 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ('joomla.application.component.controller');

class adagencyAdminControlleradagencyAds extends adagencyAdminController {
	var $_model = null;
	
	function __construct () {
		parent::__construct();
		$this->registerTask ("add", "edit");
		$this->registerTask ("", "listAds");
		$this->_model =& $this->getModel("adagencyAds");
		$this->registerTask ("unpublish", "publish");	
	}

	function listAds() {
		$this->_model->saveorder();
		$view = $this->getView("adagencyAds", "html");
		$view->setModel($this->_model, true);
		$view->display();
	}

	function edit () {
		JRequest::setVar ("hidemainmenu", 1);
		$view = $this->getView("adagencyAds", "html");
		$view->setLayout("editForm");
		$view->setModel($this->_model, true);
		$model =& $this->getModel("adagencyConfig");
		$view->setModel($model);
		$model =& $this->getModel("adagencyProduct");
		$view->setModel($model);
		$view->editForm();
	}

	function remove () {
		if (!$this->_model->delete()) {
			$msg = JText::_('AD_REMOVE_ERR');
		} else {
		 	$msg = JText::_('AD_REMOVED');
		}
		$link = "index.php?option=com_adagency&controller=adagencyAds";
		$this->setRedirect($link, $msg);
	}
	
	function publish () {
		$res = $this->_model->publish();
		if (!$res) {
			$msg = JText::_('AD_PUB_ERR');
		} elseif ($res == -1) {
		 	$msg = JText::_('AD_UNPUBLISHED');
		} elseif ($res == 1) {
			$msg = JText::_('AD_PUBLISHED');
		} else {
                 	$msg = JText::_('AD_PUB_ERR');
		}
		$link = "index.php?option=com_adagency&controller=adagencyAds";
		$this->setRedirect($link, $msg);
	}
	
	function getChannelInfo(){
		$this->_model->getChannelInfo();
		die();
	}

	function approve () {
		$res = $this->_model->approve();
		if (!$res) {
			$msg = JText::_('AD_UNPUB_ERR');
		} elseif ($res == -1) {
		 	$msg = JText::_('AD_UNPUBLISHED');
		} elseif ($res == 1) {
			$msg = JText::_('AD_PUBLISHED');
		} else {
	       	$msg = JText::_('AD_UNPUB_ERR');
		}
		$link = "index.php?option=com_adagency&controller=adagencyAds";
		$this->setRedirect($link, $msg);
	}
	
	function pending () {
		$res = $this->_model->pending();
		if($res==0){
			$msg = JText::_('ADAG_PENMSG');
		}
		$link = "index.php?option=com_adagency&controller=adagencyAds";
		$this->setRedirect($link, $msg);
	}
		
	function unapprove () {
		$res = $this->_model->unapprove();
		if (!$res) {
			$msg = JText::_('AD_UNPUB_ERR');
		} elseif ($res == -1) {
		 	$msg = JText::_('AD_UNPUBLISHED');
		} elseif ($res == 1) {
			$msg = JText::_('AD_PUBLISHED');
		} else {
 			$msg = JText::_('AD_UNPUB_ERR');
		}
		$link = "index.php?option=com_adagency&controller=adagencyAds";
		$this->setRedirect($link, $msg);
	}
	
	function saveorder(){
		$this->_model->saveorder();
		$link = "index.php?option=com_adagency&controller=adagencyAds";
		$this->setRedirect($link);
	}

	function copy () {
		$res = $this->_model->copy();
		if (!$res) {
			$msg = JText::_('AD_COPY_ERR');
		} elseif ($res == 1) {
		 	$msg = JText::_('AD_COPIED');
		}			
		$link = "index.php?option=com_adagency&controller=adagencyAds";
		$this->setRedirect($link, $msg);
	}
};
?>