 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ('joomla.application.component.controller');

class adagencyAdminControlleradagencyPlugins extends adagencyAdminController {
	var $_model = null;
	
	function __construct () {
		parent::__construct();
		$this->registerTask ("add", "edit");
		$this->registerTask ("", "listPlugins");
		$this->_model =& $this->getModel("adagencyPlugin");
		$this->registerTask ("unpublish", "publish");	
	}

	function listPlugins() {
		$view = $this->getView("adagencyPlugins", "html");
		$view->setModel($this->_model, true);
		$view->display();
	}

	function edit () {
		JRequest::setVar ("hidemainmenu", 1);
		$view = $this->getView("adagencyPlugins", "html");
		$view->setLayout("editForm");
		$view->setModel($this->_model, true);
		$model =& $this->getModel("adagencyConfig");
		$view->setModel($model);
		$view->editForm();
	}

	function save () {
		if ($this->_model->store() ) {
			$msg = JText::_('PLUGSAVED');
		} else {
			$msg = JText::_('PLUGFAILED');
		}
		$link = "index.php?option=com_adagency&controller=adagencyPlugins";
		$this->setRedirect($link, $msg);
	}

	function upload () {
		$msg = $this->_model->upload();
		$link = "index.php?option=com_adagency&controller=adagencyPlugins";
		$this->setRedirect($link, $msg);
	}

	function remove () {
		if (!$this->_model->delete()) {
			$msg = JText::_('PLUGREMERR');
		} else {
		 	$msg = JText::_('PLUGREMSUCC');
		}
		$link = "index.php?option=com_adagency&controller=adagencyPlugins";
		$this->setRedirect($link, $msg);
	}

	function cancel () {
	 	$msg = JText::_('PLUGCANCEL');
		$link = "index.php?option=com_adagency&controller=adagencyPlugins";
		$this->setRedirect($link, $msg);
	}

	function publish () {
		$res = $this->_model->publish();
		if (!$res) {
			$msg = JText::_('PLUGPUBERR');
		} elseif ($res == -1) {
		 	$msg = JText::_('PLUGUNPUB');
		} elseif ($res == 1) {
			$msg = JText::_('PLUGPUB');
		} else {
                 	$msg = JText::_('PLUGUNSPEC');
		}
		$link = "index.php?option=com_adagency&controller=adagencyPlugins";
		$this->setRedirect($link, $msg);
	}

};
?>