 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ('joomla.application.component.controller');

class adagencyAdminControlleradagencyReports extends adagencyAdminController {
	var $_model = null;
	
	function __construct () {
		parent::__construct();
		$this->registerTask ("", "listReports");
		$this->_model =& $this->getModel("adagencyReports");
	}

	function listReports() {
		$view = $this->getView("adagencyReports", "html");
		$view->setModel($this->_model, true);
		$view->display();
	}

	function edit () {
		JRequest::setVar ("hidemainmenu", 1);
		$view = $this->getView("adagencyLanguages", "html");
		$view->setLayout("editForm");
		$view->setModel($this->_model, true);
		$model =& $this->getModel("adagencyConfig");
		$view->setModel($model);
		$view->editForm();
	}
	
	function creat () { 
		$view = $this->getView("adagencyReports", "html");
		$view->setModel($this->_model, true);
		$view->display();
	}
	
	function emptyrep () { 
		if ($this->_model->emptyrep() ) {
			$msg = JText::_('ADAG_EMPTYSUC');
		} else {
			$msg = JText::_('ADAG_EMPTYFAIL');
		}
		$link = "index.php?option=com_adagency&controller=adagencyReports";
		$this->setRedirect($link, $msg);
	}

	function save () {
		if ($this->_model->store() ) {
			$msg = JText::_('LANGSAVED');
		} else {
			$msg = JText::_('LANGSAVEFAILED');
		}
		$link = "index.php?option=com_adagency&controller=adagencyLanguages";
		$this->setRedirect($link, $msg);
	}

	function upload() {
		$msg = $this->_model->upload();
		$link = "index.php?option=com_adagency&controller=adagencyLanguages";
		$this->setRedirect($link, $msg);
	}

	function remove() {
		if (!$this->_model->delete()) {
			$msg = JText::_('LANGREMERROR');
		} else {
		 	$msg = JText::_('LALNGREMSUCC');
		}
		$link = "index.php?option=com_adagency&controller=adagencyLanguages";
		$this->setRedirect($link, $msg);
	}

	function cancel() {
	 	$msg = JText::_('LANGCANCELED');	
		$link = "index.php?option=com_adagency&controller=adagencyLanguages";
		$this->setRedirect($link, $msg);
	}

    function compdata() {
        $this->_model->compdata();
        die();
    }

    function compress() {
		$view = $this->getView("adagencyReports", "html");
		$view->setLayout("compress");
        $view->compress();
    }
    
	function publish() {
		$res = $this->_model->publish();
		if (!$res) {
			$msg = JText::_('LANGPUBLICHERROR');
		} elseif ($res == -1) {
		 	$msg = JText::_('LANGUNPUBSUCC');
		} elseif ($res == 1) {
			$msg = JText::_('LANGPUBSUCC');
		} else {
                 	$msg = JText::_('LANGUNSPECERROR');
		}
		$link = "index.php?option=com_adagency&controller=adagencyLanguages";
		$this->setRedirect($link, $msg);
	}
};
?>
