<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
ini_set("memory_limit","500M");
function com_install() {

	installAlertUploadPlugins();

	$database = &JFactory::getDBO();
	$db = &JFactory::getDBO();
	$mosConfig_absolute_path = JPATH_BASE;
	$mosConfig_live_site     = JURI::base();
	$admin_path = $mosConfig_absolute_path."/administrator/components/com_adagency/";
	$user_path	= $mosConfig_absolute_path."/components/com_adagency/";
	if ( !is_dir ( $admin_path."plugins" ) ) {
	       @mkdir ( $admin_path."/plugins" );
	       @chmod ( $admin_path."/plugins", 0755 ); }
	     else {
	       @chmod ( $admin_path."/plugins", 0755 );
	    }
	@chmod ( $admin_path."/images", 0755 );
	@chmod ( $admin_path."/language", 0755 );
	@chmod ( $user_path."/images", 0755 );
	if (is_dir($mosConfig_absolute_path."/images/stories/ad_agency"))
	  @chmod ( $mosConfig_absolute_path."/images/stories/ad_agency", 0755 );
	else {
	  @mkdir ( $mosConfig_absolute_path."/images/stories/ad_agency" );
	  @chmod ( $mosConfig_absolute_path."/images/stories/ad_agency", 0755 );
	}

	/* folder */
		$imagepath = str_replace("/administrator","",JPATH_BASE);
		$imagepath = $imagepath."/images/stories/";
		//$newimgfolder = $_POST['imgfolder'];
		$newimgfolder = 'ad_agency';
		if ( !is_dir ( $imagepath.$newimgfolder ) ) {
	       @mkdir ( $imagepath.$newimgfolder );
	       @chmod ( $imagepath.$newimgfolder, 0755 ); }
	     else {
	       @chmod ( $imagepath.$newimgfolder, 0755 );
	    }
	//echo $imagepath."/".$newimgfolder."<hr />";
	/* folder */

	$database->setQuery ("UPDATE #__components SET admin_menu_img='../administrator/components/com_adagency/images/lm/adagicon.png' WHERE admin_menu_link='option=com_adagency'" );
	$database->query ();
	$sql = "SHOW columns FROM `#__ad_agency_plugins`";
	$database->setQuery($sql);
	$res_order=$database->loadResultArray();
	if(!in_array("display_name",$res_order)) {
		$sql="ALTER TABLE `#__ad_agency_plugins` ADD `display_name` VARCHAR( 20 ) NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('1');
	}
	$sql = "SHOW columns FROM `#__ad_agency_order`";
	$database->setQuery($sql);
	$res_order=$database->loadResultArray();

	$sql = "SHOW tables";
	$database->setQuery($sql);
	$res_tables=$database->loadResultArray();
	$jconfigs = new JConfig();
	$dbprefix = $jconfigs->dbprefix;
	$sqlz = NULL;
	$new_channels = false;
	$is_update = false;

	if(!in_array($dbprefix."ad_agency_channels",$res_tables)) {
		$sql = "CREATE TABLE IF NOT EXISTS `#__ad_agency_channels` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `name` varchar(100) NOT NULL,
			  `banner_id` int(11) DEFAULT '0',
			  `advertiser_id` int(11) DEFAULT '0',
			  `public` enum('Y','N') NOT NULL DEFAULT 'N',
			  `created` datetime DEFAULT NULL,
			  `created_by` int(11) DEFAULT NULL,
			  `from` enum('F','B') NOT NULL DEFAULT 'B',
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;
		";
		$new_channels = true;
		$sqlz[] = $sql;
		$database->setQuery($sql);
		$database->query();
	}

	if(!in_array($dbprefix."ad_agency_channel_sets",$res_tables)) {
		$sql = "CREATE TABLE IF NOT EXISTS `#__ad_agency_channel_set` (
			`id` int(11) NOT NULL auto_increment,
			`channel_id` int(11) NOT NULL,
			`type` varchar(25) NOT NULL,
			`logical` varchar(25) NOT NULL,
			`option` varchar(25) NOT NULL,
			`data` varchar(255) NOT NULL,
			PRIMARY KEY  (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;
		";
		$sqlz[] = $sql;
		$database->setQuery($sql);
		$database->query();
	}


	if(!in_array($dbprefix."ad_agency_package_zone",$res_tables)) {
		$sql = "CREATE TABLE `#__ad_agency_package_zone` (
		`package_id` INT( 11 ) NOT NULL ,
		`zone_id` INT( 11 ) NOT NULL ,
		PRIMARY KEY ( `package_id` , `zone_id` )
		) ENGINE = MYISAM ;
		";
		$database->setQuery($sql);
		$database->query();
	}

	$sql ="ALTER TABLE `#__ad_agency_channel_set` CHANGE `data` `data` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$sqlz[] = $sql;
	$database->setQuery($sql);
	$database->query();

	// Change of mod_adagency_zone into mod_ijoomla_adagency_zone
	$sql = "UPDATE `#__modules` SET `module` = 'mod_ijoomla_adagency_zone' WHERE `module` = 'mod_adagency_zone'";
	$database->setQuery($sql);
	$database->query();
	// end

	if(!in_array("pack_id",$res_order)) {
		$sql="ALTER TABLE `#__ad_agency_order` ADD `pack_id` ENUM( '0', '1' ) NOT NULL DEFAULT '0'";
		$database->setQuery($sql);
		if(!$database->query())
			die('2');
	}

	if(!in_array("currency",$res_order)) {
		$sql="ALTER TABLE `#__ad_agency_order` ADD `currency` VARCHAR( 50 ) NOT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('2.2');
	}

	$sql = "SHOW columns FROM `#__ad_agency_zone`";
	$database->setQuery($sql);
	$res_zone=$database->loadResultArray();
	if(!in_array("z_title",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `z_title` TEXT NOT NULL AFTER `banners` ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('3');
	}

	if(!in_array("z_ordering",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `z_ordering` INT NOT NULL DEFAULT '0' AFTER `z_title` ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('4');
	}

	if(!in_array("z_position",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `z_position` VARCHAR( 50 ) NULL DEFAULT NULL AFTER `z_ordering` ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('5');
	} else {
		 $sql = "ALTER TABLE `#__ad_agency_zone` CHANGE `z_position` `z_position` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('5.2');

	}

	$sql = "SHOW columns FROM `#__ad_agency_banners`";
	$database->setQuery($sql);
	$res_banners=$database->loadResultArray();

	if(!in_array("frequency",$res_banners)) {
		$sql="ALTER TABLE `#__ad_agency_banners` ADD `frequency` INT NULL DEFAULT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('6');
	}

	if(!in_array("channel_id",$res_banners)) {
		$sql="ALTER TABLE `#__ad_agency_banners` ADD `channel_id` INT( 11 ) NULL ";
		$database->setQuery($sql);
		if(!$database->query())
			die('6 - channel_id');
	}

	$sql = "SHOW columns FROM `#__ad_agency_advertis`";
	$database->setQuery($sql);
	$res_advertis=$database->loadResultArray();

	if(!in_array("lastreport",$res_advertis)) {
		$sql="ALTER TABLE `#__ad_agency_advertis` ADD `lastreport` BIGINT NULL DEFAULT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('7');
	}

	if(!in_array("show_title",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `show_title` TINYINT( 3 ) UNSIGNED NOT NULL DEFAULT '1';";
		$database->setQuery($sql);
		if(!$database->query())
			die('8');
	}

	if(!in_array("weekreport",$res_advertis)) {
		$sql="ALTER TABLE `#__ad_agency_advertis` ADD `weekreport` BIGINT NULL DEFAULT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('9');
	}

	if(!in_array("monthreport",$res_advertis)) {
		$sql="ALTER TABLE `#__ad_agency_advertis` ADD `monthreport` BIGINT NULL DEFAULT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('10');
	}

	if(!in_array("paywith",$res_advertis)) {
		$sql="ALTER TABLE `#__ad_agency_advertis` ADD `paywith` TEXT NOT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('11');
	}

	$sql = "SHOW columns FROM `#__ad_agency_campaign`";
	$database->setQuery($sql);
	$res_campaign=$database->loadResultArray();

	if(!in_array("exp_notice",$res_campaign)) {
		$sql="ALTER TABLE `#__ad_agency_campaign` ADD `exp_notice` INT NOT NULL DEFAULT '0'";
		$database->setQuery($sql);
		if(!$database->query())
			die('12');
	}

    if(!in_array("params",$res_campaign)) {
        $sql="ALTER TABLE `#__ad_agency_campaign` ADD `params` VARCHAR( 255 ) NULL ";
        $database->setQuery($sql);
        if(!$database->query())
            die('12+');
    }

	$sql = "SHOW columns FROM `#__ad_agency_order_type`";
	$database->setQuery($sql);
	$res_order_type=$database->loadResultArray();

	$sql = "SHOW columns FROM `#__ad_agency_campaign_banner`";
	$database->setQuery($sql);
	$res_campaign_banner=$database->loadResultArray();

	if(!in_array("thumb",$res_campaign_banner)) {
		$sql="ALTER TABLE `#__ad_agency_campaign_banner` ADD `thumb` VARCHAR( 255 ) NULL DEFAULT NULL  ";
		$database->setQuery($sql);
		if(!$database->query())
			die('*cb error*');
	}

	if(!in_array("zone",$res_campaign_banner)) {
		$sql="ALTER TABLE `#__ad_agency_campaign_banner` ADD `zone` INT( 11 ) NULL DEFAULT NULL ";
		$database->setQuery($sql);
		if(!$database->query())
			die('*cb error2*');
	}

	if(!in_array("visibility",$res_order_type)) {
		$sql="ALTER TABLE `#__ad_agency_order_type` ADD `visibility` TINYINT NOT NULL DEFAULT '1'";
		$database->setQuery($sql);
		if(!$database->query())
			die('13');
	}

	if(!in_array("location",$res_order_type)) {
		$sql="ALTER TABLE `#__ad_agency_order_type` ADD `location` INT( 11 ) NOT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('13.5');
	} else {
	// If version = 2.0.2 or 2.0.1
        $sql = "SELECT zone_id FROM #__ad_agency_package_zone LIMIT 1";
        $db->setQuery($sql);
        $rz = $db->loadResult();
        if (!$rz) {    
            $sql = "INSERT INTO #__ad_agency_package_zone
                    SELECT tid,location
                    FROM #__ad_agency_order_type
                    ";
            $db->setQuery($sql);
            $db->query();
        }
        /*
		$sql = "UPDATE `#__ad_agency_campaign_banner` AS cb
				SET `zone` = (
					SELECT pz.zone_id FROM `#__ad_agency_campaign` AS c
					LEFT JOIN `#__ad_agency_order_type` AS p
					ON c.otid = p.tid
					LEFT JOIN `#__ad_agency_package_zone` AS pz
					ON p.tid = pz.package_id
					WHERE c.id = cb.campaign_id
				)";
		$db->setQuery($sql);
		$db->query();
        */
	}

	$sql = "ALTER TABLE `#__ad_agency_order_type` CHANGE `cost` `cost` DECIMAL( 8, 2 ) NOT NULL DEFAULT '0.00'";
	$database->setQuery($sql);
	$database->query();

	//ver 1.06 add module class suffix
	if(!in_array("suffix",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `suffix` TEXT NOT NULL ";
		$database->setQuery($sql);
		if(!$database->query())
			die('14');
	}
	//ver 1.06 add user payment method
	//ver 1.06 add index for stat table
	$sql = "SHOW columns FROM `#__ad_agency_settings`";
	$database->setQuery($sql);
	$res_settings=$database->loadResultArray();

	if(!in_array("indextbl",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `indextbl` INT( 2 ) NOT NULL DEFAULT '0'";
		$database->setQuery($sql);
		if(!$database->query())
			die('15');
	}

	if(!in_array("payment",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `payment` VARCHAR( 50 ) NOT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('15.1');
	}

	if(!in_array("geoparams",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `geoparams` TEXT NOT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('15.2');
	}

	if(!in_array("captcha",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `captcha` TINYINT NOT NULL DEFAULT '0' AFTER `maxchars` ";
		$database->setQuery($sql);
		if(!$database->query())
			die('16');
	}

	if(!in_array("countryloc",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `countryloc` VARCHAR( 150 ) NOT NULL DEFAULT 'geoip/countries'";
		$database->setQuery($sql);
		if(!$database->query())
			die('16-countryloc');
	}

	if(!in_array("cityloc",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `cityloc` VARCHAR( 150 ) NOT NULL DEFAULT 'geoip/GeoLiteCity.dat'";
		$database->setQuery($sql);
		if(!$database->query())
			die('16-cityloc');
	}

	if(!in_array("codeloc",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `codeloc` VARCHAR( 150 ) NOT NULL DEFAULT 'geoip/code'";
		$database->setQuery($sql);
		if(!$database->query())
			die('16-cityloc');
	}

	//ver 1.06 add index for table stat
	if(!in_array("paywith",$res_advertis)) {
		$sql="ALTER TABLE `#__ad_agency_advertis` ADD `paywith` TEXT NOT NULL ";
		$database->setQuery($sql);
		if(!$database->query())
			die('17');
	}

	$query = "SELECT id FROM #__ad_agency_states WHERE id=1";
	$database->setQuery($query);
	if(!$database->loadResult())
		add_countries();

	$sql = "SELECT `id` FROM #__core_acl_aro_groups WHERE name='Advertiser' ";
	$database->setQuery($sql);
	$grup_advid = $database->loadResult();

	$sql = "SELECT `id` FROM #__core_acl_aro_groups WHERE name='Registered' ";
	$database->setQuery($sql);
	$grup_regid = $database->loadResult();

	if(isset($grup_advid) && $grup_advid > 0)
		{
			$sql = "UPDATE #__core_acl_groups_aro_map SET `group_id` = '".$grup_regid."' WHERE group_id='".$grup_advid."'  ";
			$database->setQuery($sql);
			$database->query();

			$sql = "UPDATE #__users SET `usertype` = 'Registered',`gid` = '".$grup_regid."' WHERE `usertype`='Advertiser' LIMIT 1";
			$database->setQuery($sql);
			$database->query();

			$sql = "DELETE FROM #__core_acl_aro_groups WHERE `id` = '".$grup_advid."' ";
			$database->setQuery($sql);
			$database->query();
		}
	// new way of creating the ADVERTISER's group - stop


	// v.1.5.3 updates - rotator + terms - start
	if(!in_array("rotatebanners",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `rotatebanners` ENUM( '0', '1' ) NOT NULL DEFAULT '0'";
		$database->setQuery($sql);
		if(!$database->query())
			die('18');
	}

	if(!in_array("rotating_time",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `rotating_time` INT NOT NULL DEFAULT '10000'";
		$database->setQuery($sql);
		if(!$database->query())
			die('19');
	}
	if(!in_array("itemid",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `itemid` INT( 10 ) NOT NULL ";
		$database->setQuery($sql);
		if(!$database->query())
			die('19.b');
	}
	if(!in_array("rotaterandomize",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `rotaterandomize` ENUM( '0', '1' ) NOT NULL DEFAULT '1'";
		$database->setQuery($sql);
		if(!$database->query())
			die('20');
	}
	if(!in_array("adparams",$res_zone)) {
		$is_update = true;
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `adparams` VARCHAR( 255 ) NOT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('20.5');
	}
	if(!in_array("textadparams",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `textadparams` VARCHAR( 255 ) NOT NULL";
		$database->setQuery($sql);
		if(!$database->query())
			die('20.51');
	}
	if(!in_array("ignorestyle",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `ignorestyle` ENUM( '0', '1' ) NOT NULL DEFAULT '0'";
		$database->setQuery($sql);
		if(!$database->query())
			die('20.6 error');
	}
	if(!in_array("askterms",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `askterms` ENUM( '0', '1' ) NOT NULL DEFAULT '0'";
		$database->setQuery($sql);
		if(!$database->query())
			die('21');
	}

	if(!in_array("termsid",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `termsid` INT NOT NULL";

		$database->setQuery($sql);
		if(!$database->query())
			die('22');
	}
	// v.1.5.3 updates - rotator + terms - stop

	// v.1.5.3 update - change the table to retain the ip - start
	$sql="ALTER TABLE `#__ad_agency_stat` CHANGE `ip_address` `ip_address` BIGINT( 15 ) NOT NULL DEFAULT '0'";
	$database->setQuery($sql);
	if(!$database->query())
			die('23');
	// v.1.5.3 update - change the table to retain the ip - stop

	// v.1.5.3 updates - zones will be saved - start
	$sql = "SHOW columns FROM `#__ad_agency_order_type`";
	$database->setQuery($sql);
	$res_order_type=$database->loadResultArray();
	if(!in_array("zones",$res_order_type)) {
		$sql="ALTER TABLE `#__ad_agency_order_type` ADD `zones` TEXT NOT NULL";
		$database->setQuery($sql);
		if(!$database->query())
		{
			//die();
		}
		$database->setQuery("UPDATE `#__ad_agency_order_type` SET `zones` = 'All Zones'");
		if(!$database->query()) {}
	}
	// v.1.5.3 updates - zones will be saved - stop

	// v.1.5.3 updates - zones_wildcard will be saved - start
	if(!in_array("zones_wildcard",$res_order_type)) {
		$sql="ALTER TABLE `#__ad_agency_order_type` ADD `zones_wildcard` TEXT NULL";
		$database->setQuery($sql);
		if(!$database->query())
		{
			//die();
		}
	}
	// v.1.5.3 updates - zones will be saved - stop

	// v.1.5.3 updates - user_agent (browser) will no longer be retained - start
	$database->setQuery("SHOW columns FROM `#__ad_agency_stat`");
	$result=$database->loadObjectList();
	$ok=1;
	for($i=0;$i<count($result);$i++){
		if($result[$i]->Field=="user_agent") $ok=0;
	}
	if($ok==0){
		$database->setQuery("ALTER TABLE `#__ad_agency_stat` DROP `user_agent`");
		if(!$database->query())
			die('24');
	}
	// v.1.5.3 updates - user_agent (browser) will no longer be retained - stop

	// v.1.5.3 updates - ordering field for packages - start
	$database->setQuery("SHOW columns FROM `#__ad_agency_order_type`");
	$result=$database->loadObjectList();
	$ok=1;
	for($i=0;$i<count($result);$i++){
		if($result[$i]->Field=="ordering") $ok=0;
	}
	if($ok==1){
		$database->setQuery("ALTER TABLE `#__ad_agency_order_type` ADD `ordering` INT( 11 ) NOT NULL DEFAULT '0' ");
		if(!$database->query())
			die('25');
	}
	// v.1.5.3 updates - ordering field for packages - stop

	// v.1.5.3 updates - added description field to packages - start
	if(!in_array("pack_description",$res_order_type)) {
		$sql="ALTER TABLE `#__ad_agency_order_type` ADD `pack_description` TEXT NOT NULL AFTER `description` ";
		$database->setQuery($sql);
		if(!$database->query())
			die('26');
	}
	// v.1.5.3 updates - added description field to packages - stop

	// CHARACTER SET utf8 COLLATE utf8_general_ci
	$sql = "ALTER TABLE `#__ad_agency_order` CHANGE `payment_type` `payment_type` VARCHAR( 20 ) NOT NULL";
	$database->setQuery($sql);
	if(!$database->query())
			die('27');

	// v.1.5.3 updates - show "advertise here" link - start
	if(!in_array("show_adv_link",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `show_adv_link` TINYINT( 1 ) NOT NULL DEFAULT '1' ";
		$database->setQuery($sql);
		if(!$database->query())
			die('28');
	}

	if(!in_array("cellpadding",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `cellpadding` INT NOT NULL DEFAULT '0' ";
		$database->setQuery($sql);
		if(!$database->query())
			die('29');
	}

	if(!in_array("link_taketo",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `link_taketo` TINYINT( 1 ) NOT NULL DEFAULT '0' ";
		$database->setQuery($sql);
		if(!$database->query())
			die('30');
	}

	if(!in_array("taketo_url",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `taketo_url` VARCHAR( 255 ) NULL DEFAULT NULL  ";
		$database->setQuery($sql);
		if(!$database->query())
			die('31');
	}
	// v.1.5.3 updates - show "advertise here" link - stop

	// v.1.5.3 updates - the ads will be displayed as ROWS+COLUMNS - start
	if(!in_array("banners_cols",$res_zone)) {
		$sql=" ALTER TABLE `#__ad_agency_zone` ADD `banners_cols` TINYINT( 2 ) NOT NULL DEFAULT '1' AFTER `banners` ";
		$database->setQuery($sql);
		if(!$database->query())
			die('32');
	}
	// v.1.5.3 updates - the ads will be displayed as ROWS+COLUMNS - stop

	// v1.6.7 updates - BEGIN

	// Set 3 states to advertisers - [P] = pending

	$db->setQuery("SHOW columns FROM `#__ad_agency_advertis` WHERE field='approved'");
	$dfa_advertis = $db->loadObject();
	if($dfa_advertis->Type != "enum('Y','N','P')") {
		$sql = "ALTER TABLE `#__ad_agency_advertis` CHANGE `approved` `approved` ENUM( 'Y', 'N', 'P' ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'P' ";
		$database->setQuery($sql);
		$database->query();
	}

	$db->setQuery("SHOW columns FROM `#__ad_agency_banners` WHERE field='approved'");
	$dfa_banners = $db->loadObject();
	if($dfa_banners->Type != "enum('N','Y','P')") {
		$sql = "ALTER TABLE `#__ad_agency_banners` CHANGE `approved` `approved` ENUM( 'N', 'Y', 'P' ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'P' ";
		$database->setQuery($sql);
		$database->query();
	}

	$db->setQuery("SHOW columns FROM `#__ad_agency_campaign` WHERE field='approved'");
	$dfa_campaign = $db->loadObject();
	if($dfa_campaign->Type != "enum('Y','N','P')") {
		$sql = " ALTER TABLE `#__ad_agency_campaign` CHANGE `approved` `approved` ENUM( 'Y', 'N', 'P' ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'P' ";
		$database->setQuery($sql);
		$database->query();
	}

	// Set "larger" number
	$sql = "ALTER TABLE `#__ad_agency_order` CHANGE `cost` `cost` DECIMAL( 10, 2 ) NOT NULL DEFAULT '0.00'";
	$database->setQuery($sql);
	$database->query();

	$sql = "ALTER TABLE `#__ad_agency_order_type` CHANGE `cost` `cost` DECIMAL( 10, 2 ) NOT NULL DEFAULT '0.00'";
	$database->setQuery($sql);
	$database->query();

	// Add fields to advertisers - BEGIN
	if(!in_array("apr_ads",$res_advertis)) {
		$sql="ALTER TABLE `#__ad_agency_advertis` ADD `apr_ads` ENUM( 'G', 'Y', 'N' ) NULL DEFAULT 'G';";
		$database->setQuery($sql);
		if(!$database->query())
			die('33');
	}
	if(!in_array("apr_cmp",$res_advertis)) {
		$sql="ALTER TABLE `#__ad_agency_advertis` ADD `apr_cmp` ENUM( 'G', 'Y', 'N' ) NULL DEFAULT 'G';";
		$database->setQuery($sql);
		if(!$database->query())
			die('34');
	}
	if(!in_array("key",$res_advertis)) {
		$sql="ALTER TABLE `#__ad_agency_advertis` ADD `key` VARCHAR( 100 ) NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('35');
	}
	// Add fields to advertisers - END

	//

	if(!in_array("showpreview",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `showpreview` TINYINT( 2 ) NOT NULL DEFAULT '1';";
		$database->setQuery($sql);
		if(!$database->query())
			die('36');
	}
	if(!in_array("show",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `show` VARCHAR( 255 ) NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('37');
	}
	if(!in_array("mandatory",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `mandatory` VARCHAR( 50 ) NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('38');
	}
	if(!in_array("params",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `params` VARCHAR( 255 ) NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('39');
	}
	if(!in_array("sbafterregaa",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `sbafterregaa` TEXT NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('40');
	}
	if(!in_array("bodyafterregaa",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `bodyafterregaa` TEXT NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('41');
	}

	if(!in_array("created",$res_banners)) {
		$sql="ALTER TABLE `#__ad_agency_banners` ADD `created` DATE NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('42');
	}
	if(!in_array("ordering",$res_banners)) {
		$sql="ALTER TABLE `#__ad_agency_banners` ADD `ordering` INT( 8 ) NOT NULL DEFAULT '0';";
		$database->setQuery($sql);
		if(!$database->query())
			die('43');
	}
	if(!in_array("keywords",$res_banners)) {
		$sql="ALTER TABLE `#__ad_agency_banners` ADD `keywords` VARCHAR( 255 ) NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('44');
	}
	if(!in_array("key",$res_banners)) {
		$sql="ALTER TABLE `#__ad_agency_banners` ADD `key` VARCHAR( 100 ) NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('45');
	}
	if(!in_array("key",$res_campaign)) {
		$sql="ALTER TABLE `#__ad_agency_campaign` ADD `key` VARCHAR( 100 ) NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('46');
	}
	if(!in_array("visibility",$res_order_type)) {
		$sql="ALTER TABLE `#__ad_agency_order_type` ADD `visibility` TINYINT( 4 ) NOT NULL DEFAULT '1';";
		$database->setQuery($sql);
		if(!$database->query())
			die('47');
	}
	if(!in_array("hide_after",$res_order_type)) {
		$sql="ALTER TABLE `#__ad_agency_order_type` ADD `hide_after` TINYINT( 2 ) NOT NULL DEFAULT '0';";
		$database->setQuery($sql);
		if(!$database->query())
			die('48');
	}
	if(!in_array("defaultad",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `defaultad` INT( 8 ) NULL ;";
		$database->setQuery($sql);
		if(!$database->query())
			die('49');
	}
	if(!in_array("keywords",$res_zone)) {
		$sql="ALTER TABLE `#__ad_agency_zone` ADD `keywords` TINYINT( 2 ) NOT NULL DEFAULT '0';";
		$database->setQuery($sql);
		if(!$database->query())
			die('50');
	}

	if(!in_array("overviewcontent",$res_settings)) {
		$sql=" ALTER TABLE `#__ad_agency_settings` ADD `overviewcontent` TEXT NOT NULL ";
		$database->setQuery($sql);
		if(!$database->query())
			die('51');
	}

	if(!in_array("limit_ip",$res_settings)) {
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `limit_ip` INT( 10 ) NOT NULL DEFAULT '100'";
		$database->setQuery($sql);
		if(!$database->query())
			die('52');
	}

	$expired_camp_adm = false;

	if(!in_array("sbcmpexpadm",$res_settings)) {
		$expired_camp_adm = true;
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `sbcmpexpadm` TEXT NOT NULL ";
		$database->setQuery($sql);
		if(!$database->query())
			die('53');
	}

	if(!in_array("bodycmpexpadm",$res_settings)) {
		$expired_camp_adm = true;
		$sql="ALTER TABLE `#__ad_agency_settings` ADD `bodycmpexpadm` TEXT NOT NULL ";
		$database->setQuery($sql);
		if(!$database->query())
			die('54');
	}

	//see if we have any settings in the settings table and add the default email settings
	$sql = "SELECT `txtafterreg` FROM `#__ad_agency_settings` LIMIT 1";
	$database->setQuery($sql);
	$textafterreg = $database->loadResult();
	if(!$textafterreg) {
		$no_setting_in_db = true;
		$config = new JConfig();
			$sql = "INSERT INTO `#__ad_agency_settings` (`id`, `lastsend`, `adminemail`, `fromemail`, `fromname`, `imgfolder`, `maxchars`, `captcha`, `allowstand`, `allowadcode`, `allowpopup`, `allowswf`, `allowtxtlink`, `allowtrans`, `allowfloat`, `txtafterreg`, `bodyafterreg`, `sbafterreg`, `bodyactivation`, `sbactivation`, `bodyrep`, `sbrep`, `bodycmpappv`, `sbcmpappv`, `bodycmpdis`, `sbcmpdis`, `bodyadappv`, `sbadappv`, `bodyaddisap`, `sbaddisap`, `bodyadvdis`, `sbadvdis`, `bodynewad`, `sbnewad`, `bodynewcmp`, `sbnewcmp`, `bodycmpex`, `sbcmpex`, `bodynewuser`, `sbnewuser`, `currencydef`, `indextbl`, `askterms`, `termsid`, `overviewcontent`, `showpreview`, `show`, `mandatory`, `params`, `sbafterregaa`, `bodyafterregaa`, `geoparams`) VALUES
(1, ".time().", '".$config->mailfrom."', '".$config->mailfrom."', 'Ad Agency', 'ad_agency', 250, 0, '1', '1', '1', '1', '1', '1', '1', '<p>Thank you {name}!<br /> <br /> Thank you for registering to our Ad Agency. Your account is pending approval. We will notify you by email when your account is approved. Please save your login information for future reference:<br /> <br /> <strong>Username</strong> - {login} <br /><strong>Password</strong> - {password}</p>', '<p>Hello {name},</p><p>We have approved your application! Now you can login to our site with the following information and manage your account, add banners, create campaigns,etc.</p><p>Username - {login}</p><p>Ad Agency Manager</p>', 'Thank you for registering at iJoomla Ad Agency', '<p>Hello {name},<br /> <br /> Thank you for registering to our Ad Agency. Your account is now pending approval. We will send you an email as soon as we approve it.<br /> <br /> Username - {login}<br /> Password - {password}</p><p>Please click the following link to activate your user account</p><p>{activate_url}</p><p>This will give you access to our site as a user, not as advertiser. When we approve your advertiser account, we will notify you via email.</p><p>Ad Agency Manager</p>', 'Thank you for registering at iJoomla Ad Agency', '<p>Dear {name},</p><p>The following is a clicks and impressions report for {daterange}</p><p>Campaign Name: {campaign}</p><p>{clicks} - Clicks total<br />{impressions} - Impressions total</p><p>{used_for_more_campaigns}</p><p>You may login to your advertiser interface for more detailed reports.</p><p><br />Thank you!<br /><br />Admin</p>', 'Subject Report', '<p>Hello {name}!</p><p>Your campaign {campaign} has been approved!</p>', 'Campaign Approved', '<p>Hello {name}!</p><p>Your campaign {campaign} has been suspended by an administrator!</p>', 'Campaign {campaign} has been suspended', '<p>Hello {name}!</p><p>Your banner {banner} been approved!</p>', '{banner}  Approved', '<p>Hello {name}!</p><p>Your banner {banner} has been dissapproved.</p><p>Possible reasons:</p><ul><li>Banner is in the wrong size </li><li>Banner is inappropriate to our needs </li><li>Banner has porn or other problems</li></ul><p>If you have any questions regarding this, please reply to this email.</p><p>Thank you,</p><p>Ad Agency Admin</p>', 'Banner {banner} has been suspended', '<p>Hello {name}!</p><p>Your advertiser account on our Ad Agency has been disapproved.</p><p>Possible reasons:</p><ul><li>We do not accept new advertisers at this point </li><li>We do not advertise your kind of products on our site</li></ul><p>If you have any questions regarding this, please reply to this email.</p><p>Thank you,</p><p>Ad Agency Admin</p>', 'Your account on iJoomla Ad Agency has been suspended', '<p>Dear Admin, <br /> <br /> A new banner/ad was added: <br /> <br /> Advertiser  Name: {name}  <br /> Company Name: {company}  <br /> Email: {email}  <br /> Phone: {phone}  <br /> Banner Name: {banner}  <br /> Banner Preview: {banner_preview_url}<br /> ------------------------------------------------ <br /> Status: {approval_status} <br /> ------------------------------------------------ <br /> <br /> To approve this ad, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{approve_banner_url}\">{approve_banner_url}</a> <br /> <br /> To decline this ad, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{decline_banner_url}\">{decline_banner_url}</a></p>', '{name} has added a banner {banner}', '<p>Dear Admin, <br /> <br /> A new campaign was added: <br /> <br /> Advertiser Name: {name} <br /> Company Name: {company} <br /> Email: {email} <br /> Phone: {phone} <br /> Campaign Name: {campaign}  <br /> Package name used to create this campaign: {package}  <br /> ------------------------------------------------ <br /> Status: {approval_status} <br /> ------------------------------------------------ <br /> <br /> To approve this campaign, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{approve_campaign_url}\">{approve_campaign_url} </a><br /> <br /> To decline this campaign, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{decline_campaign_url}\">{decline_campaign_url}</a></p>', '{name} has added a campaign {campaign}', '<p>Dear name</p><p>Campaign {campaign} has expired {expire_date}. Please click on the link below to start a new campaign with the same package:</p><p>(campaign_renew_URL}</p><p>To purchase a different package, click here:</p><p>{packages_url}</p><p>Admin</p>', 'Campaign {campaign} has expired', '<p>Dear admin, <br /> <br /> The following advertiser has signed up to your advertising program. <br /> <br /> Full Name: {name}  <br /> Email: {email}   <br /> Phone: {phone}  <br /> URL: {url} 	 <br /> Username: {username}  <br /> Company Name: {company} 	 <br /> Description: {description}  	 <br /> Street : {street}  	 <br /> Country : {country} 	 <br /> State/Province: {state}  <br /> Zip Code: {zipcode}  <br /> ---------------------------------------- <br /> Status: {approval_status}  <br /> ---------------------------------------- <br /> To approve this advertiser, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{approve_advertiser_url}\">{approve_advertiser_url}</a> <br /> <br /> To decline this advertiser, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{decline_advertiser_url}\">{decline_advertiser_url}</a></p>', '{name} has joined the Ad Agency', 'USD', 0, '0', 0, '<p>Welcome to our advertising opportunity page.</p><p>MySiteName is one of the most trafficked sites about MySiteTopic on the web. It gets well over X unique visitors a month and close to X pageviews.</p><p>How to get started</p><p>Step 1: <a href=\"index.php?option=com_adagency&amp;controller=adagencyAdvertisers&amp;task=register\">Register as an advertiser</a><br />Step 2: <a href=\"index.php?option=com_adagency&amp;controller=adagencyAds&amp;task=addbanners\">Add banners/ads</a><br />Step 3: <a href=\"index.php?option=com_adagency&amp;controller=adagencyCampaigns&amp;task=edit&amp;cid=0\">Start a campaign</a><br />Step 4: Get traffic to your site</p>
<p>{packages}</p>', 0, 'zinfo;aftercamp2;wizzard;url;phone;', '', 'a:1:{s:10:\"timeformat\";s:2:\"1\";}', 'Thank you for registering to our advertising program', '<p>Hello {name},</p><p>Thank you for registering to our Ad Agency.</p><p>Your account is now approved.</p><p>Your login information is listed below.</p><p>Username - {login}<br /> Password - {password}</p>', 'a:9:{s:14:\"allowcontinent\";s:1:\"1\";s:12:\"allowlatlong\";s:1:\"1\";s:12:\"allowcountry\";s:1:\"1\";s:2:\"c1\";s:1:\"1\";s:2:\"c2\";s:1:\"1\";s:2:\"c3\";s:1:\"1\";s:2:\"c4\";s:1:\"1\";s:2:\"c5\";s:1:\"1\";s:2:\"c6\";s:1:\"1\";}');
";
		$database->setQuery($sql);
		$database->query();
	}
	/*$sql = "UPDATE `#__ad_agency_settings` SET `bodynewad` = '<p>Dear Admin, <br /> <br /> A new banner/ad was added: <br /> <br /> Advertiser Name: {name} <br /> Company Name: {company} <br /> Email: {email} <br /> Phone: {phone} <br /> Banner Name: {banner} <br /> Banner Preview: {banner_preview_url}<br /> ------------------------------------------------ <br /> Status: {approval_status} <br /> ------------------------------------------------ <br /> <br /> To approve this ad, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{approve_banner_url}\">{approve_banner_url}</a> <br /> <br /> To decline this ad, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{decline_banner_url}\">{decline_banner_url}</a></p>',
`sbnewad` = '{name} has added a banner {banner}',`bodynewcmp` = '<p>Dear Admin, <br /> <br /> A new campaign was added: <br /> <br /> Advertiser Name: {name} <br /> Company Name: {company} <br /> Email: {email} <br /> Phone: {phone} <br /> Campaign Name: {campaign} <br /> Package name used to create this campaign: {package} <br /> ------------------------------------------------ <br /> Status: {approval_status} <br /> ------------------------------------------------ <br /> <br /> To approve this campaign, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{approve_campaign_url}\">{approve_campaign_url} </a><br /> <br /> To decline this campaign, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{decline_campaign_url}\">{decline_campaign_url}</a></p>',`bodycmpex` = '<p>Dear advertiser,</p> <p>Your campaign has expired. Please login to our site an purchase another package.</p> <p>Thank you</p> <p>Admin</p>',`bodynewuser` = '<p>Dear admin, <br /> <br /> The following advertiser has signed up to your advertising program. <br /> <br /> Full Name: {name} <br /> Email: {email} <br /> Phone: {phone} <br /> URL: {url} <br /> Username: {username} <br /> Company Name: {company} <br /> Description: {description} <br /> Street : {street} <br /> Country : {country} <br /> State/Province: {state} <br /> Zip Code: {zipcode} <br />---------------------------------------- <br /> Status: {approval_status} <br /> ---------------------------------------- <br /> To approve this advertiser, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{approve_advertiser_url}\">{approve_advertiser_url}</a><br /> <br /> To decline this advertiser, click on this URL or copy and paste it into your browser window: <br /> <br /> <a href=\"{decline_advertiser_url}\">{decline_advertiser_url}</a></p>',`sbafterregaa` = 'Thank you for registering to our advertising program',`bodyafterregaa` = '<p>Hello {name},</p> <p>Thank you for registering to our Ad Agency.</p> <p>Your account is now approved.</p> <p>Your login information is listed below.</p> <p>Username - {login}<br /> Password - {password}</p>' WHERE `id` = 1;";*/
	//echo $sql;die();
	//$database->setQuery($sql);
	//$database->query($sql);

	if(!in_array("version",$res_settings)) {
		$sql = "ALTER TABLE `#__ad_agency_settings` ADD `version` VARCHAR( 100 ) NULL DEFAULT '2.0.10' ";
		$database->setQuery($sql);
		if(!$database->query()) {
            die('54-i');
        }
        $sql = "SELECT `show` FROM `#__ad_agency_settings` LIMIT 1";
        $database->setQuery($sql);
        $shows = $database->loadResult();
        $shows .= "phone;url;";
        $sql = "UPDATE `#__ad_agency_settings` SET `show` = '{$shows}' ";
        $database->setQuery($sql);
        $database->query();
	}

	if($expired_camp_adm == true){
		$sql = "UPDATE `#__ad_agency_settings` SET `sbcmpexpadm` = 'Campaign {campaign} has expired ', `bodycmpexpadm` = '<p>Dear admin,</p><p>Campaign {campaign} of company {company} has expired {expire_date}.</p><p>Admin</p>' WHERE `id` = 1";
		$database->setQuery($sql);
		$database->query($sql);
	}

	//add the default email settings

	// 1.6.7 Check for paypal
	$sql = "SELECT id FROM #__ad_agency_plugins WHERE name='paypal' LIMIT 1";
	$database->setQuery($sql);
	$paypal = $database->loadResult();
	if(!$paypal) {
		$sql = "INSERT INTO `#__ad_agency_plugins` (`id` ,`name` ,`classname` ,`value` ,`filename` ,`type` ,`published` ,`def` ,`sandbox` ,`reqhttps` ,`display_name`) VALUES (NULL , 'paypal', 'paypal', '0', 'paypal_payment.php', 'payment', '1', 'default', '0', '0', 'PayPal');";
		$database->setQuery($sql);
		$database->query();

		$sql = "SELECT id FROM #__ad_agency_plugins ORDER BY id DESC";
		$database->setQuery($sql);
		$pluginid = $database->loadResult();

        $sql = "SELECT pluginid  FROM `#__ad_agency_plugin_settings` WHERE `setting` =  'paypal_email' ";
        $database->setQuery($sql);
        $exists_paypal = (int) $database->loadResult();
        
        if ($exists_paypal <= 0 ) {
            $sql = "INSERT INTO `#__ad_agency_plugin_settings` (`pluginid`,`setting`,`description`,`value`) 
                   VALUES ('".$pluginid."','paypal_email','email of your paypal account','');";
            $database->setQuery($sql);
            $database->query();
        }
        
		$sql = "SELECT id FROM `#__ad_agency_currencies` WHERE plugname = 'paypal' AND currency_name = 'USD' ";
		$database->setQuery($sql);
		$isCurrency = $database->loadResult();

		if(!$isCurrency) {
			$sql = "INSERT INTO `#__ad_agency_currencies` (`id`, `plugname`, `currency_name`, `currency_full`) VALUES (NULL, 'paypal', 'USD', 'U.S. Dollar'), (NULL, 'paypal', 'AUD', 'Australian Dollar'), (NULL, 'paypal', 'CAD', 'Canadian Dollar'), (NULL, 'paypal', 'CHF', 'Swiss Franc'), (NULL, 'paypal', 'CZK', 'Czech Koruna'), (NULL, 'paypal', 'DKK', 'Danish Krone'), (NULL, 'paypal', 'EUR', 'Euro'), (NULL, 'paypal', 'GBP', 'Pound Sterling'), (NULL, 'paypal', 'HKD', 'Hong Kong Dollar'), (NULL, 'paypal', 'HUF', 'Hungarian Forint'), (NULL, 'paypal', 'JPY', 'Japanese Yen'), (NULL, 'paypal', 'NOK', 'Norwegian Krone'), (NULL, 'paypal', 'NZD', 'New Zeeland Dollar'), (NULL, 'paypal', 'PLN', 'Polish Zloty'), (NULL, 'paypal', 'SEK', 'Swedish Krona'), (NULL, 'paypal', 'SGD', 'Singapore Dollar'), (NULL, 'paypal', 'ZAR', 'South African Rand');";
			$database->setQuery($sql);
			$database->query();
		}
	}
	//

	// Check for zones
	$sql = "SELECT * FROM #__ad_agency_zone";
	$database->setQuery($sql);
	$isZone = $database->loadResult();

	$sql = "SELECT * FROM #__ad_agency_advertis";
	$database->setQuery($sql);
	$isAdvert = $database->loadResult();

	$sql = "SELECT * FROM #__ad_agency_banners";
	$database->setQuery($sql);
	$isAd = $database->loadResult();

	$sql = "SELECT * FROM #__ad_agency_campaign";
	$database->setQuery($sql);
	$isCamp = $database->loadResult();

	if(($isZone == NULL)&&($isAdvert == NULL)&&($isAd == NULL)&&($isCamp == NULL)&&(isset($no_setting_in_db))) {
	//if((!$isZone)&&(!$isAdvert)&&(!$isAd)&&(!$isCamp)) {
		// Add the default advertiser if no advertiser - BEGIN
		$sql = "SELECT id FROM #__users WHERE username = 'ijoomla' ";
		$database->setQuery($sql);
		$existingUID = $database->loadResult();
		$ok = true;
		if(!$existingUID) {
			// if the user doesn't exist then we create it
			$acl =& JFactory::getACL();
			jimport('joomla.application.component.helper');
			$usersParams = &JComponentHelper::getParams( 'com_users' );
			$user = JFactory::getUser(0);
			$data = array();
		    $usertype = 'Registered';
			$data['name'] = 'iJoomla';
			$data['username'] = 'ijoomla';
			$data['email'] = 'demo@ijoomla.com';
			$data['gid'] = 18;
			$password = random_password();
			$data['password'] = $password;
			$data['password2'] = $password;
			$data['sendEmail'] = 0;
			$data['block'] = 0;
			if (!$user->bind($data)) { $ok = false;	}
			if (!$user->save()) { $ok = false; }
			$sql = "SELECT id FROM #__users WHERE username = 'ijoomla' ";
			$database->setQuery($sql);
			$existingUID = $database->loadResult($sql);
		}
		if($existingUID) {
			$sql = "INSERT INTO `#__ad_agency_advertis` (`aid`, `user_id`, `company`, `description`, `website`, `address`, `country`, `city`, `state`, `zip`, `telephone`, `fax`, `logo`, `email_daily_report`, `email_weekly_report`, `email_month_report`, `email_campaign_expiration`, `approved`, `lastreport`, `weekreport`, `monthreport`, `paywith`, `apr_ads`, `apr_cmp`, `key`) VALUES
(1, ".$existingUID.", '', NULL, 'http://ijoomla.com', NULL, NULL, NULL, NULL, NULL, '000000000', '10', NULL, 'N', 'N', 'N', 'N', 'Y', 1274390867, 1274390867, 1274390867, '', 'N', 'G', '');
";
			$database->setQuery($sql);
			$database->query();
		}
		// Add the default advertiser if no advertiser - END

		// Add the default zones if there is no zone - BEGIN
		if($ok) {
			$sql = "INSERT INTO `#__modules` (`title`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `published`, `module`, `numnews`, `access`, `showtitle`, `params`, `iscore`, `client_id`, `control`) VALUES ('Left Zone', '', 0, 'left', 0, '0000-00-00 00:00:00', 1, 'mod_ijoomla_adagency_zone', 0, 0, 1, 'moduleclass_sfx=', 0, 0, ''), ('Right Zone', '', 0, 'right', 0, '0000-00-00 00:00:00', 1, 'mod_ijoomla_adagency_zone', 0, 0, 1, 'moduleclass_sfx=', 0, 0, ''), ('Floating, Transitions, Popups', '', 0, 'footer', 0, '0000-00-00 00:00:00', 1, 'mod_ijoomla_adagency_zone', 0, 0, 0, 'moduleclass_sfx=', 0, 0, '');";
			$database->setQuery($sql);
			if(!$database->query()) {$ok = false;}
		}

		$sql = "SELECT id FROM `#__modules` WHERE title = 'Left Zone' and module = 'mod_ijoomla_adagency_zone' ";
		$database->setQuery($sql);
		$leftZoneId = $database->loadResult();
		if($leftZoneId){
			$sql = "INSERT INTO `#__ad_agency_zone` (`zoneid`, `banners`, `banners_cols`, `z_title`, `z_ordering`, `z_position`, `show_title`, `suffix`, `rotatebanners`, `rotating_time`, `rotaterandomize`, `show_adv_link`, `cellpadding`, `link_taketo`, `taketo_url`, `itemid`, `defaultad`, `keywords`, `adparams`, `ignorestyle`, `textadparams`) VALUES (".$leftZoneId.", 1, 1, 'Left Zone', 0, 'left', 1, 'moduleclass_sfx=', '0', 10000, '1', 0, 1, 3, 'http://', 0, 0, 0, 'a:3:{s:5:\"width\";s:3:\"125\";s:6:\"height\";s:3:\"125\";s:6:\"textad\";s:1:\"1\";}', '', 'a:6:{s:6:\"mxsize\";s:2:\"50\";s:6:\"mxtype\";s:1:\"w\";s:2:\"ia\";s:1:\"l\";s:8:\"wrap_img\";s:1:\"1\";s:5:\"width\";s:3:\"125\";s:6:\"height\";s:3:\"125\";}');";
			$database->setQuery($sql);
			$database->query();
			// Assign module to all pages
			$sql = "INSERT INTO `#__modules_menu` (`moduleid` ,`menuid`) VALUES ('".$leftZoneId."', '0');";
			$database->setQuery($sql);
			if(!$database->query()) {$ok = false;}
		}

		$sql = "SELECT id FROM `#__modules` WHERE title = 'Right Zone' and module = 'mod_ijoomla_adagency_zone' ";
		$database->setQuery($sql);
		$rightZoneId = $database->loadResult();
		if($rightZoneId){
			$sql = "INSERT INTO `#__ad_agency_zone` (`zoneid`, `banners`, `banners_cols`, `z_title`, `z_ordering`, `z_position`, `show_title`, `suffix`, `rotatebanners`, `rotating_time`, `rotaterandomize`, `show_adv_link`, `cellpadding`, `link_taketo`, `taketo_url`, `itemid`, `defaultad`, `keywords`, `adparams`, `ignorestyle`, `textadparams`) VALUES (".$rightZoneId.", 2, 1, 'Right Zone', 0, 'right', 1, 'moduleclass_sfx=', '0', 10000, '1', 1, 1, 3, 'http://', 0, 0, 0, 'a:5:{s:8:\"standard\";s:1:\"1\";s:9:\"affiliate\";s:1:\"1\";s:5:\"flash\";s:1:\"1\";s:5:\"width\";s:3:\"125\";s:6:\"height\";s:3:\"125\";}', '', '');
";
			$database->setQuery($sql);
			$database->query();
			// Assign module to all pages
			$sql = "INSERT INTO `#__modules_menu` (`moduleid` ,`menuid`) VALUES ('".$rightZoneId."', '0');";
			$database->setQuery($sql);
			if(!$database->query()) {$ok = false;}

		}

		$sql = "SELECT id FROM `#__modules` WHERE title = 'Floating, Transitions, Popups' and module = 'mod_ijoomla_adagency_zone' ";
		$database->setQuery($sql);
		$floatingZoneId = $database->loadResult();
		if($leftZoneId){
			$sql = "INSERT INTO `#__ad_agency_zone` (`zoneid`, `banners`, `banners_cols`, `z_title`, `z_ordering`, `z_position`, `show_title`, `suffix`, `rotatebanners`, `rotating_time`, `rotaterandomize`, `show_adv_link`, `cellpadding`, `link_taketo`, `taketo_url`, `itemid`, `defaultad`, `keywords`, `adparams`, `ignorestyle`, `textadparams`) VALUES (".$floatingZoneId.", 1, 1, 'Floating, Transitions, Popups', 0, 'footer', 0, 'moduleclass_sfx=', '0', 10000, '1', 0, 1, 3, 'http://', 0, 0, 0, 'a:5:{s:5:\"popup\";s:1:\"1\";s:10:\"transition\";s:1:\"1\";s:8:\"floating\";s:1:\"1\";s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";}', '', 'a:2:{s:5:\"width\";s:0:\"\";s:6:\"height\";s:0:\"\";}');";
			$database->setQuery($sql);
			$database->query();
			// Assign module to all pages
			$sql = "INSERT INTO `#__modules_menu` (`moduleid` ,`menuid`) VALUES ('".$floatingZoneId."', '0');";
			$database->setQuery($sql);
			if(!$database->query()) {$ok = false;}
		}

		// Add the default zones if there is no zone - END

		// Add the default banners if there are none - BEGIN
		if(($leftZoneId)&&($rightZoneId)){
			$sql = "INSERT INTO `#__ad_agency_banners` (`id`, `advertiser_id`, `title`, `description`, `media_type`, `image_url`, `swf_url`, `target_url`, `width`, `height`, `ad_code`, `use_ad_code_in_netscape`, `ad_code_netscape`, `parameters`, `approved`, `zone`, `frequency`, `created`, `ordering`, `keywords`, `key`, `channel_id`) VALUES (1, 1, 'iJoomla SEO', '', 'Advanced', NULL, NULL, NULL, 125, 125, '<a href=\"ad_url\" target=\"_blank\"><img border=\"0\" src=\"http://www.iJoomla.com/aff/banners/125x125seo.gif\" width=\"125\" height=\"125\" alt=\"seo\"></a>', 'N', NULL, 'a:1:{s:9:\"linktrack\";s:6:\"ad_url\";}', 'Y', 0, NULL, '2010-11-24', 3, '', '', -1),(2, 1, 'iJoomla SEO', '', 'TextLink', '', NULL, 'http://seo.ijoomla.com/', 150, 150, NULL, 'N', NULL, 'a:22:{s:11:\"font_family\";s:0:\"\";s:9:\"font_size\";s:2:\"14\";s:11:\"title_color\";s:6:\"0066CC\";s:11:\"font_weight\";s:18:\"lighter underlined\";s:8:\"alt_text\";s:67:\"Become a search engine magnet with this amazing Joomla Extension ! \";s:10:\"alt_text_t\";s:11:\"iJoomla SEO\";s:10:\"alt_text_a\";s:13:\"Learn More >>\";s:13:\"font_family_b\";s:0:\"\";s:11:\"font_size_b\";s:2:\"12\";s:10:\"body_color\";s:6:\"000000\";s:13:\"font_weight_b\";s:6:\"normal\";s:13:\"font_family_a\";s:0:\"\";s:11:\"font_size_a\";s:2:\"12\";s:12:\"action_color\";s:6:\"0066CC\";s:13:\"font_weight_a\";s:18:\"lighter underlined\";s:6:\"border\";s:1:\"0\";s:7:\"padding\";s:1:\"0\";s:12:\"border_color\";s:6:\"000000\";s:8:\"bg_color\";s:6:\"FFFFFF\";s:5:\"align\";s:4:\"left\";s:13:\"target_window\";s:6:\"_blank\";s:7:\"img_alt\";s:24:\"http://seo2.ijoomla.com/\";}', 'Y', 0, NULL, '2010-11-24', 0, '', '', -1),(3, 1, 'iJoomla Surveys', '', 'Advanced', NULL, NULL, NULL, 125, 125, '<a href=\"ad_url\" target=\"_blank\"><img border=\"0\" src=\"http://www.iJoomla.com/aff/banners/120x120last.gif\" width=\"125\" height=\"125\" alt=\"\"></a>', 'N', NULL, 'a:2:{s:13:\"target_window\";s:6:\"_blank\";s:9:\"linktrack\";s:38:\"http://www.iJoomla.com/139-5-1-15.html\";}', 'Y', 0, NULL, '2010-11-24', 2, '', '', -1),
(4, 1, 'iJoomla News Portal', '', 'Advanced', NULL, NULL, NULL, 125, 125, '<a href=\"ad_url\" target=\"_blank\"><img border=\"0\" src=\"http://www.iJoomla.com/aff/banners/120x120news.gif\" width=\"125\" height=\"125\" alt=\"\"></a>', 'N', NULL, 'a:2:{s:13:\"target_window\";s:6:\"_blank\";s:9:\"linktrack\";s:38:\"http://www.iJoomla.com/139-6-1-23.html\";}', 'Y', 0, NULL, '2010-11-24', 1, '', '', -1);
";
			$database->setQuery($sql);
			$database->query();
		}
		// Add the default banners if there are none - END

		// Add the default packages if there are none - BEGIN
		$sql = "INSERT INTO `#__ad_agency_order_type` (`tid`, `description`, `pack_description`, `quantity`, `type`, `cost`, `validity`, `sid`, `published`, `visibility`, `zones`, `zones_wildcard`, `ordering`, `hide_after`, `location`) VALUES
(1, '1000 Impressions', 'Try our advertising system with 1000 free impressions!', 1000, 'cpm', 0.00, '', 0, 1, 1, '', NULL, 3, 1, ".$leftZoneId."),
(2, '1 Month', 'One month of advertising on our right position', 0, 'fr', 49.99, '1|month', 0, 1, 1, '', NULL, 2, 0, ".$leftZoneId."),
(3, 'Internal Package - Right zone', 'This package is for internal use, it''s invisible on front end.', 0, 'fr', 0.00, '10|year', 0, 1, 0, '', NULL, 1, 0, ".$rightZoneId."),
(4, '100 Clicks', '100 clicks on our text ads on the left zone.', 100, 'pc', 99.99, '', 0, 1, 1, '', NULL, 4, 0, ".$leftZoneId."),
(5, 'Internal Package - Left zone', 'This is for internal use, invisible on the front end.', 0, 'fr', 0.00, '10|year', 0, 1, 0, '', NULL, 1, 0, ".$leftZoneId.");";
		$database->setQuery($sql);
		if(!$database->query()) {$ok = false;}
		// Add the default packages if there are none - END

		// Add the default campaign if there is none - BEGIN
		$sql = "INSERT INTO `#__ad_agency_campaign` (`id`, `aid`, `name`, `notes`, `default`, `start_date`, `type`, `quantity`, `validity`, `cost`, `otid`, `approved`, `status`, `exp_notice`, `key`) VALUES (1, 1, 'Right zone internal campaign', '', 'Y', '2010-11-23 00:00:00', 'fr', 0, '2020-11-23 00:00:00', 0.00, 3, 'Y', 1, 0, NULL), (2, 1, 'Left zone internal campaign', '', 'Y', '2010-11-24 00:00:00', 'fr', 0, '2020-11-24 00:00:00', 0.00, 5, 'Y', 1, 0, NULL); ";
		$database->setQuery($sql);
		if(!$database->query()) {$ok = false;}
		// Set banners to campaigns - BEGIN
		if($ok){
			$sql = "INSERT INTO `#__ad_agency_campaign_banner` (`campaign_id`, `banner_id`, `relative_weighting`, `thumb`) VALUES
					(1, 1, 100, NULL),
					(1, 3, 100, NULL),
					(1, 4, 100, NULL),
					(2, 2, 100, NULL);
					";
			$database->setQuery($sql);
			if(!$database->query()) {$ok = false;}
		}
		// Set banners to campaigns - END

		// Add the default campaign if there is none - END

		// Update to 2.0.3
        $sql = "SELECT zone_id FROM #__ad_agency_package_zone LIMIT 1";
        $db->setQuery($sql);
        $rz = $db->loadResult();
        if (!$rz) {
            $sql = "INSERT INTO #__ad_agency_package_zone
                    SELECT tid,location
                    FROM #__ad_agency_order_type
                    ";
            $db->setQuery($sql);
            $db->query();
        }
		$sql = "UPDATE `#__ad_agency_campaign_banner` AS cb
				SET `zone` = (
					SELECT pz.zone_id FROM `#__ad_agency_campaign` AS c
					LEFT JOIN `#__ad_agency_order_type` AS p
					ON c.otid = p.tid
					LEFT JOIN `#__ad_agency_package_zone` AS pz
					ON p.tid = pz.package_id
					WHERE c.id = cb.campaign_id
				)";
		$db->setQuery($sql);
		$db->query();
		// - end update 2.0.3
	}

	$sql = "SELECT aid,user_id FROM #__ad_agency_advertis ORDER BY aid ASC LIMIT 1";
	$database->setQuery($sql);
	$first_adv = $database->loadObject();

    $sql = "SELECT `id` FROM `#__ad_agency_channels` LIMIT 1 ";
    $db->setQuery($sql);    
    $is_channels = (int)$db->loadResult();
    
	// Add channels - BEGIN
	if( ($is_channels == 0) && ( ($new_channels) || (!$is_update) ) && isset($first_adv) && ($first_adv != NULL) ) {
		$sql = "INSERT INTO `#__ad_agency_channels` (`id`, `name`, `banner_id`, `advertiser_id`, `public`, `created`, `created_by`, `from`) VALUES
		(1, 'United States', 0, '".$first_adv->aid."', 'Y', '2010-11-26 00:00:00', ".$first_adv->user_id.", 'B'),
		(2, 'Europe', 0, '".$first_adv->aid."', 'Y', '2010-11-26 00:00:00', ".$first_adv->user_id.", 'B'),
		(3, 'California', 0, '".$first_adv->aid."', 'Y', '2010-11-26 00:00:00', ".$first_adv->user_id.", 'B'),
		(4, 'San Diego and Los Angeles', 0, '".$first_adv->aid."', 'Y', '2010-11-26 00:00:00', ".$first_adv->user_id.", 'B'),
		(5, 'Beverly Hills', 0, '".$first_adv->aid."', 'Y', '2010-11-26 00:00:00', ".$first_adv->user_id.", 'B'),
		(6, 'Germany', 0, '".$first_adv->aid."', 'Y', '2010-11-26 00:00:00', ".$first_adv->user_id.", 'B');";

		$database->setQuery($sql);
		$database->query();

		$sql = "INSERT INTO `#__ad_agency_channel_set` (`id`, `channel_id`, `type`, `logical`, `option`, `data`) VALUES
		(1, 1, 'country', 'AND', 'is', '[\"US\"]'),
		(2, 2, 'continent', 'AND', 'is', '[\"EU\"]'),
		(3, 3, 'region', 'AND', 'is', '[\"US\",\"CA\"]'),
		(4, 4, 'dma', 'AND', '==', '[\"825\",\"803\"]'),
		(5, 5, 'postalcode', 'AND', '==', '[\"90210\"]'),
		(6, 6, 'country', 'AND', 'is', '[\"DE\"]');";

		$database->setQuery($sql);
		$database->query();

		$sql = "ALTER TABLE `#__ad_agency_settings` CHANGE `countryloc` `countryloc` VARCHAR( 150 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'geoip/countries'";
		$database->setQuery($sql);
		$database->query();

		$sql = "UPDATE `#__ad_agency_settings` SET `countryloc` = 'geoip/countries'";
		$database->setQuery($sql);
		$database->query();

		/*$sql ="UPDATE `#__ad_agency_settings` SET `geoparams` = 'a:9:{s:14:\"allowcontinent\";s:1:\"1\";s:12:\"allowlatlong\";s:1:\"1\";s:12:\"allowcountry\";s:1:\"1\";s:2:\"c1\";s:1:\"1\";s:2:\"c2\";s:1:\"1\";s:2:\"c3\";s:1:\"1\";s:2:\"c4\";s:1:\"1\";s:2:\"c5\";s:1:\"1\";s:2:\"c6\";s:1:\"1\";}'";
		$database->setQuery($sql);
		$database->query();*/
	}

	// Add channels - END

	// v.1.6.7 updates - END
	jimport('joomla.filesystem.archive');

		$component = array();
		$modulezone = array();
		$modulemenu = array();
		$component['installed'] = $modulezone['installed'] = $modulemenu['installed'] = 0;
		$component['name'] = 'iJoomla Ad Agency';
		$component['file'] = JPATH_SITE. DIRECTORY_SEPARATOR ."administrator". DIRECTORY_SEPARATOR ."components". DIRECTORY_SEPARATOR ."com_adagency". DIRECTORY_SEPARATOR ."adagency.xml";

		$modulezone['name'] = 'Ad Agency Zone';
		$modulezone['file'] = JPATH_SITE. DIRECTORY_SEPARATOR ."modules". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_zone". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_zone.xml";
		$modulezone['php'] = JPATH_SITE. DIRECTORY_SEPARATOR ."modules". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_zone". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_zone.php";

		$modulemenu['name'] = 'Ad Agency Menu';
		$modulemenu['file'] = JPATH_SITE. DIRECTORY_SEPARATOR ."modules". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_menu". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_menu.xml";
		$modulemenu['php'] = JPATH_SITE. DIRECTORY_SEPARATOR ."modules". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_menu". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_menu.php";

		if ( file_exists($modulezone['file']) && file_exists($modulezone['php']) ){
			$modulezone['installed'] = 1;
			$data = implode ("", file ( $modulezone['file'] ) );
	        $pos1 = strpos ($data,"<version>");
	        $pos2 = strpos ($data,"</version>");
	        $modulezone['version'] = 'version '.substr ($data, $pos1+strlen("<version>"), $pos2-$pos1-strlen("<version>"));

		}

		if ( file_exists($modulemenu['file']) && file_exists($modulemenu['php']) ){
			$modulemenu['installed'] = 1;
			$data = implode ("", file ( $modulemenu['file'] ) );
	        $pos1 = strpos ($data,"<version>");
	        $pos2 = strpos ($data,"</version>");
	        $modulemenu['version'] = 'version '.substr ($data, $pos1+strlen("<version>"), $pos2-$pos1-strlen("<version>"));

		}

	$nr = 1;
	if($is_update) {
		$_updater = $nr.". <a href='index.php?option=com_adagency&controller=adagencyUpgrade'>Please continue the upgrade of Ad Agency here.</a><br />";
		$_updater2 = NULL;//"<h2>Watch this: How to upgrade to version 2.0</h2><iframe src=\"http://player.vimeo.com/video/17354129\" width=\"700\" height=\"393\" frameborder=\"0\"></iframe><p />";
		$nr++;
	} else {
		$_updater = NULL;
		$_updater2 = NULL;
	}

	if($modulemenu['installed']) {
		$adagency_menu = NULL;
	} else {
		$adagency_menu = $nr.". <span style='color:#FF0000;'>Install menu module (mod_ijoomla_adagency_menu_x.zip)</span><br />";
		$nr++;
	}

	if($modulezone['installed']) {
		$adagency_zone = NULL;
	} else {
		$adagency_zone = $nr.". <span style='color:#FF0000;'>Install the zone module (mod_ijoomla_adagency_zone_x.zip)</span><br />";
		$nr++;
	}

    // Insert Itemid part
    if(!isset($db)) {
        $db = &JFactory::getDBO();
    }
    $sql = "SELECT id FROM #__menu_types WHERE `menutype` = 'adagency' ";
    $db->setQuery($sql);
    $res = $db->loadResult();

    $sql = "SELECT id FROM #__components WHERE `link` = 'option=com_adagency' ";
    $db->setQuery($sql);
    $componentid = $db->loadResult();

    if($res == NULL) {
        $sql = "INSERT INTO `#__menu_types` (`menutype`, `title`, `description`) VALUES ('adagency', 'Ad Agency', 'Ad Agency Advertiser Menu');";
        $db->setQuery($sql);
        $db->query();

        $sql = "INSERT INTO `#__menu` (`menutype`, `name`, `alias`, `link`, `type`, `published`, `parent`, `componentid`, `sublevel`, `ordering`, `checked_out`, `checked_out_time`, `pollid`, `browserNav`, `access`, `utaccess`, `params`, `lft`, `rgt`, `home`) VALUES
        ('adagency', 'Control Panel', 'control-panel', 'index.php?option=com_adagency&view=adagencycpanel', 'component', 1, 0, {$componentid}, 0, 1, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
        ('adagency', 'My profile', 'my-profile', 'index.php?option=com_adagency&view=adagencyadvertisers&layout=editform', 'component', 1, 0, {$componentid}, 0, 2, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
        ('adagency', 'Ads', 'ads', 'index.php?option=com_adagency&view=adagencyads', 'component', 1, 0, {$componentid}, 0, 3, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
        ('adagency', 'Campaigns', 'campaigns', 'index.php?option=com_adagency&view=adagencycampaigns', 'component', 1, 0, {$componentid}, 0, 4, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
        ('adagency', 'Reports', 'reports', 'index.php?option=com_adagency&view=adagencyreports', 'component', 1, 0, {$componentid}, 0, 5, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
        ('adagency', 'Packages', 'packages', 'index.php?option=com_adagency&view=adagencypackage', 'component', 1, 0, {$componentid}, 0, 6, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
        ('adagency', 'My Orders', 'my-orders', 'index.php?option=com_adagency&view=adagencyorders', 'component', 1, 0, {$componentid}, 0, 7, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0),
        ('adagency', 'Overview', 'overview', 'index.php?option=com_adagency&view=adagencyadvertisers&layout=overview', 'component', 1, 0, {$componentid}, 0, 8, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'page_title=\nshow_page_title=1\npageclass_sfx=\nmenu_image=-1\nsecure=0\n\n', 0, 0, 0);
        ";
        $db->setQuery($sql);
        $db->query();

        $sql = "INSERT INTO `#__modules` (`title`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `published`, `module`, `numnews`, `access`, `showtitle`, `params`, `iscore`, `client_id`, `control`) VALUES
        ('Ad Agency', '', 2, 'left', 0, '0000-00-00 00:00:00', 0, 'mod_mainmenu', 0, 0, 1, 'menutype=adagency\nmenu_style=list\nstartLevel=0\nendLevel=0\nshowAllChildren=0\nwindow_open=\nshow_whitespace=0\ncache=1\ntag_id=\nclass_sfx=\nmoduleclass_sfx=_menu\nmaxdepth=10\nmenu_images=0\nmenu_images_align=0\nmenu_images_link=0\nexpand_menu=0\nactivate_parent=0\nfull_active_id=0\nindent_image=0\nindent_image1=\nindent_image2=\nindent_image3=\nindent_image4=\nindent_image5=\nindent_image6=\nspacer=\nend_spacer=\n\n', 0, 0, '');";
        $db->setQuery($sql);
        $db->query();

        $sql = "SELECT id FROM `#__modules` ORDER BY id DESC LIMIT 1";
        $db->setQuery($sql);
        $module_id_adagency = $db->loadResult();

        $sql = "INSERT INTO `#__modules_menu` (`moduleid` ,`menuid`) VALUES ('" . $module_id_adagency . "', '0');";
        $db->setQuery($sql);
        $db->query();
    } else {
        $sql = "UPDATE `jos_menu` SET `componentid` ='" . $componentid . "' WHERE `menutype` = 'adagency'";
        $db->setQuery($sql);
        $db->query();
    }
    // *********** END ITEMID PART ********************

	$adagency_component = "<span style='color: #009966;font-weight:bold;'>Installed</span>";

	$ttable = "<table><tr><td align='right'>Component:</td><td>".$adagency_component."</td></tr><tr><td align='right'>PayPal payment plugin:</td><td><span style='color:#009966;font-weight:bold;'>Installed</span></td></tr></table>";
	if(($adagency_menu != NULL)||(($adagency_zone != NULL))) { $installed = $adagency_menu.$adagency_zone; } else {$installed = NULL;}
	echo "<div style='font-size:12px;margin:10px;'><img src=\"components/com_adagency/images/logo_top.gif\"/><p />Thanks for installing the iJoomla Ad Agency component.. <p /><span style='text-decoration:underline;font-weight: bold;'>Status:</span><p />".$ttable."<p /><span style='text-decoration:underline;font-weight: bold;'>Next step(s):</span><p />".$_updater.$installed.$nr.". Go to Ad Agency -> Payment plugins, open the PayPal plugin and enter your PayPal email there.</div>".$_updater2;

	//return true;

}

function installAlertUploadPlugins(){
	$db =& JFactory::getDBO();
	$sql = "SELECT COUNT(*) FROM #__plugins WHERE element='ijoomlaupdate'";
    $db->setQuery($sql);
	$db->query();
    $count = $db->loadResult();

    if($count <= 0){
       $query = "INSERT INTO `#__plugins` (`name`, `element`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `params`)"
        ."\n VALUES ('iJoomla Upgrade Alert', 'ijoomlaupdate', 'system', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', 'lastcheck=2011-05-06')";
        $db->setQuery($query);
        $db->query();
    }

	$sql = "SELECT count(*) FROM #__plugins WHERE element='ijoomlanews'";
    $db->setQuery($sql);
	$db->query();
    $count = $db->loadResult();

    if($count <= 0){
       $query = "INSERT INTO `#__plugins` (`name`, `element`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `params`)"
        ."\n VALUES ('iJoomla News', 'ijoomlanews', 'system', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', 'nr_articles=5\ntext_length=500\nimage_width=50\n')";
        $db->setQuery($query);
        $db->query();
    }
	$component_dir = JPATH_SITE.'/administrator/components/com_adagency/plugins';
	//----------------------------------------start news plugin
	$news_dir = JPATH_SITE.'/plugins/system';
	if(!is_dir($news_dir)){
		mkdir($news_dir, 0755);
	}
	$news_php = 'ijoomlanews.php';
	$news_xml = 'ijoomlanews.xml';
	$news_folder = 'ijoomlanews';
	@chmod($news_dir, 0755);
	if(!copy($component_dir."/ijoomlanews/".$news_xml, $news_dir."/".$news_xml)){
        echo 'Error copying ijoomlanews.xml'."<br/>";
    }
	if(!copy($component_dir."/ijoomlanews/".$news_php, $news_dir."/".$news_php)){
        echo 'Error copying ijoomlanews.php'."<br/>";
    }
	if(!is_dir($news_dir."/".$news_folder)){
		mkdir($news_dir."/".$news_folder, 0755);
	}
	if(!copy($component_dir."/ijoomlanews/".$news_folder."/feed.php", $news_dir."/".$news_folder."/feed.php")){
        echo 'Error copying feed.php'."<br/>";
    }
	if(!copy($component_dir."/ijoomlanews/".$news_folder."/tabs.php", $news_dir."/".$news_folder."/tabs.php")){
        echo 'Error copying tabs.php'."<br/>";
    }
	if(!copy($component_dir."/ijoomlanews/".$news_folder."/index.html", $news_dir."/".$news_folder."/index.html")){
        echo 'Error copying index.html'."<br/>";
    }
	@chmod($component_dir.'/ijoomlanews/'.$news_php, 0755);
    @chmod($component_dir.'/ijoomlanews/'.$news_xml, 0755);
	@chmod($component_dir.'/ijoomlanews/'.$news_folder, 0755);
	if(!unlink($component_dir.'/ijoomlanews/'.$news_php)){
        echo 'Cannot delete '.$component_dir.'/ijoomlanews/'.$news_php."<br/>";
	}
	if(!unlink($component_dir.'/ijoomlanews/'.$news_xml)){
        echo 'Cannot delete '.$component_dir.'/ijoomlanews/'.$news_xml."<br/>";
	}
	//----------------------------------------stop news plugin

	//----------------------------------------start upgrade plugin
	$update_dir = JPATH_SITE.'/plugins/system';
	if(!is_dir($update_dir)){
		mkdir($update_dir, 0755);
	}
	$update_php = 'ijoomlaupdate.php';
	$update_xml = 'ijoomlaupdate.xml';
	$update_folder = 'ijoomlaupdate';
	@chmod($update_dir, 0755);
	if(!copy($component_dir."/ijoomlaupdate/".$update_xml, $update_dir."/".$update_xml)){
        echo 'Error copying ijoomlaupdate.xml'."<br/>";
    }
	if(!copy($component_dir."/ijoomlaupdate/".$update_php, $update_dir."/".$update_php)){
        echo 'Error copying ijoomlaupdate.php'."<br/>";
    }
	if(!is_dir($update_dir."/".$update_folder)){
		mkdir($update_dir."/".$update_folder, 0755);
	}
	if(!copy($component_dir."/ijoomlaupdate/".$update_folder."/editversions.php", $update_dir."/".$update_folder."/editversions.php")){
        echo 'Error copying editversions.php'."<br/>";
    }
	if(!copy($component_dir."/ijoomlaupdate/".$update_folder."/ijoomla.gif", $update_dir."/".$update_folder."/ijoomla.gif")){
        echo 'Error copying ijoomla.gif'."<br/>";
    }
	if(!copy($component_dir."/ijoomlaupdate/".$update_folder."/logo.png", $update_dir."/".$update_folder."/logo.png")){
        echo 'Error copying logo.png'."<br/>";
    }
	if(!copy($component_dir."/ijoomlaupdate/".$update_folder."/index.html", $update_dir."/".$update_folder."/index.html")){
        echo 'Error copying index.html'."<br/>";
    }
	@chmod($component_dir.'/ijoomlaupdate/'.$update_php, 0755);
    @chmod($component_dir.'/ijoomlaupdate/'.$update_xml, 0755);
	@chmod($component_dir.'/ijoomlaupdate/'.$update_folder, 0755);
	if(!unlink($component_dir.'/ijoomlaupdate/'.$update_php)){
        echo 'Cannot delete '.$component_dir.'/ijoomlaupdate/'.$update_php."<br/>";
	}
	if(!unlink($component_dir.'/ijoomlaupdate/'.$update_xml)){
        echo 'Cannot delete '.$component_dir.'/ijoomlaupdate/'.$update_xml."<br/>";
	}
	//----------------------------------------stop upgrade plugin
}

function random_password(){
	//generate a random password
	$pass = "";
	$salt = "abchefghjkmnpqrstuvwxyz0123456789";
	srand((double)microtime()*1000000);
	$i = 0;
	while ($i <= 7) {
		$num = rand() % 33;
		$tmp = substr($salt, $num, 1);
		$pass = $pass . $tmp;
		$i++;
	}
	return $pass;
}

function add_countries() {
	$database = JFactory::getDBO();
	$sql = "INSERT INTO `#__ad_agency_states` (`id`, `state`, `country`) VALUES
			(1, 'Afghanistan', 'Afghanistan'),
			(2, 'Algeria', 'Algeria'),
			(3, 'American-Samoa', 'American-Samoa'),
			(4, 'Andorra', 'Andorra'),
			(5, 'Angola', 'Angola'),
			(6, 'Anguilla', 'Anguilla'),
			(7, 'Antigua-and-Barbuda', 'Antigua-and-Barbuda'),
			(8, 'Argentina', 'Argentina'),
			(9, 'Armenia', 'Armenia'),
			(10, 'Ascension-Island', 'Ascension-Island'),
			(11, 'Australian Capital Territory', 'Australia'),
			(12, 'Christmas Island', 'Australia'),
			(13, 'New South Wales', 'Australia'),
			(14, 'Northern Territory', 'Australia'),
			(15, 'Queensland', 'Australia'),
			(16, 'South Australia', 'Australia'),
			(17, 'Tasmania', 'Australia'),
			(18, 'Victoria', 'Australia'),
			(19, 'Western Australia', 'Australia'),
			(20, 'Austria', 'Austria'),
			(21, 'Azerbaijan', 'Azerbaijan'),
			(22, 'Bahamas', 'Bahamas'),
			(23, 'Bahrain', 'Bahrain'),
			(24, 'Bangladesh', 'Bangladesh'),
			(25, 'Barbados', 'Barbados'),
			(26, 'Belarus', 'Belarus'),
			(27, 'Belgium', 'Belgium'),
			(28, 'Belize', 'Belize'),
			(29, 'Benin', 'Benin'),
			(30, 'Bermuda', 'Bermuda'),
			(31, 'Bhutan', 'Bhutan'),
			(32, 'Bolivia', 'Bolivia'),
			(33, 'Bosnia-and-Herzegovina', 'Bosnia-and-Herzegovina'),
			(34, 'Botswana', 'Botswana'),
			(35, 'Brazil', 'Brazil'),
			(36, 'Sergipe', 'Brazil'),
			(37, 'British-Indian-Ocean-Territory', 'British-Indian-Ocean-Territory'),
			(38, 'Brunei-Darussalam', 'Brunei-Darussalam'),
			(39, 'Bulgaria', 'Bulgaria'),
			(40, 'Burkina-Faso', 'Burkina-Faso'),
			(41, 'Burundi', 'Burundi'),
			(42, 'Camaroon', 'Camaroon'),
			(43, 'Cambodia', 'Cambodia'),
			(44, 'Cameroon', 'Cameroon'),
			(45, 'Alberta', 'Canada'),
			(46, 'British Columbia', 'Canada'),
			(47, 'Manitoba', 'Canada'),
			(48, 'New Brunswick', 'Canada'),
			(49, 'Newfoundland', 'Canada'),
			(50, 'Northwest Territories', 'Canada'),
			(51, 'Nova Scotia', 'Canada'),
			(52, 'Nunavut', 'Canada'),
			(53, 'Ontario', 'Canada'),
			(54, 'Prince Edward Island', 'Canada'),
			(55, 'Quebec', 'Canada'),
			(56, 'Saskatchewan', 'Canada'),
			(57, 'Yukon', 'Canada'),
			(58, 'Cape-Verde', 'Cape-Verde'),
			(59, 'Cayman-Islands', 'Cayman-Islands'),
			(60, 'Central-African-Republic', 'Central-African-Republic'),
			(61, 'Chad', 'Chad'),
			(62, 'Chile', 'Chile'),
			(63, 'Anhui', 'China'),
			(64, 'Beijing', 'China'),
			(65, 'China', 'China'),
			(66, 'Fujian', 'China'),
			(67, 'Gansu', 'China'),
			(68, 'Guangdong', 'China'),
			(69, 'Guangxi', 'China'),
			(70, 'Guizhou', 'China'),
			(71, 'Hebei', 'China'),
			(72, 'Heilongjiang', 'China'),
			(73, 'Henan', 'China'),
			(74, 'Hong-Kong', 'China'),
			(75, 'Hubei', 'China'),
			(76, 'Hunan', 'China'),
			(77, 'Jiangsu', 'China'),
			(78, 'Jiangxi', 'China'),
			(79, 'Jilin', 'China'),
			(80, 'Liaoning', 'China'),
			(81, 'Macau', 'China'),
			(82, 'Nei Mongol', 'China'),
			(83, 'Ningxia', 'China'),
			(84, 'Quinghai', 'China'),
			(85, 'Shaanxi', 'China'),
			(86, 'Shandong', 'China'),
			(87, 'Shanghai', 'China'),
			(88, 'Shanxi', 'China'),
			(89, 'Sichuan', 'China'),
			(90, 'Taiwan', 'China'),
			(91, 'Tianjin', 'China'),
			(92, 'Xinjiang', 'China'),
			(93, 'Xizang', 'China'),
			(94, 'Yunnan', 'China'),
			(95, 'Zhejiang', 'China'),
			(96, 'Colombia', 'Colombia'),
			(97, 'Comoros', 'Comoros'),
			(98, 'Congo', 'Congo'),
			(99, 'Aitutaki', 'Cook-Islands'),
			(100, 'Atiu', 'Cook-Islands'),
			(101, 'Mangaia', 'Cook-Islands'),
			(102, 'Manuae', 'Cook-Islands'),
			(103, 'Mauke', 'Cook-Islands'),
			(104, 'Mitiaro', 'Cook-Islands'),
			(105, 'Palmerston', 'Cook-Islands'),
			(106, 'Rarotonga', 'Cook-Islands'),
			(107, 'Suwarrow', 'Cook-Islands'),
			(108, 'Tatutea', 'Cook-Islands'),
			(109, 'Costa-Rica', 'Costa-Rica'),
			(110, 'Cote-D-Ivoire', 'Cote-D-Ivoire'),
			(111, 'Croatia', 'Croatia'),
			(112, 'Cuba', 'Cuba'),
			(113, 'Cyprus', 'Cyprus'),
			(114, 'Czech-Republic', 'Czech-Republic'),
			(115, 'Denmark', 'Denmark'),
			(116, 'Djibouti', 'Djibouti'),
			(117, 'Dominica', 'Dominica'),
			(118, 'Dominican-Republic', 'Dominican-Republic'),
			(119, 'Ecuador', 'Ecuador'),
			(120, 'Egypt', 'Egypt'),
			(121, 'El-Salvador', 'El-Salvador'),
			(122, 'Equatorial-Guinea', 'Equatorial-Guinea'),
			(123, 'Eritrea', 'Eritrea'),
			(124, 'Estonia', 'Estonia'),
			(125, 'Ethiopia', 'Ethiopia'),
			(126, 'Falkland-Islands', 'Falkland-Islands'),
			(127, 'Faroe-Islands', 'Faroe-Islands'),
			(128, 'Federated-States-of-Micronesia', 'Federated-States-of-Micronesia'),
			(129, 'Kandavu', 'Fiji'),
			(130, 'Lau Group', 'Fiji'),
			(131, 'Ono-I-Lau', 'Fiji'),
			(132, 'Rotuma', 'Fiji'),
			(133, 'Taveuni', 'Fiji'),
			(134, 'Vanua Levu', 'Fiji'),
			(135, 'Vanua Mbalavu', 'Fiji'),
			(136, 'Vita Levu', 'Fiji'),
			(137, 'Finland', 'Finland'),
			(138, 'Hame', 'Finland'),
			(139, 'France', 'France'),
			(140, 'French-Guiana', 'French-Guiana'),
			(141, 'Ahunui Island', 'French-Polynesia'),
			(142, 'Amanu Island', 'French-Polynesia'),
			(143, 'Anaa Island', 'French-Polynesia'),
			(144, 'Bellingshausen Island', 'French-Polynesia'),
			(145, 'Bora-Bora Island', 'French-Polynesia'),
			(146, 'Fakarava Island', 'French-Polynesia'),
			(147, 'Hao Island', 'French-Polynesia'),
			(148, 'Haraiki Island', 'French-Polynesia'),
			(149, 'Hikueru Island', 'French-Polynesia'),
			(150, 'Hiva Oa Island', 'French-Polynesia'),
			(151, 'Kaukura Island', 'French-Polynesia'),
			(152, 'Makatea Island', 'French-Polynesia'),
			(153, 'Makemo Island', 'French-Polynesia'),
			(154, 'Manuhangi Island', 'French-Polynesia'),
			(155, 'Maria Island', 'French-Polynesia'),
			(156, 'Marutea Island', 'French-Polynesia'),
			(157, 'Mataiva Island', 'French-Polynesia'),
			(158, 'Mehetia Island', 'French-Polynesia'),
			(159, 'Moorea Island', 'French-Polynesia'),
			(160, 'Mopelia Island', 'French-Polynesia'),
			(161, 'Nengonengo Island', 'French-Polynesia'),
			(162, 'Raevavae Island', 'French-Polynesia'),
			(163, 'Raiatea Island', 'French-Polynesia'),
			(164, 'Rapa Island', 'French-Polynesia'),
			(165, 'Raraka Island', 'French-Polynesia'),
			(166, 'Raroia Island', 'French-Polynesia'),
			(167, 'Ravahere Island', 'French-Polynesia'),
			(168, 'Rimatara Island', 'French-Polynesia'),
			(169, 'Rurutu Island', 'French-Polynesia'),
			(170, 'Scilly Island', 'French-Polynesia'),
			(171, 'Tahaa Island', 'French-Polynesia'),
			(172, 'Tahiti Island', 'French-Polynesia'),
			(173, 'Tahuata Island', 'French-Polynesia'),
			(174, 'Takapoto Island', 'French-Polynesia'),
			(175, 'Tematangi Island', 'French-Polynesia'),
			(176, 'Tetiaroa Island', 'French-Polynesia'),
			(177, 'Tikei Island', 'French-Polynesia'),
			(178, 'Vanavana Island', 'French-Polynesia'),
			(179, 'Gabon', 'Gabon'),
			(180, 'Georgia', 'Georgia'),
			(181, 'Bayern', 'Germany'),
			(182, 'Brandenburg', 'Germany'),
			(183, 'Bremen', 'Germany'),
			(184, 'Germany', 'Germany'),
			(185, 'Nordrhein-Westfalen', 'Germany'),
			(186, 'Rheinland-Pfalz', 'Germany'),
			(187, 'Sachsen', 'Germany'),
			(188, 'Sachsen-Anhalt', 'Germany'),
			(189, 'Thuringen', 'Germany'),
			(190, 'Ghana', 'Ghana'),
			(191, 'Gibralter', 'Gibralter'),
			(192, 'Greece', 'Greece'),

			(193, 'Greenland', 'Greenland'),
			(194, 'Grenada', 'Grenada'),
			(195, 'Guadeloupe', 'Guadeloupe'),
			(196, 'Guam', 'Guam'),
			(197, 'Guatemala', 'Guatemala'),
			(198, 'Guinea', 'Guinea'),
			(199, 'Guinea-Bissau', 'Guinea-Bissau'),
			(200, 'Guyana', 'Guyana'),
			(201, 'Haiti', 'Haiti'),
			(202, 'Honduras', 'Honduras'),
			(203, 'Hong-Kong', 'Hong-Kong'),
			(204, 'Hungary', 'Hungary'),
			(205, 'Iceland', 'Iceland'),
			(206, 'Bass', 'Ilots'),
			(207, 'de Gdansk (Danzig)', 'Ind. before 1939'),
			(208, 'Andhra Pradesh', 'India'),
			(209, 'Delhi', 'India'),
			(210, 'Gujarat', 'India'),
			(211, 'Haryana', 'India'),
			(212, 'India', 'India'),
			(213, 'Karnataka', 'India'),
			(214, 'Kerala', 'India'),
			(215, 'Madhya Pradesh', 'India'),
			(216, 'Maharashtra', 'India'),
			(217, 'Orissa', 'India'),
			(218, 'Punjab', 'India'),
			(219, 'Rajastan', 'India'),
			(220, 'Tamil Nadu', 'India'),
			(221, 'Uttar Pradesh', 'India'),
			(222, 'West Bengal', 'India'),
			(223, 'Bali', 'Indonesia'),
			(224, 'Bangka', 'Indonesia'),
			(225, 'Belitung', 'Indonesia'),
			(226, 'Borneo (Kalimantan)', 'Indonesia'),
			(227, 'Buru', 'Indonesia'),
			(228, 'Flores', 'Indonesia'),
			(229, 'Halmahera', 'Indonesia'),
			(230, 'Indonesia', 'Indonesia'),
			(231, 'Jawa (Java)', 'Indonesia'),
			(232, 'Kabaena', 'Indonesia'),
			(233, 'Kepulauan Alor (Pulau Alor)', 'Indonesia'),
			(234, 'Kepulauan Anambas', 'Indonesia'),
			(235, 'Kepulauan Aru', 'Indonesia'),
			(236, 'Kepulauan Banda', 'Indonesia'),
			(237, 'Kepulauan Banggai', 'Indonesia'),
			(238, 'Kepulauan Batu', 'Indonesia'),
			(239, 'Kepulauan Bowokan', 'Indonesia'),
			(240, 'Kepulauan Bunguran Selatan', 'Indonesia'),
			(241, 'Kepulauan Bunguran Utara', 'Indonesia'),
			(242, 'Kepulauan Kai', 'Indonesia'),
			(243, 'Kepulauan Kangean', 'Indonesia'),
			(244, 'Kepulauan Leti', 'Indonesia'),
			(245, 'Kepulauan Lingga', 'Indonesia'),
			(246, 'Kepulauan Mentawai', 'Indonesia'),
			(247, 'Kepulauan Sangihe', 'Indonesia'),
			(248, 'Kepulauan Schouten', 'Indonesia'),
			(249, 'Kepulauan Tanimbar', 'Indonesia'),
			(250, 'Kepulauan Togian', 'Indonesia'),
			(251, 'Kepulauan Tukangbesi', 'Indonesia'),
			(252, 'Lombok', 'Indonesia'),
			(253, 'Madura', 'Indonesia'),
			(254, 'Maluku', 'Indonesia'),
			(255, 'Muna', 'Indonesia'),
			(256, 'New Guinea (Irian Jaya)', 'Indonesia'),
			(257, 'Pulau Babar', 'Indonesia'),
			(258, 'Pulau Bacan', 'Indonesia'),
			(259, 'Pulau Bawean', 'Indonesia'),
			(260, 'Pulau Bengkalis', 'Indonesia'),
			(261, 'Pulau Bintan', 'Indonesia'),
			(262, 'Pulau Butung', 'Indonesia'),
			(263, 'Pulau Damar', 'Indonesia'),
			(264, 'Pulau Enggano', 'Indonesia'),
			(265, 'Pulau Kalao', 'Indonesia'),
			(266, 'Pulau Kundur', 'Indonesia'),
			(267, 'Pulau Laut', 'Indonesia'),
			(268, 'Pulau Lomblen', 'Indonesia'),
			(269, 'Pulau Misool', 'Indonesia'),
			(270, 'Pulau Nias', 'Indonesia'),
			(271, 'Pulau Obi', 'Indonesia'),
			(272, 'Pulau Padang', 'Indonesia'),
			(273, 'Pulau Pantar', 'Indonesia'),
			(274, 'Pulau Rangsang', 'Indonesia'),
			(275, 'Pulau Rupat', 'Indonesia'),
			(276, 'Pulau Sebangka', 'Indonesia'),
			(277, 'Pulau Seleyar (Salayar)', 'Indonesia'),
			(278, 'Pulau Siberut', 'Indonesia'),
			(279, 'Pulau Simeulue', 'Indonesia'),
			(280, 'Pulau Singkep', 'Indonesia'),
			(281, 'Pulau Tanahjampea', 'Indonesia'),
			(282, 'Pulau Tebingtinggi', 'Indonesia'),
			(283, 'Pulau Waigeo', 'Indonesia'),
			(284, 'Pulau Wowoni', 'Indonesia'),
			(285, 'Pulau Yapen', 'Indonesia'),
			(286, 'Salawati', 'Indonesia'),
			(287, 'Seram (Ceram)', 'Indonesia'),
			(288, 'Sulawesi (Celebes)', 'Indonesia'),
			(289, 'Sumatera (Sumatra)', 'Indonesia'),
			(290, 'Sumba', 'Indonesia'),
			(291, 'Sumbawa', 'Indonesia'),
			(292, 'Timor (Timur)', 'Indonesia'),
			(293, 'Iran', 'Iran'),
			(294, 'Iraq', 'Iraq'),
			(295, 'Ireland', 'Ireland'),
			(296, 'Isle-of-Man', 'Isle-of-Man'),
			(297, 'Golan Heights', 'Israel'),
			(298, 'Israel', 'Israel'),
			(299, 'Italy', 'Italy'),
			(300, 'Jamaica', 'Jamaica'),
			(301, 'Japan', 'Japan'),
			(302, 'Mie', 'Japan'),
			(303, 'Shizuoka', 'Japan'),
			(304, 'Toyama', 'Japan'),
			(305, 'Jordan', 'Jordan'),
			(306, 'Kazakhstan', 'Kazakhstan'),
			(307, 'Kenya', 'Kenya'),
			(308, 'Abemama Island', 'Kiribati'),
			(309, 'Arorae Island', 'Kiribati'),
			(310, 'Banaba Island', 'Kiribati'),
			(311, 'Beru Island', 'Kiribati'),
			(312, 'Birnie Island', 'Kiribati'),
			(313, 'Canton Island', 'Kiribati'),
			(314, 'Caroline Atoll', 'Kiribati'),
			(315, 'Christmas Island', 'Kiribati'),
			(316, 'Enderbury Island', 'Kiribati'),
			(317, 'Fanning Island', 'Kiribati'),
			(318, 'Filippo Reef', 'Kiribati'),
			(319, 'Flint Island', 'Kiribati'),
			(320, 'Gardner Island', 'Kiribati'),
			(321, 'Hull Island', 'Kiribati'),
			(322, 'Kiritimati(Christmas) Is', 'Kiribati'),
			(323, 'Kuria Island', 'Kiribati'),
			(324, 'Makin Island', 'Kiribati'),
			(325, 'Malden Island', 'Kiribati'),
			(326, 'Merlin Seamount', 'Kiribati'),
			(327, 'Nikunau Island', 'Kiribati'),
			(328, 'Nonouti Island', 'Kiribati'),
			(329, 'Onotoa Island', 'Kiribati'),
			(330, 'Phoenix Island', 'Kiribati'),
			(331, 'Starbuck Island', 'Kiribati'),
			(332, 'Sydney Island', 'Kiribati'),
			(333, 'Tabiteuea Island', 'Kiribati'),
			(334, 'Tamana Island', 'Kiribati'),
			(335, 'Tapeteuea Island', 'Kiribati'),
			(336, 'Tarawa Island', 'Kiribati'),
			(337, 'Vostok Island', 'Kiribati'),
			(338, 'Washington Island', 'Kiribati'),
			(339, 'Korea-(Peoples-Republic-of)', 'Korea-(Peoples-Republic-of)'),
			(340, 'Korea-(Republic-of)', 'Korea-(Republic-of)'),
			(341, 'Kuwait', 'Kuwait'),
			(342, 'Kyrgyzstan', 'Kyrgyzstan'),
			(343, 'Laos', 'Laos'),
			(344, 'Latvia', 'Latvia'),
			(345, 'Lebanon', 'Lebanon'),
			(346, 'Lesotho', 'Lesotho'),
			(347, 'Liberia', 'Liberia'),
			(348, 'Libya', 'Libya'),
			(349, 'Liechtenstein', 'Liechtenstein'),
			(350, 'Lithuania', 'Lithuania'),
			(351, 'Luxembourg', 'Luxembourg'),
			(352, 'Macau', 'Macau'),
			(353, 'Macedonia', 'Macedonia'),
			(354, 'Madagascar', 'Madagascar'),
			(355, 'Malawi', 'Malawi'),
			(356, 'Labuan', 'Malaysia'),
			(357, 'Malaya', 'Malaysia'),
			(358, 'Malaysia', 'Malaysia'),
			(359, 'Sarawak', 'Malaysia'),
			(360, 'Maldives', 'Maldives'),
			(361, 'Mali', 'Mali'),
			(362, 'Malta', 'Malta'),
			(363, 'Marshall-Islands', 'Marshall-Islands'),
			(364, 'Martinique', 'Martinique'),
			(365, 'Mauritius', 'Mauritius'),
			(366, 'Mayotte', 'Mayotte'),
			(367, 'Aguascalientes', 'Mexico'),
			(368, 'Baja California Norte', 'Mexico'),
			(369, 'Baja California Sur', 'Mexico'),
			(370, 'Campeche', 'Mexico'),
			(371, 'Chiapas', 'Mexico'),
			(372, 'Chihuahua', 'Mexico'),
			(373, 'Coahuila', 'Mexico'),
			(374, 'Coalima', 'Mexico'),
			(375, 'District Federal', 'Mexico'),
			(376, 'Durango', 'Mexico'),
			(377, 'Guanajuato', 'Mexico'),
			(378, 'Guerrero', 'Mexico'),
			(379, 'Hidalgo', 'Mexico'),
			(380, 'Jalisco', 'Mexico'),
			(381, 'Mexico', 'Mexico'),
			(382, 'Morelos', 'Mexico'),
			(383, 'Nayarit', 'Mexico'),
			(384, 'Oaxaca', 'Mexico'),
			(385, 'Puebla', 'Mexico'),
			(386, 'Quintana Roo', 'Mexico'),
			(387, 'Sinaloa', 'Mexico'),
			(388, 'Sonora', 'Mexico'),
			(389, 'Tabasco', 'Mexico'),
			(390, 'Tamaulipas', 'Mexico'),
			(391, 'Tlaxcala', 'Mexico'),
			(392, 'Veracruz', 'Mexico'),
			(393, 'Yucatan', 'Mexico'),
			(394, 'Zacatecas', 'Mexico'),
			(395, 'Moldavia', 'Moldavia'),
			(396, 'Monaco', 'Monaco'),
			(397, 'Mongolia', 'Mongolia'),
			(398, 'Montenegro', 'Montenegro'),
			(399, 'Montserrat', 'Montserrat'),
			(400, 'Morocco', 'Morocco'),
			(401, 'Sidi Ifni (since 1969)', 'Morocco'),
			(402, 'Spanish Morocco', 'Morocco'),
			(403, 'Tangier (since 1956)', 'Morocco'),
			(404, 'Mozambique', 'Mozambique'),
			(405, 'Myanmar', 'Myanmar'),
			(406, 'Namibia', 'Namibia'),
			(407, 'Nauru', 'Nauru'),
			(408, 'Nepal', 'Nepal'),
			(409, 'Netherlands', 'Netherlands'),
			(410, 'Aruba Island', 'Netherlands-Antilles'),
			(411, 'Bonaire Island', 'Netherlands-Antilles'),
			(412, 'Cura ao Island', 'Netherlands-Antilles'),
			(413, 'Saba Island', 'Netherlands-Antilles'),
			(414, 'Sint Maarten Island', 'Netherlands-Antilles'),
			(415, 'Hunter Island', 'New-Caledonia'),
			(416, 'New Caledonia Island', 'New-Caledonia'),
			(417, 'New-Caledonia', 'New-Caledonia'),
			(418, 'Arapawa Island', 'New-Zealand'),
			(419, 'Campbell Island', 'New-Zealand'),
			(420, 'New-Zealand', 'New-Zealand'),
			(421, 'Nicaragua', 'Nicaragua'),
			(422, 'Niger', 'Niger'),
			(423, 'Nigeria', 'Nigeria'),
			(424, 'Niue', 'Niue'),
			(425, 'Norfolk-Island', 'Norfolk-Island'),
			(426, 'Northern-Mariana-Islands', 'Northern-Mariana-Islands'),
			(427, 'Aker-Shus', 'Norway'),
			(428, 'Norway', 'Norway'),
			(429, 'Oman', 'Oman'),
			(430, 'Baluchistan', 'Pakistan'),
			(431, 'Nothern Areas', 'Pakistan'),
			(432, 'Pakistan', 'Pakistan'),
			(433, 'Palau', 'Palau'),
			(434, 'Panama', 'Panama'),
			(435, 'Bismark Islands', 'Papua-New-Guinea'),
			(436, 'Bougainville', 'Papua-New-Guinea'),
			(437, 'd Entrecasteaux Islands', 'Papua-New-Guinea'),
			(438, 'Feni Islands', 'Papua-New-Guinea'),
			(439, 'Green Islands', 'Papua-New-Guinea'),
			(440, 'Hermit Islands', 'Papua-New-Guinea'),
			(441, 'Kaniet Islands', 'Papua-New-Guinea'),
			(442, 'Lihir Islands', 'Papua-New-Guinea'),
			(443, 'Louisiade Islands', 'Papua-New-Guinea'),
			(444, 'Manus Island', 'Papua-New-Guinea'),
			(445, 'Mussau Island', 'Papua-New-Guinea'),
			(446, 'New Britain', 'Papua-New-Guinea'),
			(447, 'New Guinea', 'Papua-New-Guinea'),
			(448, 'New Hanover Island', 'Papua-New-Guinea'),
			(449, 'New Ireland', 'Papua-New-Guinea'),
			(450, 'Ninigo Islands', 'Papua-New-Guinea'),
			(451, 'Nuguria Islands', 'Papua-New-Guinea'),
			(452, 'Nukumanu Islands', 'Papua-New-Guinea'),
			(453, 'Rossel Island', 'Papua-New-Guinea'),
			(454, 'Tabar Islands', 'Papua-New-Guinea'),
			(455, 'Tagula Island', 'Papua-New-Guinea'),
			(456, 'Tanga Islands', 'Papua-New-Guinea'),
			(457, 'Tauu Islands', 'Papua-New-Guinea'),
			(458, 'Trobriand Island', 'Papua-New-Guinea'),
			(459, 'Woodlark Island', 'Papua-New-Guinea'),
			(460, 'Wuvulu Island', 'Papua-New-Guinea'),
			(461, 'Paraguay', 'Paraguay'),
			(462, 'Peru', 'Peru'),
			(463, 'Philippines', 'Philippines'),
			(464, 'Pitcairn', 'Pitcairn'),
			(465, 'Austrian before 1918', 'Poland'),
			(466, 'German (Prussian) before 1918', 'Poland'),
			(467, 'German (Prussian) before 1944', 'Poland'),
			(468, 'Poland', 'Poland'),
			(469, 'Azores', 'Portugal'),
			(470, 'Madeira Islands', 'Portugal'),
			(471, 'Mainland Portugal', 'Portugal'),
			(472, 'Portugal', 'Portugal'),
			(473, 'Puerto-Rico', 'Puerto-Rico'),
			(474, 'Qatar', 'Qatar'),
			(475, 'Reunion', 'Reunion'),
			(476, 'Romania', 'Romania'),
			(477, 'Asian RSFSR', 'Russian-Federation'),
			(478, 'European RSFSR', 'Russian-Federation'),
			(479, 'Kaliningrad area', 'Russian-Federation'),
			(480, 'Komandorskije Ostrova', 'Russian-Federation'),
			(481, 'Kuril Islands', 'Russian-Federation'),
			(482, 'Novaja Zeml area', 'Russian-Federation'),
			(483, 'Novosibirskije Ostrova', 'Russian-Federation'),
			(484, 'Ostrov Sachalin', 'Russian-Federation'),
			(485, 'Russian-Federation', 'Russian-Federation'),
			(486, 'Severnaja Zeml area', 'Russian-Federation'),
			(487, 'Rwanda', 'Rwanda'),
			(488, 'Bequia Island', 'Saint-Vincent-and-the-Grenadin'),
			(489, 'Canouan Island', 'Saint-Vincent-and-the-Grenadin'),
			(490, 'Carriacou Island', 'Saint-Vincent-and-the-Grenadin'),
			(491, 'Saint Vincent Island', 'Saint-Vincent-and-the-Grenadin'),
			(492, 'San-Marino', 'San-Marino'),
			(493, 'Sao-Tome-and-Principe', 'Sao-Tome-and-Principe'),
			(494, 'Saudi-Arabia', 'Saudi-Arabia'),
			(495, 'Senegal', 'Senegal'),
			(496, 'Serbia', 'Serbia'),
			(497, 'Seychelles', 'Seychelles'),
			(498, 'Sierra-Leone', 'Sierra-Leone'),
			(499, 'Singapore', 'Singapore'),
			(500, 'Slovakia', 'Slovakia'),

			(501, 'Slovenia', 'Slovenia'),
			(502, 'Choiseul', 'Solomon-Islands'),
			(503, 'Guadalcanal', 'Solomon-Islands'),
			(504, 'Malaita', 'Solomon-Islands'),
			(505, 'New Georgia', 'Solomon-Islands'),
			(506, 'San Cristobal', 'Solomon-Islands'),
			(507, 'Santa Isabel', 'Solomon-Islands'),
			(508, 'Somalia', 'Somalia'),
			(509, 'Eastern Cape', 'South-Africa'),
			(510, 'Kwazulu-Natal', 'South-Africa'),
			(511, 'Mpumalanga', 'South-Africa'),
			(512, 'South-Africa', 'South-Africa'),
			(513, 'South-Georgia', 'South-Georgia'),
			(514, 'Balearic Islands', 'Spain'),
			(515, 'Canary Islands', 'Spain'),
			(516, 'Mainland', 'Spain'),
			(517, 'Spain', 'Spain'),
			(518, 'Spanish Morocco', 'Spain'),
			(519, 'Sri-Lanka', 'Sri-Lanka'),
			(520, 'St.-Kitts-and-Nevis', 'St.-Kitts-and-Nevis'),
			(521, 'St.-Lucia', 'St.-Lucia'),
			(522, 'St.-Pierre-and-Miquelon', 'St.-Pierre-and-Miquelon'),
			(523, 'Sudan', 'Sudan'),
			(524, 'Suriname', 'Suriname'),
			(525, 'Swaziland', 'Swaziland'),
			(526, 'Sweden', 'Sweden'),
			(527, 'Switzerland', 'Switzerland'),
			(528, 'Syrian-Arab-Republic', 'Syrian-Arab-Republic'),
			(529, 'Taiwan', 'Taiwan'),
			(530, 'Tajikistan', 'Tajikistan'),
			(531, 'Tanzania', 'Tanzania'),
			(532, 'Thailand', 'Thailand'),
			(533, 'The-Gambia', 'The-Gambia'),
			(534, 'Togo', 'Togo'),
			(535, 'Tokelau', 'Tokelau'),
			(536, 'Ata Island', 'Tonga'),
			(537, 'Eua Island', 'Tonga'),
			(538, 'Tafahi Island', 'Tonga'),
			(539, 'Toku Island', 'Tonga'),
			(540, 'Tongatapu Islands', 'Tonga'),
			(541, 'Vava u Islands', 'Tonga'),
			(542, 'Tobago', 'Trinidad-and-Tobago'),
			(543, 'Trinidad', 'Trinidad-and-Tobago'),
			(544, 'Trinidad-and-Tobago', 'Trinidad-and-Tobago'),
			(545, 'Tunisia', 'Tunisia'),
			(546, 'Asian', 'Turkey'),
			(547, 'European', 'Turkey'),
			(548, 'Turkey', 'Turkey'),
			(549, 'Turkmenistan', 'Turkmenistan'),
			(550, 'Turks-and-Caicos-Islands', 'Turks-and-Caicos-Islands'),
			(551, 'Tuvalu', 'Tuvalu'),
			(552, 'Uganda', 'Uganda'),
			(553, 'Ukraine', 'Ukraine'),
			(554, 'United-Arab-Emirates', 'United-Arab-Emirates'),
			(555, 'England', 'United-Kingdom'),
			(556, 'Essex', 'United-Kingdom'),
			(557, 'Guernsey', 'United-Kingdom'),
			(558, 'Isle of Man', 'United-Kingdom'),
			(559, 'Jersey', 'United-Kingdom'),
			(560, 'Northern-Ireland', 'United-Kingdom'),
			(561, 'Scotland', 'United-Kingdom'),
			(562, 'Wales', 'United-Kingdom'),
			(563, 'Alabama', 'United-States'),
			(564, 'Alaska', 'United-States'),
			(565, 'Arizona', 'United-States'),
			(566, 'Arkansas', 'United-States'),
			(567, 'California', 'United-States'),
			(568, 'Colorado', 'United-States'),
			(569, 'Connecticut', 'United-States'),
			(570, 'Delaware', 'United-States'),
			(571, 'District of Columbia', 'United-States'),
			(572, 'Florida', 'United-States'),
			(573, 'Georgia', 'United-States'),
			(574, 'Hawaii', 'United-States'),
			(575, 'Idaho', 'United-States'),
			(576, 'Illinois', 'United-States'),
			(577, 'InRoss', 'United-States'),
			(578, 'Iowa', 'United-States'),
			(579, 'Kansas', 'United-States'),
			(580, 'Kentucky', 'United-States'),
			(581, 'Louisiana', 'United-States'),
			(582, 'Maine', 'United-States'),
			(583, 'Maryland', 'United-States'),
			(584, 'Massachusetts', 'United-States'),
			(585, 'Michigan', 'United-States'),
			(586, 'Minnesota', 'United-States'),
			(587, 'Mississippi', 'United-States'),
			(588, 'Missouri', 'United-States'),
			(589, 'Montana', 'United-States'),
			(590, 'Nebraska', 'United-States'),
			(591, 'Nevada', 'United-States'),
			(592, 'New Hampshire', 'United-States'),
			(593, 'New Jersey', 'United-States'),
			(594, 'New Mexico', 'United-States'),
			(595, 'New York', 'United-States'),
			(596, 'North Carolina', 'United-States'),
			(597, 'North Dakota', 'United-States'),
			(598, 'Ohio', 'United-States'),
			(599, 'Oklahoma', 'United-States'),
			(600, 'Oregon', 'United-States'),
			(601, 'Pennsylvania', 'United-States'),
			(602, 'Rhode Island', 'United-States'),
			(603, 'South Carolina', 'United-States'),
			(604, 'South Dakota', 'United-States'),
			(605, 'Tennessee', 'United-States'),
			(606, 'Texas', 'United-States'),
			(607, 'United-States', 'United-States'),
			(608, 'Utah', 'United-States'),
			(609, 'Vermont', 'United-States'),
			(610, 'Virginia', 'United-States'),
			(611, 'Washington', 'United-States'),
			(612, 'West Virginia', 'United-States'),
			(613, 'Wisconsin', 'United-States'),
			(614, 'Wyoming', 'United-States'),
			(615, 'Uruguay', 'Uruguay'),
			(616, 'Uzbekistan', 'Uzbekistan'),
			(617, 'Ambrim Island', 'Vanuatu'),
			(618, 'Aneityum Island', 'Vanuatu'),
			(619, 'Efate Island', 'Vanuatu'),
			(620, 'Epi Island', 'Vanuatu'),
			(621, 'Eromanga Island', 'Vanuatu'),
			(622, 'Espritu Santo Island', 'Vanuatu'),
			(623, 'Maewo Island', 'Vanuatu'),
			(624, 'Malekula Island', 'Vanuatu'),
			(625, 'Oba Island', 'Vanuatu'),
			(626, 'Pentecost Island', 'Vanuatu'),
			(627, 'Santa Maria Island', 'Vanuatu'),
			(628, 'Tana Island', 'Vanuatu'),
			(629, 'Torres Islands', 'Vanuatu'),
			(630, 'Vanua Lava Island', 'Vanuatu'),
			(631, 'Vanuatu', 'Vanuatu'),
			(632, 'Venezuela', 'Venezuela'),
			(633, 'North Vietnam', 'Viet-Nam'),
			(634, 'South Vietnam', 'Viet-Nam'),
			(635, 'Viet-Nam', 'Viet-Nam'),
			(636, 'Virgin-Islands-(U.K.)', 'Virgin-Islands-(U.K.)'),
			(637, 'Virgin-Islands-(U.S.)', 'Virgin-Islands-(U.S.)'),
			(638, 'Wallis-and-Futanu-Islands', 'Wallis-and-Futanu-Islands'),
			(639, 'Savai i', 'Western-Samoa'),
			(640, 'Upolu', 'Western-Samoa'),
			(641, 'Yemen', 'Yemen'),
			(642, 'Yugoslavia', 'Yugoslavia'),
			(643, 'Zaire', 'Zaire'),
			(644, 'Zambia', 'Zambia'),
			(645, 'Zimbabwe', 'Zimbabwe')";
	$database->setQuery($sql);
	$database->query();
}
?>
