<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");

class adagencyAdminModeladagencyAds extends JModel {
	var $_licenses;
	var $_license;
	var $_id = null;
	var $_total = 0;
	var $_pagination = null;

	function __construct () {
		parent::__construct();
		$cids = JRequest::getVar('cid', 0, '', 'array');
		$this->setId((int)$cids[0]);
		global $mainframe, $option;
		// Get the pagination request variables
		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
		$this->setState('limit', $limit); // Set the limit variable for query later on
		$this->setState('limitstart', $limitstart);
	}

	function setId($id) {
		$this->_id = $id;
		$this->_license = null;
	}

	function getPagination(){
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))	{
			jimport('joomla.html.pagination');
			if (!$this->_total) $this->getListAds();
			$this->_pagination = new JPagination( $this->_total, $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function rememberChannel(){
		$data = JRequest::get('post');
		//echo "<pre>";var_dump($data);die();
		if(isset($data['geo_type'])&&($data['geo_type'] == 1)){
			if(isset($data['limitation'])&&($data['limitation'] != '')) {
				$temp = NULL;
				$region_city_exist = false;
				foreach($data['limitation'] as $element) {
					if(($element['type'] == 'region')||($element['type'] == 'city')) {
						$region_city_exist = true;
					} elseif($element['type'] == 'country') {
						$the_country = array($element['data'][0]);
					}
				}
				foreach($data['limitation'] as $element) {
					if(($element['type'] == 'region')||($element['type'] == 'city')) {
						$element['data'] = array_merge($the_country, $element['data']);
					} elseif (($element['type'] == 'country')&&($region_city_exist)) { continue; }
		//			$temp[] = "( NULL , '".$channel_id."', '".$element['type']."','AND','".$element['option']."', '".json_encode($element['data'])."' )";
					$ctemp = new stdClass();
					$ctemp->type = $element['type'];
					$ctemp->data = json_encode($element['data']);
					$_SESSION['channelz'] = $ctemp;
		//			echo "1";die();
				}
			}
		} elseif(isset($data['geo_type'])&&($data['geo_type'] == 2)){
			if(isset($data['limitation_existing'])&&($data['limitation_existing'] != 0)) {
				$_SESSION['channelz2'] = $data['limitation_existing'];
		//		echo "2";die();
			}
		}
		
		return true;
	}

	function getChannelInfo(){
		$JPATH_BASE = str_replace('administrator','',JPATH_BASE); 
		require_once($JPATH_BASE.'/components/com_adagency/helpers/geoipotherdata.php');
		require_once($JPATH_BASE.'/components/com_adagency/helpers/geoipregionvars.php');		
		if (!function_exists('json_encode')) {
			require_once($JPATH_BASE.DS.'components'.DS.'com_adagency'.DS.'helpers'.DS.'jsonwrapper.php');
		}		
		//echo "<pre>";var_dump($HELPER_GEOIP_CONTINENTS);//die();
		$db = &JFactory::getDBO();
		$cid = JRequest::getInt('cid', 0);
		$output = "<table>";
		if(isset($cid)&&($cid != 0)) {
			$sql = "SELECT `type`, `logical`, `option`, `data` FROM `#__ad_agency_channel_set` WHERE channel_id = ".intval($cid)." ORDER BY id ASC";
			$db->setQuery($sql);
			$result = $db->loadObjectList();
			if(isset($result)) {
				$counter = 0;
				foreach($result as $element){
					$counterREG = 0;$aux = NULL;$values = NULL;$not_any = NULL;
					$element->data = json_decode($element->data);
					if($counter>=1) {
						$output.="<tr><th align='left'>".JText::_('ADAG_'.$element->logical)."</th></tr>";
					}
					if($element->type == 'continent') {
						foreach($element->data as &$val){
							$val = $HELPER_GEOIP_CONTINENTS[$val];
						}
						$values = implode(', ',$element->data);
						$output.= "<tr><td>".JText::_('ADAG_CONTINENT').": ".$values."</tr></td>";
					} elseif($element->type == 'country'){
						foreach($element->data as &$val){
							$val = $HELPER_GEOIP_COUNTRIES[$val];
						}
						$values = implode(', ',$element->data);
						if($element->option != 'is') { $not_any = JText::_('ADAG_NOT_ANY'); }
						$output.= "<tr><td>".JText::_('ADAG_COUNTRY').$not_any.": ".$values."</tr></td>";
					} elseif($element->type == 'region'){
						foreach($element->data as &$val){
							if($counterREG == 0){
								$aux = $val;
								$val = $HELPER_GEOIP_COUNTRIES[$val];
							} else {
								$val = $GEOIP_REGION_NAME[$aux][$val];
							}
							$counterREG++;
						}
						if($element->option != 'is') { $not_any = JText::_('ADAG_NOT_ANY'); }
						$output.= "<tr><td>".JText::_('ADAG_COUNTRY').": ".$element->data[0]."<br />";
						$element->data[0] = NULL;unset($element->data[0]);
						$values = implode(', ',$element->data);
						$output.= JText::_('ADAG_REGION').$not_any.": ".$values;
						$output.= "</tr></td>";						
					} elseif($element->type == 'city'){
						if($element->option == '==') { $not_any = JText::_('ADAG_IS_EQUAL'); }
						elseif($element->option == '!=') { $not_any = JText::_('ADAG_IS_DIFFERENT'); }
						elseif($element->option == '=~') { $not_any = JText::_('ADAG_CONTAINS'); }
						elseif($element->option == '!~') { $not_any = JText::_('ADAG_NOT_CONTAINS'); }
						$output.= "<tr><td>".JText::_('ADAG_COUNTRY').": ".$HELPER_GEOIP_COUNTRIES[$element->data[0]]."<br />";
						$values = $element->data[1];
						$output.= JText::_('ADAG_CITY').$not_any.": ".$values;
						$output.= "</tr></td>";							
					} elseif($element->type == 'dma'){
						if($element->option != 'is') { $not_any = JText::_('ADAG_NOT_ANY'); }
						foreach($element->data as &$val){
							$val = $HELPER_GEOIP_DMA[$val];
						}
						$values = implode(', ',$element->data);						
						$output.= "<tr><td>".JText::_('ADAG_DMA').$not_any.": ".$values."</td></tr>";
					} elseif($element->type == 'latitude'){
						if($element->option == '==') { $not_any = JText::_('ADAG_BETWEEN'); } else { $not_any = JText::_('ADAG_NOT_BETWEEN'); }
						$output.= "<tr><td>".JText::_('ADAG_LATLONG').$not_any.": <br />";
						$output.= $element->data->a." ".JText::_('ADAG_AND')." ".$element->data->b."<br />";
						$output.= $element->data->c." ".JText::_('ADAG_AND')." ".$element->data->d."<br />";
						$output.= "</td></tr>";
					} elseif($element->type == 'usarea'){
						if($element->option == '==') { $not_any = JText::_('ADAG_IS_EQUAL'); }
						elseif($element->option == '!=') { $not_any = JText::_('ADAG_IS_DIFFERENT'); }
						elseif($element->option == '=~') { $not_any = JText::_('ADAG_CONTAINS'); }
						elseif($element->option == '!~') { $not_any = JText::_('ADAG_NOT_CONTAINS'); }
						$output.= "<tr><td>".JText::_('ADAG_USAREA').": ".$element->data[0]."</tr></td>";					
					} elseif($element->type == 'postalcode'){
						if($element->option == '==') { $not_any = JText::_('ADAG_IS_EQUAL'); }
						elseif($element->option == '!=') { $not_any = JText::_('ADAG_IS_DIFFERENT'); }
						elseif($element->option == '=~') { $not_any = JText::_('ADAG_CONTAINS'); }
						elseif($element->option == '!~') { $not_any = JText::_('ADAG_NOT_CONTAINS'); }
						$output.= "<tr><td>".JText::_('ADAG_POSTAL_COD').": ".$element->data[0]."</tr></td>";					
					}					
					$counter++;
				}
			}
			$output.= "</table>";
			//echo "<pre>";var_dump($result);die();
			echo $output;
		}
	}

	function getlistAds () {
		$limit_cond=NULL;
		$db = &JFactory::getDBO();
		if (empty ($this->_licenses)) {
			if(isset($_GET['cid'][0]) && $_GET['cid'][0] > 0)	
				{
					$and_filter = ' AND cb.campaign_id = '.intval($_GET['cid'][0]).' ';
				}
			else
					$and_filter = '';
					
		if(isset($_GET['apr'])&&($_GET['apr']==true)) { $and_filter.= " AND b.approved = 'P' "; }			
		/* adding the search condition - start */			
		if(isset($_POST['search_text']))
		{
			$_SESSION['search_text'] = $db->getEscaped($_POST['search_text']);
			$search_text = $db->getEscaped($_POST['search_text']);
		}
		elseif(isset($_SESSION['search_text']))
			$search_text = $db->getEscaped($_SESSION['search_text']);		
		if(isset($search_text) && $search_text!=''){
			$and_filter = $and_filter." AND (b.id LIKE '%".$search_text."%' OR b.title LIKE '%".$search_text."%' OR b.description LIKE '%".$search_text."%')"; }								
		/* adding the search condition - stop */		
		
		/* adding the advertiser select condition - start */			
		if(isset($_POST['advertiser_id']))
			{
				$advertiser = intval($_POST['advertiser_id']);
				$_SESSION['advertiser_id'] = intval($_POST['advertiser_id']);
			}	
		elseif(isset($_SESSION['advertiser_id']))	
			$advertiser = $_SESSION['advertiser_id'];
		if(isset($advertiser) && $advertiser!='0'){
				$and_filter = $and_filter." AND b.advertiser_id = '".$advertiser."' "; }			
		/* adding the advertiser select condition - stop */
		
		/* adding the type select condition - start */			
		if(isset($_POST['type_select']))
			{
				$type_select = $db->getEscaped($_POST['type_select']);
				$_SESSION['type_select'] = $db->getEscaped($_POST['type_select']);
			}	
		elseif(isset($_SESSION['type_select']))	
			$type_select = $_SESSION['type_select'];
		if(isset($type_select) && $type_select!='all' && $type_select!=""){
				$and_filter = $and_filter." AND b.media_type = '".$type_select."' "; }			
		/* adding the advertiser select condition - stop */		
		
		/* adding the zone select condition - start */			
		if(isset($_POST['zone_id']))
			{
				$zone = $_POST['zone_id'];
				$_SESSION['zone_id'] = $_POST['zone_id'];
			}	
		elseif(isset($_SESSION['zone_id']))	
			$zone = $_SESSION['zone_id'];
		if(isset($zone) && $zone!='0'){
				$and_filter = $and_filter." AND m.id = '".$zone."' "; }			
		/* adding the zone select condition - stop */	
		
		/* adding the status select condition - start */			
		if(isset($_POST['status_select']))
			{
				$status_select =$db->getEscaped($_POST['status_select']);
				$_SESSION['status_select'] =$db->getEscaped($_POST['status_select']);
			}	
		elseif(isset($_SESSION['status_select']))	
			$status_select =$db->getEscaped($_SESSION['status_select']);
		if(isset($status_select) && $status_select!='YA' && $status_select!=""){
				$and_filter = $and_filter." AND b.approved = '".$status_select."' "; }			
		/* adding the status select condition - stop */			
		$sql = "	SELECT b . * , camp.id campaign_id, camp.name campaign_name, a.aid AS advertiser_id2, a.company AS advertiser, concat( width, 'x', height ) AS size_type, m.id mid, m.title zone_name
					FROM #__ad_agency_banners AS b
					LEFT OUTER JOIN #__ad_agency_advertis AS a ON b.advertiser_id = a.aid
					LEFT JOIN #__ad_agency_campaign_banner AS cb ON cb.banner_id = b.id
					LEFT JOIN #__ad_agency_campaign AS camp ON camp.id = cb.campaign_id
					LEFT JOIN #__ad_agency_order_type AS p ON camp.otid = p.tid
					LEFT JOIN #__modules AS m ON m.id = cb.zone
					WHERE 1=1 " . $and_filter . "
					GROUP BY b.id
                    ORDER BY b.ordering ASC , b.id DESC
				";
		
		//$sql= "SELECT DISTINCT * FROM (".$sql.") as thealias ORDER BY ordering ASC, id DESC";
		$limitstart=$this->getState('limitstart');
		$limit=$this->getState('limit');
			
		if($limit!=0){
			$limit_cond=" LIMIT ".$limitstart.",".$limit." ";
		} else {
			$limit_cond = NULL;
		}
		$this->_licenses = $this->_getList($sql.$limit_cond);
		$this->_total = $this->_getListCount($sql);
		$rows = $this->_licenses;
		$ids = array();
		if(is_array($rows))
		foreach($rows as $row)
			array_push($ids, $row->id);
		$ids = implode(",", $ids);
		
		if ($ids == "") $ids = "null";
		$sql2 = <<<eosql
select
			banner_id,
			sum(case s.type when 'impressions' then s.how_many else 0 end) as impressions, 
			sum(case s.type when 'click' then s.how_many else 0 end) as click,
			TRUNCATE((sum(case s.type when 'click' then s.how_many else 0 end)/(sum(case s.type when 'impressions' then s.how_many else 0 end)/100)),2) as click_rate
			FROM #__ad_agency_stat s
where banner_id in($ids)
group by banner_id
eosql;
		$this->_licenses = $this->_getList($sql2);
		$rows2 = $this->_licenses;
		foreach($rows2 as $row2)
			foreach($rows as $k=>$row)
				if($row2->banner_id == $row->id)
				{
					$rows[$k]->impressions = $row2->impressions;
					$rows[$k]->click = $row2->click;
					$rows[$k]->click_rate = $row2->click_rate;
					$sqlz	= "SELECT count(c.id) FROM #__ad_agency_campaign c INNER JOIN #__ad_agency_campaign_banner cb on c.id = cb.campaign_id WHERE banner_id = {$row->id}";
					$this->_licenses = $this->_getList($sqlz);
					
				}
			$this->_licenses = $rows;
		}
		return $this->_licenses;
	}	

	function getLicense() {
		if (empty ($this->_license)) {
			$sql = "select l.*,p.name as productname, u.username from #__adagency_licenses l, #__adagency_products p, #__users u where l.productid=p.id and l.userid=u.id and l.id=".$this->_id;
			$this->_total = $this->_getListCount($sql);
			
			$this->_license = $this->_getList($sql);
			if (count ($this->_license) > 0) $this->_license = $this->_license[0];
			else {
				$this->_license =& $this->getTable("adagencyLicense");
				$this->_license->username = "";
			}
		}
		return $this->_license;
	}
	
	function getCampaignCount($banner_id) {
		$database = & JFactory::getDBO();
		$sql	= "SELECT count(DISTINCT c.id) FROM #__ad_agency_campaign c INNER JOIN #__ad_agency_campaign_banner cb on c.id = cb.campaign_id WHERE banner_id = {$banner_id}";
		$database->setQuery($sql);
		$result = $database->loadResult();
		return $result;
	}
	
	function store () {
		$item =& $this->getTable('adagencyLicense');
		$data = JRequest::get('post');
		$res = true;
		if (!$item->bind($data)){
			$res = false;
		}

		if (!$item->check()) {
			$res = false;
		}

		if (!$item->store()) {
			$res = false;
		}
		return $res;
	}	
	
	function copy () {
		$db = & JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$n		= count( $cid );
		if ($n == 0) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}
		foreach ($cid as $id)
		{
			$row 	=& $this->getTable('adagencyAds');
			$db = & JFactory::getDBO();
			// load the row from the db table
			$row->load( (int) $id );
			
			$row->title 		= $row->title.' copy';
			$row->id 			= 0;

			if (!$row->check()) {
				return JError::raiseWarning( 500, $row->getError() );
			}
			if (!$row->store()) {
				return JError::raiseWarning( 500, $row->getError() );
			}
			$row->checkin();
			unset($row);
			
			$sql = "SELECT id FROM #__ad_agency_banners ORDER BY id DESC LIMIT 1";
			$db->setQuery($sql);
			$currentid = $db->loadResult();
			
			$sql = "SELECT campaign_id FROM #__ad_agency_campaign_banner WHERE banner_id = '".$id."'";
			$db->setQuery($sql);
			$result = $db->loadResultArray();
			
			// Copy the channel settings as well here - BEGIN
			$sql = "SELECT * FROM #__ad_agency_channels WHERE banner_id = ".$id." LIMIT 1";
			$db->setQuery($sql);
			$sqlz[] = $sql;
			$chan = $db->loadObject();
			
			if(isset($chan->id)){
				$sql = "INSERT INTO `#__ad_agency_channels` (`name` ,`banner_id` ,`advertiser_id` ,`public` ,`created` ,`created_by` ,`from`
			)VALUES ('".$chan->name."', '".$currentid."', '".$chan->advertiser_id."', '".$chan->public."',  NOW() , '".$chan->created_by."', '".$chan->from."');";
				$sqlz[] = $sql;
				$db->setQuery($sql);
				$db->query();
				
				$sql = "SELECT id FROM `#__ad_agency_channels` ORDER BY id DESC LIMIT 1";
				$sqlz[] = $sql;
				$db->setQuery($sql);
				$new_channel_id = $db->loadResult();
				
				$sql = "SELECT * FROM `#__ad_agency_channel_set` WHERE channel_id = ".$chan->id." LIMIT 1";
				$sqlz[] = $sql;
				$db->setQuery($sql);
				$channel_sets = $db->loadObject();
				
				if(($channel_sets != NULL)&&($new_channel_id != NULL)) {
					$sql = "INSERT INTO `#__ad_agency_channel_set` (`channel_id` ,`type` ,`logical` ,`option` ,`data`) VALUES (
					'".$new_channel_id."', '".$channel_sets->type."', '".$channel_sets->logical."', '".$channel_sets->option."', '".$channel_sets->data."');";
					$sqlz[] = $sql;
					$db->setQuery($sql);
					$db->query();
				}
			}
			// Copy the channel settings as well here - END
			
			foreach($result as $element) {
				$sql = "INSERT INTO `#__ad_agency_campaign_banner` (`campaign_id` ,`banner_id` ,`relative_weighting`
) VALUES ('".$element."', '".$currentid."', '100');";
				$db->setQuery($sql);
				$db->query();
			}
		}
		//echo "<pre>";var_dump($sqlz);die();
		return 1;
	}
	
	function delete () {
		$database = & JFactory::getDBO();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$item =& $this->getTable('adagencyAds');
		foreach ($cids as $cid) {
			if (!$item->delete($cid)) {
				$this->setError($item->getErrorMsg());
				return false;
			}
			$query = "DELETE FROM #__ad_agency_stat WHERE banner_id = '".$cid."'";
			$database->setQuery( $query );
			if (!$database->query()) {
				mosErrorAlert( $database->getErrorMsg() );
				exit;
			}
			$query = "DELETE FROM #__ad_agency_campaign_banner WHERE banner_id = '".$cid."'";
			$database->setQuery( $query );
			if (!$database->query()) {
				mosErrorAlert( $database->getErrorMsg() );
				exit;
			}
		}
		return true;
	}

	function publish () {
		$db =& JFactory::getDBO();
		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyAds');
		if ($task == 'publish'){
			$sql = "update #__ad_agency_banners set approved='Y' where id in ('".implode("','", $cids)."')";
			$ret = 1;
		} else {
			$ret = -1;
			$sql = "update #__ad_agency_banners set approved='N' where id in ('".implode("','", $cids)."')";
		}
		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}
	
		//send email notifications
			$sql = "SELECT b.title, u.name, u.username, u.email FROM #__ad_agency_banners AS b LEFT JOIN #__ad_agency_advertis as a ON a.aid=b.advertiser_id LEFT JOIN #__users as u ON u.id=a.user_id WHERE b.id IN ('".implode("','", $cids)."') GROUP BY b.id";
			$db->setQuery($sql);

			if(!$result = $db->query()) {
				echo $db->stderr();
				return;
			}
			$user = $db->loadObjectList();
	        foreach ( $user as $value) {			
				if ($task == 'publish') {
					$subject=$configs->sbadappv;
					$message=$configs->bodyadappv;
				}
				else {
					$subject=$configs->sbaddisap;
					$message=$configs->bodyaddisap;
				}
				$subject =str_replace('{name}',$value->name,$subject);
				$subject =str_replace('{login}',$value->username,$subject);
				$subject =str_replace('{email}',$value->email,$subject);
				$subject =str_replace('{banner}',$value->title,$subject);
				$message =str_replace('{name}',$value->name,$message);
				$message =str_replace('{login}',$value->username,$message);
				$message =str_replace('{email}',$value->email,$message);
				$message =str_replace('{banner}',$value->title,$message);
				// mail publish campaign
				JUtility::sendMail( $configs->fromemail, $configs->fromname, $value->email, $subject, $message, 1 );
			}
		//send email notifications
		return $ret;
	}
	
	function saveorder () {
		$db =& JFactory::getDBO();
		$data=JRequest::get('post');
		
		if(!isset($data['order'])) {
			$sql = "SELECT id, ordering as value FROM `#__ad_agency_banners` ORDER BY value ASC";
			$db->setQuery($sql);
			$res = $db->loadAssocList();
			$data['order'] = 1;
		}
				
		if(isset($data['order'])) {
			if(is_array($data['order'])) {
				asort($data['order']);
				$i=0;
				foreach($data['order'] as $key=>$value){
					$temp[$i]['id']= intval($key);
					$temp[$i]['value']= intval($value);
					$i++;
				}
			} else {
				$temp = $res;
				$i = count($temp);
			}
			
			$ok=true;
			while($ok==true){
				$bool = true;
				for($j=0;$j<=$i-2;$j++){
					if(($temp[$j]['value'] == $temp[$j+1]['value'])&&($temp[$j]['id'] < $temp[$j+1]['id'])) {
						$aux = $temp[$j]['id'];
						$temp[$j]['id'] = $temp[$j+1]['id'];
						$temp[$j+1]['id'] = $aux;
						$bool = false;
					}
				}
				if($bool){
					$ok = false;
				}
			}
					
			$nr = 0;
			for($i=0;$i<=count($temp)-1;$i++) {
				$sql="UPDATE `#__ad_agency_banners` SET `ordering` = '".$nr."' WHERE `id` =".$temp[$i]['id']." LIMIT 1 ;";
				$sqlz[] = $sql;
				$db->setQuery($sql);
				$db->query();
				$nr++;
			}
		}
		
		return true;
	}

	function approve ($cid,$task) {
		$db =& JFactory::getDBO();
		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		//$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		//$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyAds');
		$sql = "update #__ad_agency_banners set approved='Y' where id = '".$cid."' ";
		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}

		//send email notifications
			$sql = "SELECT b.title, u.name, u.username, u.email FROM #__ad_agency_banners AS b LEFT JOIN #__ad_agency_advertis as a ON a.aid=b.advertiser_id LEFT JOIN #__users as u ON u.id=a.user_id WHERE b.id = '".$cid."' GROUP BY b.id";
			$db->setQuery($sql);
			if(!$result = $db->query()) {
				echo $db->stderr();
				return;
			}
			$user = $db->loadObjectList();
	        foreach ( $user as $value) {			

				if($task == 'Y') {
					$subject=$configs->sbadappv;
					$message=$configs->bodyadappv;
				} else {
					$subject=$configs->sbaddisap;
					$message=$configs->bodyaddisap;
				}
					
				$subject =str_replace('{name}',$value->name,$subject);
				$subject =str_replace('{login}',$value->username,$subject);
				$subject =str_replace('{email}',$value->email,$subject);
				$subject =str_replace('{banner}',$value->title,$subject);
				$message =str_replace('{name}',$value->name,$message);
				$message =str_replace('{login}',$value->username,$message);
				$message =str_replace('{email}',$value->email,$message);
				$message =str_replace('{banner}',$value->title,$message);
				// mail publish campaign
				JUtility::sendMail( $configs->fromemail, $configs->fromname, $value->email, $subject, $message, 1 );
			}
		//send email notifications
		return 1;
	}
	
	// get advertisers name by advertiser id
	function getAdvByAID($aid){
		$db = &JFactory::getDBO();
		$sql = "SELECT u.name FROM `#__users` AS u, `#__ad_agency_advertis` AS a WHERE u.id = a.user_id AND a.aid= ".$aid;
		$db->setQuery($sql);
		$result = $db->loadResult();
		return $result;
	}
	
	function pending () {
		$db =& JFactory::getDBO();
		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyAds');
		$sql = "UPDATE #__ad_agency_banners SET approved='P' WHERE id in ('".implode("','", $cids)."')";
		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}
		return 0;
	}

	function unapprove () {
		$db =& JFactory::getDBO();
		$configs = $this->getInstance("adagencyConfig", "adagencyAdminModel");
		$configs = $configs->getConfigs();
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$task = JRequest::getVar('task', '', 'post');
		$item =& $this->getTable('adagencyAds');
		$sql = "update #__ad_agency_banners set approved='N' where id in ('".implode("','", $cids)."')";
		$db->setQuery($sql);
		if (!$db->query() ){
			$this->setError($db->getErrorMsg());
			return false;
		}
		//send email notifications
			$sql = "SELECT b.title, u.name, u.username, u.email FROM #__ad_agency_banners AS b LEFT JOIN #__ad_agency_advertis as a ON a.aid=b.advertiser_id LEFT JOIN #__users as u ON u.id=a.user_id WHERE b.id IN ('".implode("','", $cids)."') GROUP BY b.id";
			$db->setQuery($sql);
			if(!$result = $db->query()) {
				echo $db->stderr();
				return;
			}
			$user = $db->loadObjectList();
	        foreach ( $user as $value) {			
					$subject=$configs->sbaddisap;
					$message=$configs->bodyaddisap;
				$subject =str_replace('{name}',$value->name,$subject);
				$subject =str_replace('{login}',$value->username,$subject);
				$subject =str_replace('{email}',$value->email,$subject);
				$subject =str_replace('{banner}',$value->title,$subject);
				$message =str_replace('{name}',$value->name,$message);
				$message =str_replace('{login}',$value->username,$message);
				$message =str_replace('{email}',$value->email,$message);
				$message =str_replace('{banner}',$value->title,$message);
				// mail publish campaign
				JUtility::sendMail( $configs->fromemail, $configs->fromname, $value->email, $subject, $message, 1 );
			}
		//send email notifications
		return -1;
	}
};
?>