 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");

class adagencyAdminModeladagencyReports extends JModel {
	function __construct () {
		parent::__construct();
		$cids = JRequest::getVar('cid', 0, '', 'array');
		$this->setId((int)$cids[0]);
	}

	function setId($id) {
		$this->_id = $id;
		$this->_installpath = JPATH_COMPONENT.DS."plugins".DS;
		$this->_plugin = null;
	}

	function getlistLanguages () {
		if (empty ($this->_plugins)) {
			$sql = "select * from #__adagency_languages";
			$this->_languages = $this->_getList($sql);
		}
		return $this->_languages;
	}	
	
	function formatime2($time,$option = 1){
		$date_time = explode(" ",$time);
		$date_time[0] = str_replace("/","-",$date_time[0]);
		$tdate = explode("-",$date_time[0]); 		
		if (($option == 1)||($option == 2)||($option == 7)||($option == 8)) { 
			$aux=$tdate[0];
			$tdate[0]=$tdate[2];
			$tdate[2]=$aux;
		}
		elseif (($option == 3)||($option == 4)||($option == 9)||($option == 10)) { 
			//mm-dd-yyyy
			$aux=$tdate[0];
			$tdate[0]=$tdate[2];
			$tdate[2]=$tdate[1];
			$tdate[1]=$aux;	
		}
		$output = NULL;
		if(!isset($date_time[1])) {$date_time[1] = NULL;}
		$output = $tdate[0]."-".$tdate[1]."-".$tdate[2];			
		return trim($output);
	}
	
	function emptyrep(){
		$data= JRequest::get('post');
		$db = JFactory::getDBO();	
		$data['start_date'] = $this->formatime2($data['start_date'], $data['tfa']);
		$data['end_date'] = $this->formatime2($data['end_date'], $data['tfa']);
		$sql="DELETE FROM #__ad_agency_stat WHERE entry_date>='".$data['start_date']." 00:00:00' AND entry_date<='".$data['end_date']." 23:59:59' ";
		$db->setQuery($sql);
		if(!$db->query()){
			return false;
		}
		
		return true;
	}

	function getLanguage () {
		$db = JFactory::getDBO();
		$sql = "select * from #__adagency_languages where id=".$this->_id;
		$db->setQuery($sql);
		$lang = $db->loadObjectList();
		$lang = $lang[0];
		$file = $lang->fefilename;
		$code = $lang->name;
		$respathfe = JPATH_ROOT.DS."language".DS.$code.DS.$file;
		$respathbe = JPATH_ROOT.DS."administrator".DS."language".DS.$code.DS.$file;
		$task = JRequest::getVar("task", "", "request");
		if ($task == "editFE") $lang->path = $respathfe;
		else $lang->path = $respathbe;
		$lang->data = implode ("", file ($lang->path));
		$lang->type = $task;
		return $lang;
	}
	
	function store () {
		$db = JFactory::getDBO();
		$id = JRequest::getVar("id", "", "request");
		if (!$id) return false;
		$sql = "select * from #__adagency_languages where id=".$id;
		$db->setQuery($sql);
		$lang = $db->loadObjectList();
		$lang = $lang[0];
		$file = $lang->fefilename;
		$code = $lang->name;
		$respathfe = JPATH_ROOT.DS."language".DS.$code.DS.$file;
		$respathbe = JPATH_ROOT.DS."administrator".DS."language".DS.$code.DS.$file;
		$type = JRequest::getVar("type", "", "request");
		if ($type == "editFE") $path = $respathfe;
		else $path = $respathbe;
		$text = $_POST["langfiledata"];
		$f = fopen ($path, "w");
		fwrite ($f, $text);
		fclose ($f);
		return true;
	}	

	function copyLangFile ($path, $type, $code, $file) {
		$respath = "";
		if ($type == "fe") {
			$respath = JPATH_ROOT.DS."language".DS.$code.DS;
		} elseif ($type == "be") {
			$respath = JPATH_ROOT.DS."administrator".DS."language".DS.$code.DS;
		}
		if (!file_exists($respath) ) return -2;
		if (file_exists($respath.$file)) return -1;
		JFile::copy($path, $respath.$file, '');	
		return 1;
	}

	function installLanguage($path, $language_file = '') {
		$db = JFactory::getDBO();
		$language_file = trim ($language_file);
		if (strlen($language_file) < 1) return JText::_('MODLANGNOUPLOAD');
		$ext = substr ($language_file, strrpos($language_file, ".") + 1);
		if ($ext != 'zip') return JText::_('MODLANGNOZIP');
		jimport('joomla.filesystem.archive');	
		if (!JArchive::extract($path.$language_file, $path)) {
			return JText::_('MODLANGERREXTRACT');
		}
		$dir = opendir ($path);
		if (!file_exists($path."install")) return JText::_("MODLANGMISSINSTALL");
		$install = parse_ini_file($path."install");
		if (count ($install) < 1) return JText::_("MODLANGCORRUPTEDINSTALL");
		$lang_code = explode (" ", $install['langcode']);
	        foreach ($lang_code as $code ) {
			$be = 0;
			$fe = 0;
			$fe_path = $path."fe".DS.$code.DS.$code.".com_adagency.ini";
			$lang_file = $code.".com_adagency.ini";
			$be_path = $path."be".DS.$code.DS.$code.".com_adagency.ini";
			if (!file_exists($fe_path)) $fe = 0; else $fe = 1;
			if (!file_exists($be_path)) $be = 0; else $be = 1;
			if ($be && $fe ) {
				$query = "select count(*) from #__adagency_languages where fefilename='".$lang_file."' or befilename='".$lang_file."'";
  				$db->setQuery($query);
		   		$isthere = $db->loadResult();
				if ($isthere) {
					return JText::_('MODLANGALLREDYEXIST');// 
				} else {
				        $fe = 0;
					$be = 0;
					$fe = $this->copyLangFile($fe_path, "fe", $code, $lang_file);
					if ($fe) {
						$be = $this->copyLangFile($be_path, "be", $code, $lang_file);		
					}
					if (!$fe || !$be) {
						return JText::_("MODLANGCOPYERR");
					} else if ($fe == -1 || $be == -1) {
						return JText::_("MODLANGCANTCOPY");
					} else if ($fe < 0 || $be < 0) {
						return JText::_("MODLANGFOLDERNOTEXITST");
					} else {
						$sql = "insert into #__adagency_languages(`name`, `fefilename`, `befilename`) values ('".$code."', '".$lang_file."', '".$lang_file."')";
		  				$db->setQuery($sql);
				   		$db->query();
					}
				} 
			} else {
				return JText::_("MODLANGMISSLANGFILE");
			}
		}
		$install_path = $this->_installpath;
      		JFile::copy ($path.$install['filename'], $install_path.$install['filename']);
	    	return JText::_("MODLANGSUCCESSFUL");
	}

    function compdata() {
        $db = &JFactory::getDBO();
        $step = &JRequest::getVar('step');

        if ($step == 1) {
            $sql = "SELECT id, name FROM #__ad_agency_campaign
                    WHERE (`type` = 'cpm' AND `quantity` < 1)
                    OR (`type` = 'pc' AND `quantity` < 1)
                    OR (`type` = 'fr' AND `validity` < NOW())";
            $sqlz[] = $sql;
            // echo $sql;die();
            $db->setQuery($sql);
            $camps = $db->loadRowList();
            // echo "<pre>";var_dump($camps);die();
            // echo json_encode($camps);die();

            $finals = array();
            $valids = array();

            if (count($camps) > 0) {

                foreach ($camps as $camp) {
                    // store the id of the campaigns
                    $tmp[] = $camp[0];
                }

                if (count($tmp) > 1) {
                    $in_camps = "(" . implode(',', $tmp) . ")";
                } else {
                    $in_camps = "(" . $tmp[0] . ")";
                }

                $sql = "SELECT `campaign_id` , `banner_id` , COUNT( advertiser_id ) AS nr
                        FROM `#__ad_agency_stat`
                        WHERE `campaign_id` IN {$in_camps}
                        GROUP BY `campaign_id` , `banner_id`";

                $sqlz[] = $sql;
                $db->setQuery($sql);
                $res = $db->loadObjectList();

                if (count($res) > 0) {
                    // if there are more than 2 records (1 for impressions and one for clicks)
                    // for a banner for a specific campaign
                    // it means the campaign is most probably uncompressed
                    foreach ($res as $element) {
                        if ( ($element->nr > 2) && (!in_array($element->campaign_id, $valids)) ) {
                            $valids[] = $element->campaign_id;
                        }
                    }

                    // foreach uncompressed campaign, grab the complete details
                    foreach ($camps as $camp) {
                        if (in_array($camp[0], $valids)) {
                            $finals[] = $camp;
                        }
                    }
                }

           }

            echo json_encode($finals);
        } elseif ($step == '2c') {
            $this->computil('click');
        } elseif ($step == '2i') {
            $this->computil('impressions');
        } else {
            echo $step;
        }

        // echo "<pre>";var_dump($sqlz);die();
        die();
    }

    function computil($opt = 'click') {
        $db = &JFactory::getDBO();
        $cid = &JRequest::getInt('cid');
        $ok = 'ok';
        $sql = "SELECT `entry_date`, `ip_address`, `advertiser_id`, `banner_id`
                AS bid, SUM( how_many ) AS total
                FROM `#__ad_agency_stat`
                WHERE `campaign_id` = $cid
                AND `type` = '$opt'
                GROUP BY `banner_id`";
        $sqlz[] = $sql;
        $db->setQuery($sql);
        $bns = $db->loadObjectList();

        if (is_array($bns)) {
            foreach($bns as $element) {
                $sql = "DELETE FROM `#__ad_agency_stat`
                        WHERE `campaign_id` = '$cid'
                        AND `type` = '$opt'
                        AND `banner_id` = '$element->bid'
                        ";
                $sqlz[] = $sql;
                $db->setQuery($sql);
                if (!$db->query()) {
                    $ok = 'error when deleting';
                }

                $sql = "INSERT INTO `#__ad_agency_stat` (
                    `entry_date` ,`ip_address` ,`advertiser_id` ,
                    `campaign_id` ,`banner_id` ,`type` ,`how_many`
                ) VALUES (
                    '$element->entry_date',
                    '$element->ip_address',
                    '$element->advertiser_id',
                    '$cid',
                    '$element->bid',
                    '$opt',
                    '$element->total'
                );";
                $sqlz[] = $sql;
                $db->setQuery($sql);
                if (!$db->query()) {
                    $ok = 'error when inserting';
                }
            }
        }
        // echo "<pre>";var_dump($sqlz);

    }

	function upload() {
		$table_entry =& $this->getTable ("adagencyPlugin");
		jimport('joomla.filesystem.file');
		$file = JRequest::getVar('langfile', array(), 'files');	
		$install_path = JPATH_ROOT.DS."tmp".DS."adagencylanguage".DS;
		Jfolder::create ($install_path);
		if (JFile::copy($file['tmp_name'], $install_path.$file['name'], '')) {
			$res = $this->installLanguage($install_path, $file['name']);
			JFolder::delete ($install_path);
		} else {
			$res = JText::_('MODLANGCOPYERR');
		}
		return $res;
	}

	function delete () {
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		jimport('joomla.filesystem.file');
		$db = JFactory::getDBO();
		foreach ($cids as $cid) {
			$sql = "select name,fefilename from #__adagency_languages where id=".$cid;
			$db->setQuery($sql);
			$tmp = $db->loadObjectList();
			$file = $tmp[0]->fefilename;
			$code = $tmp[0]->name;
			$respathfe = JPATH_ROOT.DS."language".DS.$code.DS;
			$respathbe = JPATH_ROOT.DS."administrator".DS."language".DS.$code.DS;
			$menufile = str_replace (".ini", ".menu.ini", $file);
			if ((JFile::delete($respathfe.$file)) && (JFile::delete($respathfe.$menufile))
				&& (JFile::delete($respathbe.$file)) && (JFile::delete($respathbe.$menufile))) {
				$sql = "delete from #__adagency_languages where id=".$cid;
				$db->setQuery($sql);
				$db->query();
			}
		}
		return true;
	}
	
	function getreportsAdvertisers () {
		if (empty ($this->_package)) {
			$db =& JFactory::getDBO();
			$sql = "SELECT a.aid, b.name as company, a.user_id FROM #__ad_agency_advertis as a, #__users as b WHERE a.user_id = b.id ORDER BY company ASC";
			$db->setQuery($sql);
			if (!$db->query()) {
				echo $db->stderr();
				return;
			}
			$this->_package = $db->loadObjectList();
		}
		return $this->_package;
	}
};
?>
