<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.application.component.view");

class adagencyAdminViewadagencyabout extends JView {

	function display ($tpl =  null ) {
		
		JToolBarHelper::title(JText::_('AD_ABOUTTITLE'), 'generic.png');

		JToolBarHelper::Cancel();
		
		$component = array();
		$modulezone = array();
		$modulemenu = array();
		$component['installed'] = $modulezone['installed'] = $modulemenu['installed'] = 0;
		$component['name'] = 'iJoomla Ad Agency';
		$component['file'] = JPATH_SITE. DIRECTORY_SEPARATOR ."administrator". DIRECTORY_SEPARATOR ."components". DIRECTORY_SEPARATOR ."com_adagency". DIRECTORY_SEPARATOR ."adagency.xml"; 
		
		$modulezone['name'] = 'Ad Agency Zone';
		$modulezone['file'] = JPATH_SITE. DIRECTORY_SEPARATOR ."modules". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_zone". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_zone.xml";
		$modulezone['php'] = JPATH_SITE. DIRECTORY_SEPARATOR ."modules". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_zone". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_zone.php";
		
		$modulemenu['name'] = 'Ad Agency Menu';
		$modulemenu['file'] = JPATH_SITE. DIRECTORY_SEPARATOR ."modules". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_menu". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_menu.xml";
		$modulemenu['php'] = JPATH_SITE. DIRECTORY_SEPARATOR ."modules". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_menu". DIRECTORY_SEPARATOR ."mod_ijoomla_adagency_menu.php";
		
		if ( file_exists($component['file']) ){
		
			$component['installed'] = 1;
			$data = implode ("", file ( $component['file'] ) );
	        $pos1 = strpos ($data,"<version>");
	        $pos2 = strpos ($data,"</version>");
	        $component['version'] = 'version '.substr ($data, $pos1+strlen("<version>"), $pos2-$pos1-strlen("<version>"));
		}
		
		if ( file_exists($modulezone['file']) && file_exists($modulezone['php']) ){
			$modulezone['installed'] = 1;
			$data = implode ("", file ( $modulezone['file'] ) );
	        $pos1 = strpos ($data,"<version>");
	        $pos2 = strpos ($data,"</version>");
	        $modulezone['version'] = 'version '.substr ($data, $pos1+strlen("<version>"), $pos2-$pos1-strlen("<version>"));
	
		}
		
		if ( file_exists($modulemenu['file']) && file_exists($modulemenu['php']) ){
			$modulemenu['installed'] = 1;
			$data = implode ("", file ( $modulemenu['file'] ) );
	        $pos1 = strpos ($data,"<version>");
	        $pos2 = strpos ($data,"</version>");
	        $modulemenu['version'] = 'version '.substr ($data, $pos1+strlen("<version>"), $pos2-$pos1-strlen("<version>"));
	
		}
		
		$this->assignRef('component', $component);
		$this->assignRef('modulezone', $modulezone);	
		$this->assignRef('modulemenu', $modulemenu);	
		
		parent::display($tpl);

	}

}

?>