 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.application.component.view");

class adagencyAdminViewadagencyAds extends JView {

	function display ($tpl =  null ) {
		JToolBarHelper::title(JText::_('ADAGENCY_ADS_MANAGER'), 'generic.png');
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::custom( 'copy', 'copy.png', 'copy_f2.png', 'Copy', true );
		JToolBarHelper::deleteList();	
		$ads =& $this->get('listAds');		
		
		if(is_array($ads))
		foreach($ads as $ad){
			$ad->advertiser = & $this->_models['adagencyads']->getAdvByAID($ad->advertiser_id2);
		}
		//echo "<pre>";var_dump($ads);die();
		
		$this->assignRef('ads', $ads);
		
		$pagination = & $this->get( 'Pagination' );
		$this->assignRef('pagination', $pagination);

		$javascript = 'onchange="document.topform1.submit();"';
		$advertisers[] = JHTML::_('select.option',  "0", JText::_('AD_AGENCY_ALL_ADV'), 'aid', 'company' );	

			$db =& JFactory::getDBO();
			$sql = "SELECT a.aid, b.name as company, a.user_id FROM #__ad_agency_advertis as a, #__users as b WHERE a.user_id = b.id ORDER BY a.company ASC";
			$db->setQuery($sql);
			if (!$db->query()) {
				echo $db->stderr();
				return;
			}
			$advertisersloaded = $db->loadObjectList();
			
			//echo "<pre>";var_dump($advertisersloaded);die();

	    $advertisers 	= array_merge( $advertisers, $advertisersloaded );
		
		if(isset($_SESSION['advertiser_id']))
			$advertiser_id = $_SESSION['advertiser_id'];
		else	
			$advertiser_id = 0;
	    $lists['advertiser_id']  =  JHTML::_( 'select.genericlist', $advertisers, 'advertiser_id', 'class="inputbox" size="1"'.$javascript,'aid', 'company', $advertiser_id);
		//select advertisers drop-down 
		
		//select zone drop-down 
		$javascript = 'onchange="document.topform1.submit();"';
		$zones[] = JHTML::_('select.option',  "0", JText::_('AD_AGENCY_ALL_ZONES'), 'zoneid', 'z_title' );	

			$sql = "SELECT `zoneid`, `z_title` FROM #__ad_agency_zone ORDER BY `z_title` ASC";
			$db->setQuery($sql);
			if (!$db->query()) {
				echo $db->stderr();
				return;
			}
			$zonesloaded = $db->loadObjectList();

	    $zones 	= array_merge( $zones, $zonesloaded );
		
		if(isset($_SESSION['zone_id']))
			$zone_id = $_SESSION['zone_id'];
		else	
			$zone_id = 0;
			
	    $lists['zone_id']  =  JHTML::_( 'select.genericlist', $zones, 'zone_id', 'class="inputbox" size="1"'.$javascript,'zoneid', 'z_title', $zone_id);		
		//end select zone drop-down 
		
		$query = "SELECT params FROM #__ad_agency_settings ORDER BY id ASC LIMIT 1";
		$db->setQuery($query);
		$params = $db->loadResult();
		$params = @unserialize($params);
		if(isset($params['timeformat'])){
			$params = $params['timeformat'];
		} else { $params = "-1"; }
		
		//echo $params;die();
		$this->assignRef('params', $params);
		$this->assignRef('lists', $lists);
		
		parent::display($tpl);

	}
	
	function approve( &$row, $i, $imgY = 'tick.png', $imgX = 'publish_x.png', $prefix='' )
	{
		$imgP = "components/com_adagency/images/pending.gif";
		if($row->approved=='Y') {
			$img = 'images/'.$imgY;
			$task = "pending";
			$alt = JText::_('Approve');
			$action = JText::_('ADAG_CHTPEN');
		} elseif ($row->approved=='N') {
			$img = 'images/'.$imgX;
			$task = "approve";
			$alt = JText::_('Unapprove');
			$action = JText::_('Approve item');
		} elseif ($row->approved=='P') {
			$img = $imgP;
			$task = "unapprove";
			$alt = JText::_("ADAG_PENDING");
			$action = "Unnapprove Item";
		} else {return false;}

		/*$href = '
		<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $prefix.$task .'\')" title="'. $action .'">*/
		$href= '<img src="'. $img .'" border="0" alt="'. $alt .'" />';//</a>'
		;
		return $href;

	}

	function editForm($tpl = null) {

		$db =& JFactory::getDBO();
		$license =& $this->_models['adagencylicense']->getLicense();
		$isNew = isset($license->id)&&($license->id < 1);
		$text = $isNew?JText::_('New'):JText::_('Edit');

		JToolBarHelper::title(JText::_('License').":<small>[".$text."]</small>");
		JToolBarHelper::save();
		if ($isNew) {
			JToolBarHelper::cancel();

		} else {
			JToolBarHelper::cancel ('cancel', 'Close');

		}

		$this->assign("license", $license);

		$configs =& $this->_models['adagencyconfig']->getConfigs();
		$lists = array();

		$prods =& $this->_models['adagencyproduct']->getListProducts();
		$opts = array();
		$opts[] = JHTML::_('select.option',  "", JText::_("Select product") );
		foreach ( $prods as $prod ) {
			$opts[] = JHTML::_('select.option',  $prod->id, $prod->name );
		}
		$lists['productid'] = JHTML::_('select.genericlist',  $opts, 'productid', 'class="inputbox" size="1" ', 'value', 'text', isset($license->productid)?$license->productid:"");
		
		$this->assign("configs", $configs);
		$this->assign("lists", $lists);
		$this->assign("currency_options", array());
		$plugin_handler = new stdClass;
		$plugin_handler->encoding_plugins = array();
		$this->assign("plugin_handler", $plugin_handler);
		parent::display($tpl);


	}

}

?>