 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
	$k = 0;
	$n = count ($this->advertisers);
	require_once(JPATH_BASE.DS."components".DS."com_adagency".DS."helpers".DS."helper.php");
?>
	<form action="index.php?option=com_adagency&controller=adagencyAdvertisers" method="post"name="topform1">
	<table width="100%" cellpadding="5" cellspacing="5" bgcolor="#FFFFFF">
	  <tr>
	  	<td align="right" width="68%">
			<input type="text" name="search_advertiser" value="<?php if(isset($_SESSION['search_advertiser'])) echo $_SESSION['search_advertiser'];?>" />
			<input type="submit" name="submit_search" value="<?php echo JText::_('VIEWAD_SEARCHTXT');?>" />
		</td>
	  	<td align="right">
			<?php echo JText::_('VIEWAD_STATUS_SEARCH');?>
			<select name="advertiser_status" onChange="document.topform1.submit()">
				<option value="YN" <?php if (!isset($_SESSION['advertiser_status']) || $_SESSION['advertiser_status'] == 'YN') echo ' selected="selected" ';?>><?php echo JText::_('VIEWAD_SEARCH_SELECT');?></option>
				<option value="Y" <?php if (isset($_SESSION['advertiser_status']) && $_SESSION['advertiser_status'] == 'Y') echo ' selected="selected" ';?>><?php echo JText::_('VIEWAD_STATUS_SEARCH_APPROVED');?></option>
				<option value="N" <?php if (isset($_SESSION['advertiser_status']) && $_SESSION['advertiser_status'] == 'N') echo ' selected="selected" ';?>><?php echo JText::_('VIEWAD_STATUS_SEARCH_DISSAPPROVED');?></option>
				<option value="P" <?php if (isset($_SESSION['advertiser_status']) && $_SESSION['advertiser_status'] == 'P') echo ' selected="selected" ';?>><?php echo JText::_('ADAG_PENDING');?></option>
			</select>
		</td>
		<td align="right">
			<?php echo JText::_('ADAG_MBR_STS');?>
			<select name="advertiser_enable" onChange="document.topform1.submit()">
				<option value="-1" <?php if (!isset($_SESSION['advertiser_enable']) || $_SESSION['advertiser_enable'] == '-1') echo ' selected="selected" ';?>><?php echo JText::_('VIEWAD_SEARCH_SELECT'); ?></option>
				<option value="0" <?php if (isset($_SESSION['advertiser_enable']) && $_SESSION['advertiser_enable'] == '0') echo ' selected="selected" ';?>><?php echo JText::_('VIEWAD_STATUS_SEARCH_ENABLED');?></option>
				<option value="1" <?php if (isset($_SESSION['advertiser_enable']) && $_SESSION['advertiser_enable'] == '1') echo ' selected="selected" ';?>><?php echo JText::_('VIEWAD_STATUS_SEARCH_DISABLED');?></option>
			</select>
		</td>
	  </tr>
	 </table>
</form>

<form action="index.php" name="adminForm" method="post">
<div id="editcell" >
<table class="adminlist">
<thead>

	<tr>
		<th width="5">
			<input type="checkbox" onclick="checkAll(<?php echo $n; ?>)" name="toggle" value="" />
		</th>
	        <th width="20">
			<?php echo JText::_('VIEWADVERTISERID');?>
		</th>
		<th>
			<?php echo JText::_('VIEWADVERTISERCONTACT');?>
		</th>
		<th>
			<?php echo JText::_('VIEWADVERTISERAPPROVED');?>
		</th>

		<th>
			<?php echo JText::_('ADAG_USER');?>
		</th>

		<th>
			<?php echo JText::_('VIEWADVERTISERENABLED');?>
		</th>
		<th>
			<?php echo JText::_('VIEWADVERTISEREMAIL');?>
		</th>

		<th>
			<?php echo JText::_('ADAG_DATEADD');?>
		</th>

		<th>
			<?php echo JText::_('VIEWADVERTISERCAMPAIGNS');?>
		</th>
	</tr>
</thead>

<tbody>

<?php
	for ($i = 0; $i < $n; $i++):
	$advertiser =& $this->advertisers[$i];
	$id = $advertiser->aid;
	$uid = $advertiser->id;
	$checked = JHTML::_('grid.id', $i, $id);
	$link = JRoute::_("index.php?option=com_adagency&controller=adagencyAdvertisers&task=edit&cid[]=".$uid);
	$cmplink = JRoute::_("index.php?option=com_adagency&controller=adagencyCampaigns");
	$published = adagencyAdminViewadagencyAdvertisers::approve($advertiser, $i );
	$blocked = adagencyAdminViewadagencyAdvertisers::block($advertiser, $i );
?>
	<tr class="row<?php echo $k;?>">
	     	<td>
	     	    	<?php echo $checked;?>
		</td>

	     	<td>
	     	    	<?php echo $id;?>
		</td>
	     	<td>
	     	    	<a href="<?php echo $link;?>" ><?php echo $advertiser->name;?></a>
		</td>
		<td>
	     	    	<?php echo $published;?>
		</td>

		<td>
					<?php echo "<a target='_blank' href='index.php?option=com_users&task=user.edit&id=".$advertiser->user_id."'>".$advertiser->username."</a>";?>
		</td>

		<td>
	     	    	<?php echo $blocked;?>
		</td>
		<td>
	     	    	<?php echo $advertiser->email;?>
		</td>

		<td>
					<?php echo adagencyAdminHelper::formatime($advertiser->registerDate,$this->params['timeformat']); ?>
		</td>

		<td>
	     	    	<a href="<?php echo $cmplink;?>" ><?php echo $advertiser->count;?></a>
		</td>
	</tr>


<?php
		$k = 1 - $k;
	endfor;
?>

	<tr>
<td colspan="9"><?php echo $this->pagination->getListFooter(); ?></td>

</td>
</tr>

</tbody>


</table>

</div>

<input type="hidden" name="option" value="com_adagency" />
<input type="hidden" name="id" value="<?php echo $uid;?>"/>
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="controller" value="adagencyAdvertisers" />
</form>
