<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.application.component.view");

class adagencyAdminViewadagencyConfigs extends JView {
	function display ($tpl =  null ) {
		
		$db = & JFactory::getDBO();
		$configs =& $this->get('Configs');
		$configs->params = @unserialize($configs->params);
		$configs->payment = @unserialize($configs->payment);
		require_once( JPATH_COMPONENT.DS.'helpers'.DS.'sajax.php' );
		JToolBarHelper::title(JText::_('Settings'));
		JToolBarHelper::apply('apply', 'Apply');
		JToolBarHelper::save();
		JToolBarHelper::cancel ('cancel', 'Cancel');

		global $mainframe;
		$agmailfrom =  $mainframe->getCfg( 'mailfrom' );	
		$agfromname =  $mainframe->getCfg( 'fromname' );	
		
        $arr[] = JHTML::_('select.option', 999, JText::_('ADAG_UNLIMITED'));
        for ($i=1; $i <= 100; $i++) {
            $arr[] = JHTML::_('select.option',  $i, $i );
        }
        isset($configs->params['adslim']) ? $selected = $configs->params['adslim'] : $selected = NULL;
        $adslim = JHTML::_('select.genericlist',   $arr, 'params[adslim]', '', 'value', 'text', $selected );       
        
		if (isset($configs->show)){
			$show=explode(";",$configs->show);
		} else {$show = NULL;}
		
		if (isset($configs->mandatory)){
			$mandatory=explode(";",$configs->mandatory);
		} else {$mandatory = NULL;}
		
		if(count($show)>=2){ unset($show[count($show)-1]);}
		if(count($mandatory)>=2){ unset($mandatory[count($mandatory)-1]);}
		
		$configs->show = $show;
		$configs->mandatory = $mandatory;
		
		$this->assign("configs", $configs);		
		$this->assign("agmailfrom", $agmailfrom);
		$this->assign("agfromname", $agfromname);
		
		$data = JRequest::get('get');
		if(isset($data['task2'])) {
			if($data['task2']=='general') { $startOffset=0; }
			elseif ($data['task2']=='payments') { $startOffset=1; }
			elseif ($data['task2']=='email') { $startOffset=2; }
			elseif ($data['task2']=='content') { $startOffset=3; }
			elseif ($data['task2']=='overview') { $startOffset=4; }
			elseif ($data['task2']=='registration') { $startOffset=5;}
			elseif ($data['task2']=='approvals') { $startOffset=6; }
		} else {
			$startOffset=0; 
		}
		
		$this->assign("startOffset", $startOffset);	

		$agmailfrom=str_replace("'","''",$agmailfrom);
		$agfromname=str_replace("'","''",$agfromname);

		if ($configs->adminemail=="") { 
			$query="UPDATE #__ad_agency_settings SET `adminemail` = '".$agmailfrom."'";
			$db->setQuery($query);
			if(!$db->query()) {die($db->stderr());}
		}
		if ($configs->fromemail=="") {
			$query="UPDATE #__ad_agency_settings SET `fromemail` = '".$agmailfrom."'";
			$db->setQuery($query);
			if(!$db->query()) {die($db->stderr());}
		}
		if ($configs->fromname=="") {  
			$query="UPDATE #__ad_agency_settings SET `fromname` = '".$agfromname."'";
			$db->setQuery($query);
			if(!$db->query()) {die($db->stderr());}
		} 
		
		$respathfe = JPATH_ROOT.DS."language".DS."en-GB".DS."en-GB.com_adagency.ini";
		$respathbe = JPATH_ROOT.DS."administrator".DS."language".DS."en-GB".DS."en-GB.com_adagency.ini";
		
		$langfe = implode ("", file ($respathfe));
		$langbe = implode ("", file ($respathbe));
		
		$this->assign("langfe", $langfe);
		$this->assign("langbe", $langbe);
		
		
	$configs =& $this->_models['adagencyconfig']->getConfigs();
	//var_dump($configs);die();
	$database = & JFactory::getDBO();
	
	$query = "select distinct (currency_name), currency_full from #__ad_agency_currencies";
    $database->setQuery($query);
    $currs = $database->loadObjectList();
	
	$query = "select distinct (plugname) from #__ad_agency_currencies as dc, #__ad_agency_plugins as dp where dp.published=1 and dp.name=dc.plugname";
    $database->setQuery($query);
    $normal_plugs = $database->loadObjectList ();
	
	$default_currency = $configs->currencydef;
    $plugs = array ();
    $currency_list = '<select name="currencydef">';
    foreach ($currs as $i => $v){
        $query = "select dc.plugname from #__ad_agency_currencies as dc, #__ad_agency_plugins as dp where dc.currency_name='".$v->currency_name."' and dp.published=1 and dp.name=dc.plugname";
        $database->setQuery($query);

        $plugs[$v->currency_name][] = $database->loadObjectList();
        $currency_list .= '<option  value="'.$v->currency_name.'" ';
    if ($v->currency_name == $default_currency) 
            $currency_list .= 'selected';
         $currency_list .= '>'.$v->currency_full.'</option>';
    }
    $currency_list .= '</select>';
    
    $query = "select name from #__ad_agency_plugins where `def`='default'";
    $database->setQuery($query);
    $defaultplug = $database->loadResult();
	
    $this->assign('currency_list', $currency_list);
	$approvals =& $this->_models['adagencyconfig']->getApprovals();
		$plugin_data = & $this->_models['adagencyplugin']->BackPluginHandler();

        $this->assign('adslim', $adslim);
		$this->assign('approvals', $approvals);
    	$this->assign('plugin_data', $plugin_data);    
    	$this->assign('plugs', $plugs);    
    	$this->assign('default_currency', $default_currency);    
    	$this->assign('normal_plugs', $normal_plugs);    
    	$this->assign('defaultplug', $defaultplug);    
		parent::display($tpl);
	}
    
}

?>