<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
$orderid = $this->orderid;
$nullDate = 0;
$configs = $this->configs;
$lists = $this->lists;	
require_once(JPATH_BASE.DS."components".DS."com_adagency".DS."helpers".DS."helper.php");
$document = &JFactory::getDocument();
$document->addStyleSheet('components/com_adagency/css/joomla16.css');
$document->addStyleSheet(JURI::root()."components/com_adagency/includes/css/adag_tip.css");

?>
<?php include(JPATH_BASE."/components/com_adagency/includes/js/add_order.php"); ?>
 <form action="index.php" method="post" name="adminForm" id="adminForm">
	<fieldset class="adminform">
	<legend><?php echo JText::_('VIEWORDERSLICDET');?></legend>
    <table class="admintable adminform">
		<tr>
			<td width="130px">
			<?php echo JText::_('VIEWORDERSNUMBER'); ?>:
			</td>
			<td>
			<?php echo $orderid; ?>
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('VIEWORDERSNUMBER_TIP'); ?></span>
            </span>
			</td>
		</tr>
		<tr>
			<td width="130px">
			<?php echo JText::_('ADDORDERS_ADVERTISER'); ?>:
			</td>
			<td>
			<?php echo $lists['advertiser_id']; ?>
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('ADDORDERS_ADVERTISER_TIP'); ?></span>
            </span>
			</td>
		</tr>
		<tr>
			<td width="130px">
			<?php echo JText::_('ADDORDERS_PACKAGE'); ?>:
			</td>
			<td>
			<?php echo $lists['package_id']; ?>
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('ADDORDERS_PACKAGE_TIP'); ?></span>
            </span>
			</td>
		</tr>
		<tr>
			<td width="130px">
			<?php echo JText::_('AD_PAYMENT_METHOD'); ?>:
			</td>
			<td>
			<?php echo $lists['payment_method']; ?>
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('AD_PAYMENT_METHOD_TIP'); ?></span>
            </span>
			</td>
		</tr>
		<tr>
			<td width="130px">
			<?php echo JText::_('AD_PAYMENT_AMOUNT'); ?>:
			</td>
			<td>
			<input id="cost" class="inputbox" type="text" value="0" maxlength="20" size="8" name="cost" />&nbsp;
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('AD_PAYMENT_AMOUNT_TIP'); ?></span>
            </span>
			</td>
		</tr>		
		<tr>
			<td width="130px">
			<?php echo JText::_('AD_PAYMENT_DATE') ?>:
			</td>
			<td>
				<?php 
					if(($configs->params['timeformat']==1)||($configs->params['timeformat']==7)) {$ymd="%d-%m-%Y";}
					elseif(($configs->params['timeformat']==2)||($configs->params['timeformat']==8)) {$ymd="%d/%m/%Y";}
					elseif(($configs->params['timeformat']==3)||($configs->params['timeformat']==9)) {$ymd="%m-%d-%Y";}
					elseif(($configs->params['timeformat']==4)||($configs->params['timeformat']==10)) {$ymd="%m/%d/%Y";}
					elseif(($configs->params['timeformat']==5)||($configs->params['timeformat']==11)) {$ymd="%Y-%m-%d";}
					elseif(($configs->params['timeformat']==6)||($configs->params['timeformat']==12)) {$ymd="%Y/%m/%d";}
					else {$ymd="%d-%m-%Y";}
					$now_now=adagencyAdminHelper::formatime(date('Y-m-d h:m:s'),$configs->params['timeformat']);
					echo JHTML::_('calendar', $now_now, 'pay_date', 'pay_date', ''.$ymd.' %H:%M:%S', array('class'=>'inputbox', 'size'=>'25',  'maxlength'=>'19')); 
					echo "<input type='hidden' name='tfa' value='".$configs->params['timeformat']."' />";
					?>
                    <span class="adag_tip">
                        <img src="components/com_adagency/images/tooltip.png" border="0" />
                        <span><?php echo JText::_('AD_PAYMENT_DATE_TIP'); ?></span>
                    </span>
			</td>
		</tr>
		</table>

	</fieldset>

			<input type="hidden" name="images" value="" />                
	        <input type="hidden" name="option" value="com_adagency" />
	        <input type="hidden" name="id" value="" />
	        <input type="hidden" name="task" value="" />
			<input type="hidden" name="controller" value="adagencyOrders" />
        </form>
