 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
	$k = 0;
	$n = count ($this->orders);
	$configs = $this->configs;
	$lists = $this->lists;	
	$plugs = $this->plugs;	
	require_once(JPATH_BASE.DS."components".DS."com_adagency".DS."helpers".DS."helper.php");	
?>
	<form action="index.php?option=com_adagency&controller=adagencyOrders" method="post"name="topform1">
	<table width="100%" cellpadding="5" cellspacing="5" bgcolor="#FFFFFF">
	  <tr nowrap="nowrap">
		<td align="right" nowrap="nowrap"> 
			<input type="text" name="search_order" value="<?php if(isset($_SESSION['search_order'])) echo $_SESSION['search_order'];?>" />
			<input type="submit" name="submit_search" value="<?php echo JText::_('VIEWAD_SEARCHTXT');?>" />
		</td>
		<td align="right">
			<?php echo JText::_('VIEWAD_SEARCH_ADVERTISER');?>
			<?php echo $lists['advertiser_id'];	?>	
		</td>
		<td align="right">
			<?php echo JText::_('VIEWAD_SEARCH_PACKAGE');?>
			<?php echo $lists['package_id'];	?>	
		</td>
		<td align="right">
			<?php echo JText::_('VIEWAD_SEARCH_PAYMENT_METHOD');?>
			<?php echo $lists['payment_method'];	?>	
		</td>
		<td align="right">
			<?php echo JText::_('VIEWAD_STATUS_SEARCH');?>
			<select name="order_status" onChange="document.topform1.submit()">
				<option value="-1" <?php if (!isset($_SESSION['order_status']) || $_SESSION['order_status'] == '-1') echo ' selected="selected" ';?>><?php echo JText::_('VIEWAD_SEARCH_SELECT');?></option>
				<option value="0" <?php if (isset($_SESSION['order_status']) && $_SESSION['order_status'] == '0') echo ' selected="selected" ';?>><?php echo JText::_('VIEWORDERSPAID');?></option>
				<option value="1" <?php if (isset($_SESSION['order_status']) && $_SESSION['order_status'] == '1') echo ' selected="selected" ';?>><?php echo JText::_('VIEWORDERSPENDING');?></option>
			</select>
					
		</td>
	  </tr>
	 </table>
</form>

<form action="index.php" name="adminForm" method="post">
<div id="editcell" >
<table class="adminlist">
<thead>

	<tr>
		<th width="5">
			<input type="checkbox" onclick="checkAll(<?php echo $n; ?>)" name="toggle" value="" />
		</th>
	        <th width="20">
			<?php echo JText::_('VIEWORDERSID');?>
		</th>
		<th>
			<?php echo JText::_('VIEWORDERSADVERT');?>
		</th>
			<th>
			<?php echo JText::_('VIEWORDERSORDERDATE');?>
		</th>
		<th>
			<?php echo JText::_('VIEWORDERSPRICE');?>
		</th>
		<th>
			<?php echo JText::_('VIEWORDERSPACKAGE');?>
		</th>
		<th>
			<?php echo JText::_('VIEWORDERSMETHOD');?>
		</th>
		<th>
			<?php echo JText::_('VIEWORDERSSTATUS');?>
		</th>
		<th>
			<?php echo JText::_('VIEWORDERSACTIONS');?>
		</th>

	</tr>
</thead>

<tbody>

<?php 
	for ($i = 0; $i < $n; $i++):
		$order =& $this->orders[$i];
		$id = $order->oid;
		$checked = JHTML::_('grid.id', $i, $id);
		$link = JRoute::_("index.php?option=com_adagency&controller=adagencyOrders&task=edit&cid[]=".$id);
		$customerlink = JRoute::_("index.php?option=com_adagency&controller=adagencyAdvertisers&task=edit&cid[]=".$order->aid);
		$packagelink = JRoute::_("index.php?option=com_adagency&controller=adagencyPackages&task=edit&cid[]=".$order->tid);
		
?>
	<tr class="row<?php echo $k;?>"> 
	     	<td>
	     	    	<?php echo $checked;?>
		</td>		

	     	<td>
	     	    	<a href="index.php?option=com_adagency&controller=adagencyOrders&task=edit&cid[]=<?php echo $order->oid;?>"><?php echo $id;?></a>
		</td>		
	     	<td>
	     	    	<a href="<?php echo $link;?>" ><?php echo $order->company;?></a>
		</td>		
	     	<td>
	     	    	<?php  echo adagencyAdminHelper::formatime($order->order_date, $configs->params['timeformat']);?>
		</td>		

	     	<td>
	     	    	<?php echo $order->cost.'&nbsp;';
						if(isset($order->currency)&&($order->currency != NULL)) {
							echo $order->currency;
						} else {
							echo $configs->currencydef;
						}
					?>
		</td>		


	     	<td>
	     	    	<a href="<?php echo $packagelink;?>" ><?php echo $order->notes;?></a>
		</td>		
<td>
	     	    	<?php
					if ($order->alias == "2CO") $order->alias="twocheckout";
					$ok=0;
						foreach($plugs as $a_plug) {
							if($a_plug[0] == $order->alias.".php") { echo $a_plug[1]; $ok=1; }
							//break;
						}
						 
					if ($ok==0) echo $order->alias;
					$ok=0;
					?>
		</td>
<td>
	     	    	<?php if ($order->status=='paid') echo JText::_('VIEWORDERSPAID'); else echo JText::_('VIEWORDERSPENDING'); ?>
		</td>
<td>
	     	    	<?php if ($order->status=='paid') echo '<a onclick="return confirm(\'Are you sure you want to delete this order?\');" href="index.php?option=com_adagency&controller=adagencyOrders&task=remove&cid[]='.$order->oid.'">'.JText::_('VIEWORDERSDELETE').'</a>'; else echo '<a style="color:green" href="index.php?option=com_adagency&controller=adagencyOrders&task=confirm&cid[]='.$order->oid.'">'.JText::_('VIEWORDERSCONFIRM').'</a>'.'&nbsp;|&nbsp;'.'<a onclick="return confirm(\'Are you sure you want to delete this order?\');" href="index.php?option=com_adagency&controller=adagencyOrders&task=remove&cid[]='.$order->oid.'">'.JText::_('VIEWORDERSDELETE').'</a>'; ?>
		</td>
	</tr>


<?php 
		$k = 1 - $k;
	endfor;
?>
	<tr>
<td colspan="9"><?php echo $this->pagination->getListFooter(); ?></td>

</td>
</tr>


</tbody>


</table>

</div>

<input type="hidden" name="option" value="com_adagency" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="controller" value="adagencyOrders" />
</form>