<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
$editable=NULL;
$data = $this->data;
$type = $this->type;
$lists = $this->lists;
$package=$this->package;
$the_zones_positions=$this->available_positions;
$zones=$this->newzones;
//$hide = implode('|',$zones);

$oldzones=array();
if (isset($package->zones)) $oldzones = explode('|',$package->zones);

$nullDate = 0;
$configs = $this->configs;
if (!isset($type)) $type='cpm';
if (!isset($package->type)) $package->type=$type;

$document =& JFactory::getDocument();
$document->addScript( JURI::root()."components/com_adagency/includes/js/jquery.js" );
$document->addScript( JURI::root()."components/com_adagency/includes/js/jquery.adagency.js" );
// $document->addScript(JURI::base()."components/com_adagency/js/modal.js");
// $document->addStyleSheet(JURI::base()."components/com_adagency/css/modal.css");
$document->addStyleSheet(JURI::base()."components/com_adagency/css/joomla16.css");
$document->addStyleSheet(JURI::root()."components/com_adagency/includes/css/adag_tip.css");

?>

<?php include(JPATH_BASE."/components/com_adagency/includes/js/package.php"); ?>

 <form action="index.php" method="post" name="adminForm" id="adminForm">
	<fieldset class="adminform">
	<legend><?php echo ($package->tid > 0)?JText::_('VIEWPACKAGEEDIT'):JText::_('VIEWPACKAGENEW'); ?></legend>
	<table class="admintable adminform" border="0">
		<tr>
			<td width="15%">
			 <?php echo JText::_('VIEWPACKAGEDESC');?>:<font color="#ff0000">*</font>
			</td>
			<td>
			<input <?php if ($package->tid && $editable) echo 'readonly="readonly" style="background-color:transparent;border:0px solid white;"';?> class="inputbox" type="text" name="description" size="40" maxlength="255" value="<?php echo $package->description; ?>" />
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('VIEWPACKAGEDESC_TIP'); ?></span>
            </span>
			</td>
		</tr>

		<tr>
			<td width="15%" valign="top">
			 <?php echo JText::_('VIEWPACKAGE_DESCRIPTION');?>:
			</td>
			<td>
			<textarea name="pack_description" id="pack_description" wrap="physical" cols="40" rows="4"><?php echo stripslashes($package->pack_description);?></textarea>
            <span class="adag_tip" style="float:right; margin-right: 60%;">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('VIEWPACKAGE_DESCRIPTION_TIP'); ?></span>
            </span>
			</td>
		</tr>

		<tr>
			<td>
			<?php echo JText::_('VIEWPACKAGETYPE');?>:<font color="#ff0000">*</font>
			</td>
			<td><?php echo $lists['type']; ?>
                <span class="adag_tip">
                    <img src="components/com_adagency/images/tooltip.png" border="0" />
                    <span><?php echo JText::_('VIEWPACKAGETYPE_TIP'); ?></span>
                </span>
			</td>
		</tr>
		<?php if ($package->type=="fr") { ?>
		<tr>
			<td>
			<?php echo JText::_('VIEWPACKAGETERMS');?>:<font color="#ff0000">*</font>
			</td>
			<td><?php echo $lists['amount']; ?>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $lists['duration'] ?>
			</td>
		</tr>
		<?php } elseif ($package->type=="pc") { ?>
		<tr>
			<td>
			<?php echo JText::_('VIEWPACKAGETERMS');?>:<font color="#ff0000">*</font>
			</td>
			<td>
			<input <?php if ($package->tid && $editable) echo 'readonly="readonly" style="background-color:transparent;border:0px solid white;"';?> class="inputbox" type="text" name="quantity" size="8" maxlength="8" value="<?php echo $package->quantity; ?>" />&nbsp;<?php echo JText::_('AGENCYCLICKS');?>
			</td>
		</tr>
		<?php } else if ($package->type=="cpm") { ?>
			<td>
			<?php echo JText::_('VIEWPACKAGETERMS');?>:<font color="#ff0000">*</font>
			</td>
			<td>
			<input <?php if ($package->tid && $editable) echo 'readonly="readonly" style="background-color:transparent;border:0px solid white;"';?> class="inputbox" type="text" name="quantity" size="8" maxlength="10" value="<?php if ($package->quantity) {echo $package->quantity;} else {echo "10000";} ?>" />
			<?php //echo $lists['quantity']; ?>&nbsp;<?php echo JText::_('AGENCYIMPRESSIONS');?>
			</td>
		<?php } ?>

		<tr>
			<td valign="top">
			 <?php echo JText::_('VIEWPACKAGEPRICE');?>:<font color="#ff0000">*</font>
			</td>
            <td>
                <table cellpadding="0" cellspacing="0" id="package_price">
                    <tr>
                        <td>
                            <input type="radio" value="1" id="not_free" name="free" <?php if ($package->cost > 0) echo 'checked="checked"'; ?>>
                            <input onKeyDown="javascript:document.getElementById('not_free').checked=true;" <?php if ($package->tid && $editable) echo 'readonly="readonly" style="background-color:transparent;border:0px solid white;"';?> class="inputbox" type="text" id="cost" name="cost" size="8" maxlength="8" value="<?php echo $package->cost; ?>" />&nbsp;<?php echo $configs->currencydef; ?>&nbsp;&nbsp;
                            <span class="adag_tip">
                                <img src="components/com_adagency/images/tooltip.png" border="0" />
                                <span><?php echo JText::_('VIEWPACKAGEPRICE_TIP'); ?></span>
                            </span>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <input type="radio" value="0" name="free" id="is_free" <?php if ($package->cost == 0) echo 'checked="checked"'; ?> onClick="javascript:document.getElementById('cost').value=0;">
                            <label><?php echo JText::_('VIEWPACKAGE_PRICE_FREE');?></label>
                            <span class="adag_tip">
                                <img src="components/com_adagency/images/tooltip.png" border="0" />
                                <span><?php echo JText::_('VIEWPACKAGE_PRICE_FREE_TIP'); ?></span>
                            </span>
                            &nbsp;
                            <input type="checkbox" name="hide_after" value="1" <?php if($package->hide_after==1) {echo 'checked="checked"';} ?>/>
                            <label><?php echo JText::_('ADAG_HIDE_AFTER');?></label>
                            <span class="adag_tip">
                                <img src="components/com_adagency/images/tooltip.png" border="0" />
                                <span><?php echo JText::_('ADAG_HIDE_AFTER_TIP'); ?></span>
                            </span>
                        </td>
                    </tr>
                </table>
			</td>
		</tr>

		<tr>
			<td>
			 <?php echo JText::_('AD_PACK_VIS');?>:
			</td>
			<td>
			<?php //var_dump($package->visibility);die(); ?>
			<input type="radio" value="1" id="visible" name="visible" <?php
			if (isset($package->visibility) && ($package->visibility > 0)) {echo 'checked="checked"';}
			elseif(!isset($package->visibility)) {echo 'checked="checked"';}
            ?>>
            <label><?php echo JText::_('JAS_YES'); ?></label>
            <input type="radio" value="0" name="visible" id="not_visible" <?php if(isset($package->visibility) && ($package->visibility == 0)) echo 'checked="checked"'; ?>>
            <label><?php echo JText::_('JAS_NO'); ?></label>
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('ADAG_PACK_VISIBLE_TIP'); ?></span>
            </span>
			</td>
		</tr>

		<tr>
		<td valign="top">
		   <?php echo JText::_('VIEWPACKAGE_ZONES_INCLUDED');?>:<font color="#ff0000">*</font>
		</td>
		<td>
        <?php
            //echo $lists['location'];
            if(isset($zones)&&(is_array($zones))) {
                echo "<table cellpadding='0' cellspacing='0' id='package_zones'>";
                foreach($zones as $zone){
                    if(in_array($zone->zoneid,$this->sel_zones)) { $chk = " checked=\"checked\" ";} else { $chk = NULL; }
                        echo "<tr><td>";
                        echo "<input class=\"zlocations\" type=\"checkbox\" name=\"packz[]\" ".$chk." value=\"".$zone->zoneid."\" />&nbsp;&nbsp;<label>".$zone->z_title."</label><br />";
                        echo "</tr></td>";
                }
                echo "</table>";
            }
        ?>
        </td>
        </tr>

       <!-- <tr>
        	<td><a rel="{handler: 'iframe', size: {x: 800, y: 450}}"  class="modal"  href="index.php?option=com_adagency&controller=adagencyPackages&task=preview&tmpl=component&no_html=1&cid[]=<?php echo $package->tid; ?>"><?php echo JText::_('VIEWPACKAGE_ZONES_PREVIEW');?></a>
			</td>
            <td>&nbsp;</td>
        </tr>-->

		</table>
		<!--<div style='color: red; border:1px solid black; width:45%; padding:2px 5px 2px 20px;'><?php echo JText::_("AD_PACK_WARNING");?></div>-->

		<input type="hidden" name="tid" value="<?php echo $package->tid;?>" />
		<input type="hidden" name="option" value="com_adagency" />
		<input type="hidden" name="task" value="edit" />
		<input type="hidden" name="allzones" value="<?php //echo $hide; ?>" />
		<input type="hidden" name="published" value="1<?php //echo $published?>" />
		<input type="hidden" name="controller" value="adagencyPackages" />
        </form>
