 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.application.component.view");

class adagencyAdminViewadagencyZones extends JView {

	function display ($tpl =  null ) {
		$db =& JFactory::getDBO();
		JToolBarHelper::title(JText::_('ADAGENCY_ZONES_MANAGER'), 'generic.png');
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::editListX('duplicate',JText::_('ADAG_DUPLICATE'));
		JToolBarHelper::addNewX();
		JToolBarHelper::editListX();
		JToolBarHelper::deleteList();
		$configs =& $this->_models['adagencyconfig']->getConfigs();
		$this->assign("configs", $configs);
		//for the default zone
		$sql = "SELECT `id` FROM #__modules WHERE title='Ad Agency Zone'";
		$db->setQuery($sql);
		$exista = $db->loadResult();
		if (intval($exista) > 0) {
			$sqls = "SELECT `z_title` FROM #__ad_agency_zone WHERE zoneid='".$exista."'";
			$db->setQuery($sqls);
			$exists = $db->loadResult();
			if (!$exists) {
				$sqln = "INSERT INTO `#__ad_agency_zone` ( `zoneid` , `banners` , `z_title` , `z_ordering` , `z_position` , `show_title` , `suffix` ) VALUES ('".$exista."', '1', 'Ad Agency Zone', '0', 'left' , '1', '')";
				$db->setQuery($sqln);
				$db->query();
			}
		}
		//end default zone
		$javascript = 'onchange="document.topform1.submit();"';
		if(isset($_POST['module_position']))
			$module_position = $_POST['module_position'];
		else
			if(isset($_SESSION['module_position']))
				$module_position = $_SESSION['module_position'];
			else	
				$module_position =0;
		$positions[] = JHTML::_('select.option',  "0", trim(JText::_('AD_ZONES_ALL_POS')), 'position', 'position' );	
			$db =& JFactory::getDBO();
			$sql = "SELECT DISTINCT(position) FROM `#__modules` WHERE module ='mod_ijoomla_adagency_zone'";
			$db->setQuery($sql);
			if (!$db->query()) {
				echo $db->stderr();
				return;
			}
			$positionsloaded = $db->loadObjectList();
	    
        $positions 	= array_merge( $positions, $positionsloaded );
	    $lists['module_position']  =  JHTML::_( 'select.genericlist', $positions, 'module_position', 'class="inputbox" size="1"'.$javascript,'position', 'position', $module_position);
		$this->assignRef('lists', $lists);
		$zones =& $this->get('listZones');
		$pagination = & $this->get( 'Pagination' );
		$this->assignRef('pagination', $pagination);
		$this->assignRef('zones', $zones);
		parent::display($tpl);
	}

	function editForm($tpl = null) {
		$db =& JFactory::getDBO();
		$zone =& $this->get('zone');
		$zone->adparams = @unserialize($zone->adparams);
		$cids = JRequest::getVar('cid', array(0), 'method', 'array'); 
		$isNew = ($zone->zoneid < 1); 
		if($isNew) {
			$isLock = false;
		} else {
			$isLock = & $this->_models['adagencyzone']->getLockZone($zone->zoneid);
		}
		$text = $isNew?JText::_('New'):JText::_('Edit');
		$client	=& JApplicationHelper::getClientInfo(JRequest::getVar('client', '0', '', 'int'));
		$modul =& JTable::getInstance('module');
		if (!$isNew) $modul =& $this->_models['adagencyzone']->getTheModule($zone->zoneid);
		$clientid = $client->id;
		$positions = & $this->_models['adagencyzone']->getThePositions($clientid);
		$approved_ads = & $this->_models['adagencyzone']->getApprovedAds();
		JToolBarHelper::title(JText::_('AD_ZONE').":<small>[".$text."]</small>");
		JToolBarHelper::apply('apply', 'Apply');
		JToolBarHelper::save();
		if ($isNew) {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel ('cancel', 'Close');
		}
		$this->assign("zone", $zone);
		$configs =& $this->_models['adagencyconfig']->getConfigs();
		$lists = NULL;
		////////////////////
		$db =& JFactory::getDBO();
		$query = 'SELECT position, ordering, showtitle, title'
		. ' FROM #__modules'
		. ' WHERE 1=1'
		. ' ORDER BY ordering'
		;
		
		$db->setQuery( $query );
		if ( !($orders = $db->loadObjectList()) ) {
			echo $db->stderr();
			return false;
		}
		$orders2 	= array();
		$l = 0;
		$r = 0;
		for ($i=0, $n=count( $orders ); $i < $n; $i++) {
			$ord = 0;
			if (array_key_exists( $orders[$i]->position, $orders2 )) {
				$ord =count( array_keys( $orders2[$orders[$i]->position] ) ) + 1;
			}

			$orders2[$orders[$i]->position][] = JHTML::_('select.option',  $ord, $ord.'::'.addslashes( $orders[$i]->title ) );
		}
		// build the html select list for published
		if (!$isNew)
			$lists['published'] = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $modul[0]->published );
		else 
			$lists['published'] = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', '1' );
		// modified here from $modul->published to '1'
		// build the html select list for show title
		if (!$isNew)
			$lists['showtitle'] = JHTML::_('select.booleanlist',  'showtitle', 'class="inputbox"', $modul[0]->showtitle );
		else 
			$lists['showtitle'] = JHTML::_('select.booleanlist',  'showtitle', 'class="inputbox"', 0 );
		// build the html select list for keyword search		
		if (!$isNew)
			$lists['showkeyws'] = JHTML::_('select.booleanlist',  'keywords', 'class="inputbox"', $zone->keywords);
		else 
			$lists['showkeyws'] = JHTML::_('select.booleanlist',  'keywords', 'class="inputbox"', 0 );			
		// build the html select list for rotate banners
		if (!$isNew)
			$lists['rotatebanners'] = JHTML::_('select.booleanlist',  'rotatebanners', 'class="inputbox"', $zone->rotatebanners );
		else 
			$lists['rotatebanners'] = JHTML::_('select.booleanlist',  'rotatebanners', 'class="inputbox"', '0' );
						
		// build the html select list for rotate randomize
		if (!$isNew)
			$lists['rotaterandomize'] = JHTML::_('select.booleanlist',  'rotaterandomize', 'class="inputbox"', $zone->rotaterandomize );
		else 
			$lists['rotaterandomize'] = JHTML::_('select.booleanlist',  'rotaterandomize', 'class="inputbox"', '1' );						
		// get selected pages for $lists['selections']
		if ( $cids[0] ) {
			$query = 'SELECT menuid AS value'
			. ' FROM #__modules_menu'
			. ' WHERE moduleid = '.(int) $modul[0]->id
			;
			$db->setQuery( $query );
			$lookup = $db->loadObjectList();
			if (empty( $lookup )) {
				$lookup = array( JHTML::_('select.option',  '-1' ) );
				$modul[0]->pages = 'none';
			} elseif (count($lookup) == 1 && $lookup[0]->value == 0) {
				$modul[0]->pages = 'all'; 
			} else {
				$modul[0]->pages = null;
			}
		} else {
			$lookup = array( JHTML::_('select.option',  0, JText::_( 'All' ) ) );
			if (!$isNew)
				$modul[0]->pages = 'all';
			else 
				$modul->pages = 'all';
			
		}
	if (!$isNew) {
		if ( $modul[0]->access == 99 || $modul[0]->client_id == 1 ) {
			$lists['access'] 			= 'Administrator';
			$lists['selections'] 		= 'N/A';
		} else {
			if ( $client->id == '1' ) {
				$lists['access'] 		= 'N/A';
				$lists['selections'] 	= 'N/A';
			} else {	
				$lists['access'] 		= JHTML::_('list.accesslevel',  $modul[0] );
				$selections				= JHTML::_('menu.linkoptions');
				$lists['selections']	= JHTML::_('select.genericlist',   $selections, 'selections[]', 'class="inputbox" size="15" multiple="multiple"', 'value', 'text', $lookup, 'selections' );

			}
		}
	} else if ($isNew) {	
			if ( $modul->access == 99 || $modul->client_id == 1 ) {
			$lists['access'] 			= 'Administrator';
			$lists['selections'] 		= 'N/A';
		} else {
			if ( $client->id == '1' ) {
				$lists['access'] 		= 'N/A';
				$lists['selections'] 	= 'N/A';
			} else {
				$lists['access'] 		= JHTML::_('list.accesslevel',  $modul );
				$selections				= JHTML::_('menu.linkoptions');
				$lists['selections']	= JHTML::_('select.genericlist',   $selections, 'selections[]', 'class="inputbox" size="15" multiple="multiple"', 'value', 'text', $lookup, 'selections' );
			}
		}
	}
		//----------------------------------------------------------------------
		if ($zone->zoneid>0) { $cellpadding=$zone->cellpadding;} else {$cellpadding=1;} 
		$javascript='';
		$lists['adsinzone'] = JHTML::_('select.integerlist',   1, 25, 1, 'banners', $javascript, $zone->banners );
		$lists['cellpadding'] = JHTML::_('select.integerlist',   0, 25, 1, 'cellpadding', $javascript, $cellpadding);
		$lists['adsinzone_cols'] = JHTML::_('select.integerlist',   1, 25, 1, 'banners_cols', $javascript, $zone->banners_cols );
		$sel_packs = & $this->_models['adagencyzone']->getZonePacks2Select($zone->z_position);
		$sel_packsALL = & $this->_models['adagencyzone']->getZonePacks2SelectALL();
		
		//$defaultad=$zone->defaultad;
		$adlist[] 	= JHTML::_('select.option',  "0", JText::_('ADAG_NONE'), 'id', 'title' );	
		$adlist 	= array_merge( $adlist, $approved_ads );
		$lists['adlist'] = JHTML::_( 'select.genericlist', $adlist, 'defaultad', 'class="inputbox" size="1"','id', 'title', $zone->defaultad);		
		
		$jomsocial_positions = array('js_side_top','js_side_bottom','js_profile_top','js_profile_bottom','js_profile_side_top','js_profile_side_bottom','js_profile_feed_top','js_profile_feed_bottom','js_groups_side_top','js_groups_side_bottom');
		$positions 	= @array_unique(@array_merge( $positions, $jomsocial_positions ));
		@sort($positions);
		
		$zone->textadparams = @unserialize($zone->textadparams);
		
		if(!isset($zone->textadparams['ia'])) { $zone->textadparams['ia'] = 'l'; } 
		$alignments2[] = JHTML::_('select.option',  "t", JText::_('AD_TOP'), 'value', 'option' );	
		$alignments2[] = JHTML::_('select.option',  "l", JText::_('AD_LEFT'), 'value', 'option' );	
		$alignments2[] = JHTML::_('select.option',  "r", JText::_('AD_RIGHT'), 'value', 'option' );	
		$lists['ia']  =  JHTML::_( 'select.genericlist', $alignments2, 'textadparams[ia]', 'class="inputbox" size="1"','value', 'option', $zone->textadparams['ia']);
		
		if(!isset($zone->textadparams['wrap_img'])) { $zone->textadparams['wrap_img'] = '1'; }
		$wraps[] = JHTML::_('select.option',  "0", JText::_('JAS_NO'), 'value', 'option' );
		$wraps[] = JHTML::_('select.option',  "1", JText::_('JAS_YES'), 'value', 'option' );
		$lists['wrap_img'] = JHTML::_( 'select.genericlist', $wraps, 'textadparams[wrap_img]', 'class="inputbox" size="1"','value', 'option', $zone->textadparams['wrap_img']);
		
		if (!$isNew) {
			$this->assign("modul", $modul[0]);
		} else {
			$this->assign("modul", $modul);
		}
		$this->assign("isLock", $isLock);
		$this->assign("positions", $positions);
		$this->assign("orders2", $orders2);
		$this->assign("configs", $configs);
		$this->assign("lists", $lists);
		$this->assign("sel_pack",$sel_packs);
		$this->assign("sel_packALL",$sel_packsALL);
		parent::display($tpl);
	}

}
?>