<?php
/**
* @version		$Id: index.php 10381 2008-06-01 03:35:53Z pasamio $
* @package		Authorize.net payment gateway for ad agency
* @copyright		Copyright (C) 2010  osdcs.com. All rights reserved.
* @license		GNU/GPL, see license.txt
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/
//Languages:

define(OSDCS_ADAGENCY_AUTHORIZE_PROCESSING, 'Processing');
define(OSDCS_ADAGENCY_AUTHORIZE_HEADER , 'Header');
define(OSDCS_ADAGENCY_AUTHORIZE_CARD_NUMBER, 'Card number');
define(OSDCS_ADAGENCY_AUTHORIZE_EXP_DATE, 'Exp date');
define(OSDCS_ADAGENCY_AUTHORIZE_CVV2, 'CVV2');
define(OSDCS_ADAGENCY_AUTHORIZE_FIRST_NAME, 'First name');
define(OSDCS_ADAGENCY_AUTHORIZE_LAST_NAME, 'Last name');
define(OSDCS_ADAGENCY_AUTHORIZE_EMAIL, 'Email');
define(OSDCS_ADAGENCY_AUTHORIZE_AMOUNT, 'Amount');
define(OSDCS_ADAGENCY_AUTHORIZE_SUBMIT, 'Submit');



defined( '_JEXEC' ) or die( 'Restricted access' );

class authorizenet {
	
	function selfile (){
		return  "authorizenet_payment.php";	
	}
	function type () {
		return "payment";
	}

	function getBEData ($plugin_conf) {
        return $paypalform;
    }
    
    function writeto($file, $msg) {        
        $handle = @fopen( JPATH_BASE . DS . $file, "a");        
        @fwrite($handle, date('Y-m-d H:i:s') . ': ' . $msg."\n");
        @fclose($handle);    
    }    
	
    function insert_currency() {
        global $database;
        $currencies = array (
        'USD' => 'US Dollar (United States)'
        );
		return $currencies;
    }
    
   function deleteCurrency() {
        $database = JFactory::getDBO();
            
        $sql = "DELETE FROM #__digistore_currencies WHERE plugname='" . get_class($this) . "'";
        $database->setQuery($sql);
        $database->query();
    }
    
	function sandbox_support(){
		return 1;	
	}
	
	
	function getFEData ( $items, $tax, $redirect , $profile, $plugin_conf, $configs) {
    
        global $Itemid;
		
		$mosConfig_live_site = JURI::base();
		$sid = $profile->_sid;
        
		// echo "<pre>".print_r($profile,1)."</pre>";
		
        $firstname = $profile->_user->name;
        $lastname = "";
        $email = $profile->_user->email;
        
		$uid = $profile->_user_id;  
        
        $now = time();
		@session_start();
		$_SESSION['order_accepted'] = 0;

        //print_r($tax);
        
		$amount = $tax['taxed'];
		$currency = $tax['currency']; //$configs->currency;
		$secret = $plugin_conf->config->data['authorizenet_secret'];
		?>
			
	<script>
	function CheckAll(){
		correct = checkDate() && check(document.card_form.creditCardNumber.value) && checkCVV();
		if(correct){
			document.card_form.submitBtn.value="<?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_PROCESSING')?>";
			document.card_form.submitBtn.disabled="disabled";
			return true;
		}
		return false;	
		
	}
	function checkCVV(){
		var numeric = /^[0-9\,\.]+$/;
		if(!numeric.test(document.card_form.cvv2Number.value)){
			return false;
		}
		if(!(document.card_form.cvv2Number.value.length==3 || document.card_form.cvv2Number.value.length==4)){
			return false;
		}
		return true;
	} 
	function checkDate(){
		month = document.card_form.expDateMonth.value;
		year  = document.card_form.expDateYear.value;
		d = new Date();
		curr_month = d.getMonth()+1;
		curr_year =  d.getFullYear();
		if( curr_month>month && curr_year==year ){ return false;}
		else {return true;}
	}

	function validateDate(){
		if( !checkDate() ){
			//document.getElementById("checkDate").src="<?php echo $mosConfig_live_site?>/images/red.gif";
		}else{
			//document.getElementById("checkDate").src="<?php echo $mosConfig_live_site?>/images/green.gif";
		}
	}
	
	function validate(cardNumber){
		if(! check(cardNumber) ){
			//document.getElementById("check").src="<?php echo $mosConfig_live_site?>/images/red.gif";
		}else{
			//document.getElementById("check").src="<?php echo $mosConfig_live_site?>/images/green.gif";
		}
	}
	
function isCreditCard(cardNumber) {
  if (cardNumber.length > 19)
    return (false);

  if (cardNumber == 0)
	return (false);

  sum = 0; mul = 1; l = cardNumber.length;
  for (i = 0; i < l; i++) {
    digit = cardNumber.substring(l-i-1,l-i);
    tproduct = parseInt(digit ,10)*mul;
    if (tproduct >= 10)
      sum += (tproduct % 10) + 1;
    else
      sum += tproduct;
    if (mul == 1)
      mul++;
    else
      mul--;
  }
  if ((sum % 10) == 0)
    return (true);
  else
    return (false);

} 

function check(cardNumber)
{
	var alpha_numeric_space = /^[a-zA-Z0-9\s\-]+$/;
	var numeric = /^[0-9\,\.]+$/;
	var alpha = /^[a-zA-Z]+$/;
	var numeric_brackets = /^[0-9\(\)\s\-]+$/;
	var numeric_space_dash = /^[0-9\s\-]+$/;
	var alpha_dot = /^[a-zA-Z\.]+$/;
	var space_numeric = /^[0-9\,\.\s]+$/;

	errorflag = false;
	cardNumber = cardNumber.replace(/,/g,"");
	cardNumber = cardNumber.replace(/-/g,"");
	cardNumber = cardNumber.replace(/ /g,"");

	if(cardNumber.length < 12 || cardNumber.length > 19)
	{
		errorflag = true;
	}
	else
	{
		if (!numeric.test(cardNumber))
		{
			if(!space_numeric.test(cardNumber))
			{
				errorflag = true;
			}
			else
			{
				errorflag = true;
			}
		}
		else
		{
			if (!isCreditCard(cardNumber))
			{
				errorflag = true;
			}
		}
	}
	if (errorflag){ return false; }
	else{ return true; }
}
	</script>
	
			<form action="index.php?option=com_adagency&controller=adagencyCampaigns&task=notifyPayment&plugin=authorizenet" method="POST" onSubmit="JavaScript: return CheckAll();" name="card_form" id="card_form">
			<?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_HEADER');?> 
			<table>
			    <tr>
			        <td > 
			        	<?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_CARD_NUMBER');?> 
			       	</td>
			        <td>
			            <input class="inputbox" type="text" size="30" maxlength="19" AUTOCOMPLETE='off' name="creditCardNumber" value="" onKeyPress="JavaScript:validate(this.value)" onChange="JavaScript:validate(this.value)"/>
                    </td>
			        <td><!--img id="check" src="<?php echo $mosConfig_live_site?>/images/red.gif"-->
			        </td>
			    </tr>
			    <tr>
			        <td > <?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_EXP_DATE');?> </td>
			        <td>
			            <select class="inputbox" name="expDateMonth" onChange="JavaScript:validateDate()">
			            <option value="01">01</option>
			            <option value="02">02</option>
			            <option value="03">03</option>
			            <option value="04">04</option>
			            <option value="05">05</option>
			            <option value="06">06</option>
			            <option value="07">07</option>
	 		            <option value="08">08</option>
			            <option value="09">09</option>
			            <option value="10">10</option>
			            <option value="11">11</option>
			            <option value="12">12</option>
			            </select>
			            <select class="inputbox" name="expDateYear" onChange="JavaScript:validateDate()">
						<?php 
							$year=date('Y');
							for($i=0;$i<14;$i++){
								$val=intval($year)+intval($i);
								if($val<10){
									$val="0".$val;
								}
								echo "<option value=\"$val\">$val</option>";
							}
						?>
			            </select>
			        </td>
			        <td><!--img id="checkDate" src="<?php echo $mosConfig_live_site?>/images/red.gif"-->
		        </td>
			    </tr>
			    <tr>
			        <td> <?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_CVV2');?> </td>
			        <td>
			            <input class="inputbox" type="text" size="3" maxlength="4" name="cvv2Number" value="" />
			        </td>
			    </tr>
			    <tr>
			        <td> <?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_FIRST_NAME');?></td>
			        <td><input class="inputbox" type="text" size="30" maxlength="32" name="firstName" value="<?php echo (isset($firstname))?$firstname:''; ?>" /></td>
			    </tr>
			    <tr>
			        <td> <?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_LAST_NAME');?> </td>
			        <td><input class="inputbox" type="text" size="30" maxlength="32" name="lastName" value="<?php echo (isset($lastname))?$lastname:''; ?>" /></td>
			    </tr>
			    <tr>
			        <td> <?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_EMAIL');?> </td>
			        <td><input  class="inputbox" type="text" size="30" maxlength="60" name="email" value="<?php echo (isset($email))?$email:''; ?>" /></td>
			    </tr>
			    <tr>
			        <td> <?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_AMOUNT');?></td>
			        <td><?php echo "<b>".$amount." ".$currency."</b>";?></td>
			    <tr>
			        <td >
			        </td>
			        <td>
			            <input class="button" name='submitBtn' type="submit" value="<?php echo JText::_('OSDCS_ADAGENCY_AUTHORIZE_SUBMIT');?>" />
			        </td>
			    </tr>
			</table>
	
			<input type="hidden" name="amount" value="<?php echo $amount;?>"/>
			<input type="hidden" name="currency" value="<?php echo $currency;?>"/>
			<input type="hidden" name="sid" value="<?php echo $sid;?>"/>
			<input type="hidden" name="uid" value="<?php echo $uid;?>"/>
			<input type="hidden" name="Itemid" value="<?php echo $Itemid;?>"/>			
			<input type="hidden" name="hash" value="<?php echo md5($sid.":".$uid.":$amount:$currency:".$secret);?>"/>
<?php
            $descr = "";
            foreach ($items as $i => $item) {

				if ($i < 0) continue;
                
                $value=$i.$item->name.$item->oid."<|>".$item->name."<|><|>".$item->quantity."<|>".$item->amount."<|>Y";
                //echo '<input type="hidden" name="x_line_item" value="'.$value.'" /> ';
                $descr .= str_replace('"', "'",$item->name)."<br />\n";
            }
?>
            <input type="hidden" name="x_description" value="<?php echo $descr;?>" />
            
			</form>
	<?php

        
		@session_start();
		$_SESSION["myid"] = $uid; 
        return "&nbsp";    
    }
    
  function notify($plugin_conf, $cart, $configs, $plugin_handler){
  
        global $Itemid;
        
		$plugin_handler2=$plugin_handler;
		$plugin_handler2->_id = $plugin_conf->id;
		$plugin_conf2=$plugin_handler2->getPlugin();
		$secret = $plugin_conf2->config->data['authorizenet_secret'];
		$login = $plugin_conf2->config->data['authorizenet_login'];
		$key = $plugin_conf2->config->data['authorizenet_key'];
		$mosConfig_sitename=JApplication::getCfg('sitename');
		$sid=$_POST['sid'];		
        
        $my = JFactory::getUser();
        $f = fopen(JPATH_ROOT.DS."administrator/components/com_adagency/plugins/".$my->id.$my->name.".txt", "a+");
        //fwrite ($f, print_r($_REQUEST, true));
        //start Robs IP Tracking Code
        $det_ip_addr = $_SERVER['REMOTE_ADDR'];
        fwrite ($f, print_r("Base Detected IP:", true));
        fwrite ($f, print_r($det_ip_addr, true));
        fwrite ($f, print_r("\nAdvanced Detected IP:", true));
            if (!empty($_SERVER['HTTP_CLIENT_IP']))   //check ip from share internet
            {
              $ip=$_SERVER['HTTP_CLIENT_IP'];
            }
            elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   //to check ip is pass from proxy
            {
              $ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
            }
            else
            {
              $ip=$_SERVER['REMOTE_ADDR'];
            }
        fwrite ($f, print_r($ip, true));
        fwrite ($f, print_r("\n", true));   
        //end robs IP tracking code
        

  		if(md5($_POST['sid'].":".$_POST['uid'].":".$_POST['amount'].":".$_POST['currency'].":".$secret) == $_POST['hash']){
                						$txn_id = date("Y-m-D H:i:s");
                						$ccnum=$_POST['creditCardNumber'];
      									$ccnum=str_replace(" ","",$ccnum);
      									$ccnum=str_replace("-","",$ccnum);
      									$ccnum=str_replace(",","",$ccnum);
                						$params = "x_login=".urlencode($login)
                								."&x_tran_key=".urlencode($key)
                								."&x_version=3.1"
                								."&x_type=AUTH_CAPTURE"
                								."&x_method=CC" 
                								."&x_recurring_billing=FALSE"               								
                								."&x_amount=".urlencode($_POST['amount'])
                								."&x_card_num=".urlencode($ccnum)
                								."&x_exp_date=".urlencode($_POST['expDateMonth'].$_POST['expDateYear'])                						
                								."&x_card_code=".$_POST['cvv2Number']
                								."&x_invoice_num=".urlencode($txn_id)
                								."&x_description=".urlencode("Payment to $mosConfig_sitename")
                								."&x_first_name=".urlencode($_POST['firstName'])
												."&x_last_name=".urlencode($_POST['lastName'])
												."&x_delim_data=TRUE"
												."&x_email=".$_POST['email']
												."&x_delim_char=|";
										$host = 'secure.authorize.net';			
										if($plugin_conf->sandbox=="1"){
											$host = 'test.authorize.net';
										}
										$port = 443;
										$path = "/gateway/transact.dll";
										if( function_exists( "curl_init" )) {                                       
                                                
												$ch = curl_init();
												curl_setopt($ch, CURLOPT_URL, "https://".$host.$path);
										        curl_setopt($ch, CURLOPT_HEADER, 0);
										        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); 
												curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  FALSE); 
												curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
												curl_setopt($ch, CURLOPT_POST, 1); 
												curl_setopt($ch, CURLOPT_POSTFIELDS, $params); 
												if(JText::_("OSDCS_ADAGENCY_AUTHORIZE_GODADDY") == "1"){
													curl_setopt($ch, CURLOPT_VERBOSE, 1);
													curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL, TRUE);
													curl_setopt($ch, CURLOPT_PROXYTYPE, CURLPROXY_HTTP);
													curl_setopt($ch, CURLOPT_PROXY,"http://proxy.shr.secureserver.net:3128");
													curl_setopt($ch, CURLOPT_TIMEOUT, 120);
												}

												$result = curl_exec( $ch );

												$error = curl_error( $ch );
		
												curl_close($ch);
												if( !empty( $error )) {
													$this->return2($plugin_conf, $sid, $configs, $plugin_handler);
												}
												
										} else {
												$fp = fsockopen("ssl://".$host, $port, $errno, $errstr, $timeout = 60);
												if(!$fp){

													$this->return2($plugin_conf, $sid, $configs, $plugin_handler);
													
												} else {
													fputs($fp, "POST $path HTTP/1.1\r\n");
													fputs($fp, "Host: $host\r\n");
													fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
													fputs($fp, "Content-length: ".strlen($params)."\r\n");
													fputs($fp, "Connection: close\r\n\r\n");
													fputs($fp, $params . "\r\n\r\n");
													$str = '';
													while(!feof($fp) && !stristr($str, 'content-length')) {
														$str = fgets($fp, 4096);
													}
													if (!stristr($str, 'content-length')) {
														$this->return2($plugin_conf, $sid, $configs, $plugin_handler);
													}
													$data = "";
													while (!feof($fp)) {
														$data .= fgets ($fp, 1024);
													}
													$result = trim( $data );
													fclose($fp);
									          }
									    }
                                        
									    $response = explode("|", $result);
                                        
                                        //print_r($response); die;
				
										if( $response[0]=="1" ) {
											$now=time();
											//$customer = $plugin_handler->loadCustomer($sid);
									        //$items = $cart->getCartItems( $customer, $configs );
fwrite ($f, print_r($items, true));                                            
									        //$orderid = $plugin_handler->addOrder($items, $customer, $now, 'authorizenet');
//fwrite ($f, mysql_error());                                            
										    //$plugin_handler->addLicenses($items, $orderid, $now, $customer);
//fwrite ($f, mysql_error());
fclose($f);                                            
											$this->return1($plugin_conf, $sid, $configs, $plugin_handler);
										}else {
fclose($f);                                        
											$this->return2($plugin_conf, $sid, $configs, $plugin_handler);
										}
		}else{
fclose($f);        
			$this->return2($plugin_conf, $sid, $configs, $plugin_handler);
		}
		
	}

	function return1 ($plugin_conf, $sid, $configs, $plugin_handler) {
		$plugin_handler->goToSuccessURL ($sid);
	 	return;
    }

    function return2 ($plugin_conf, $sid, $configs, $plugin_handler) {
        $plugin_handler->goToFailedURL($sid);
        return;
    }
    

	function get_info () {
		$info = JText::_("OSDCS_ADAGENCY_ADAGENCY_PLUGIN_" . strtoupper(get_class($this)) . "_PAYMENT");
		return $info;
	}

}

?>