 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ('joomla.application.component.controller');

class adagencyAdminControlleradagencyConfigs extends adagencyAdminController {

	var $_model = null;
	
	function __construct () {
		parent::__construct();
		require_once( JPATH_COMPONENT.DS.'helpers'.DS.'helper.php' );
		$this->registerTask ("", "listConfigs");
		$this->registerTask("general", "listConfigs");
		$this->registerTask("payments", "listConfigs");
		$this->registerTask("content", "listConfigs");
		$this->_model =& $this->getModel("adagencyConfig");
	}

	function listConfigs() {
		$view = $this->getView("adagencyConfigs", "html");
		$view->setModel($this->_model, true);
		$model =& $this->getModel("adagencyPlugin");
		$view->setModel($model);
		$view->display();
	}

	function save () {
		if ($this->_model->store() ) {
			$msg = JText::_('CONFIGSAVED');
		} else {
			$msg = JText::_('');
		}
		$link = "index.php?option=com_adagency";
		$this->setRedirect($link, $msg);
	}
	
	function apply () {
		$tab = JRequest::getVar('tab');
		if ($this->_model->store() ) {
			$msg = JText::_('CONFIGSAVED');
		} else {
			$msg = JText::_('');
		}
		if(isset($_POST['task2'])&&($_POST['task2']!='')){ $task2="&task2=".$_POST['task2'];} else { $task2 = NULL;}
		if(isset($tab)&&($tab != NULL)&&($tab !='')) {
			$pieces = explode('-',$tab);
			$task2 = '&task2='.$pieces[0];
		} 
		//echo "<pre>";var_dump($_POST);echo "<hr />";var_dump($tab);echo "<hr />";var_dump($task2);echo "<hr />";die();
		$link = "index.php?option=com_adagency&controller=adagencyConfigs".$task2;
		$this->setRedirect($link, $msg);
	}
	
};
?>