<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.aplication.component.model");

function fk_slashes($string) {
    while(strstr($string, '\\')) {
        $string = stripslashes($string);
    }
    return $string;
}

class adagencyAdminModeladagencyConfig extends JModel {
	var $_configs = null;
	var $_id = null;

	function __construct () {
		parent::__construct();
		$this->_id = 1;
	}

	function getConfigs() {
		if ( empty($this->_configs) ) {
			$this->_configs =& $this->getTable("adagencyConfig");
			$this->_configs->load( $this->_id );
		}
		return $this->_configs;
	}
	
	function getConf() {
		$db = & JFactory::getDBO();
		$sql = "SELECT * FROM #__ad_agency_settings LIMIT 1";
		$db->setQuery( $sql );
		$result = $db->loadObject();
		return $result;
	}
		
	function getApprovals() {
		$db = & JFactory::getDBO();	
		
		$query = "SHOW columns FROM #__ad_agency_banners WHERE field='approved'";
		$db->setQuery( $query );
		$result = $db->loadRow();
		$approval['ads'] = $result[4];
		
		$query = "SHOW columns FROM #__ad_agency_advertis WHERE field='approved'";
		$db->setQuery( $query );
		$result = $db->loadRow();
		$approval['adv'] = $result[4];
		
		$query = "SHOW columns FROM #__ad_agency_campaign WHERE field='approved'";
		$db->setQuery( $query );
		$result = $db->loadRow();
		$approval['cmp'] = $result[4];
		
		return $approval;
	}
	
	function getAdvById($id){
		$db = &JFactory::getDBO();
		$id = intval($id);
		$sql = "SELECT * FROM #__ad_agency_advertis WHERE aid = " . $id;
		$db->setQuery( $sql );
		$res =  $db->loadObject();
		return $res;
	}	
	
	function store() {
		$item =& $this->getTable('adagencyConfig');
		$imagepath = str_replace("/administrator", "", JPATH_BASE);
		$imagepath = $imagepath . "/images/stories/";
		$data = JRequest::get('post');
		$newimgfolder = $data['imgfolder'];
		if ( !is_dir ( $imagepath.$newimgfolder ) ) {
	       @mkdir ( $imagepath . "/" . $newimgfolder );
	       @chmod ( $imagepath . "/" . $newimgfolder, 0755 ); 
        } else {
	       @chmod ( $imagepath . "/" . $newimgfolder, 0755 ); 
	    }    
		isset($data['allowstand']) ? $data['allowstand'] = 1 : $data['allowstand'] = 0;
		isset($data['allowadcode']) ? $data['allowadcode'] = 1 : $data['allowadcode'] = 0;
		isset($data['allowpopup']) ? $data['allowpopup'] = 1 : $data['allowpopup'] = 0;
		isset($data['allowswf']) ? $data['allowswf'] = 1 : $data['allowswf'] = 0;
		isset($data['allowtxtlink']) ? $data['allowtxtlink']=1 : $data['allowtxtlink'] = 0;
		isset($data['allowtrans']) ? $data['allowtrans']=1 : $data['allowtrans'] = 0;
		isset($data['allowfloat']) ? $data['allowfloat']=1 : $data['allowfloat'] = 0;
		$data['payment'] = @serialize($data['payment']);
		$show = ''; $mandatory = '';
		$database = & JFactory::getDBO();
		if (isset($data['show'])) {
			foreach ($data['show'] as $key => $value) {
				if ($value == 1) { $show.=$key . ';'; }
			}
		}
		if ( isset($data['mandatory']) ) {
			foreach ($data['mandatory'] as $key => $value) {
				if($value==1) {$mandatory.=$key.';';}
			}
		}

		$data['params'] = @serialize($data['params']);
		$data['show'] = $show;
		$data['mandatory'] = $mandatory;
		
		$data['txtafterreg'] = JRequest::getVar("txtafterreg", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodyafterreg'] = JRequest::getVar("bodyafterreg", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodyafterregaa'] = JRequest::getVar("bodyafterregaa", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodyactivation'] = JRequest::getVar("bodyactivation", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodyrep'] = JRequest::getVar("bodyrep", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodycmpappv'] = JRequest::getVar("bodycmpappv", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodycmpdis'] = JRequest::getVar("bodycmpdis", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodyadappv'] = JRequest::getVar("bodyadappv", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodyaddisap'] = JRequest::getVar("bodyaddisap", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodyadvdis'] = JRequest::getVar("bodyadvdis", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodynewad'] = JRequest::getVar("bodynewad", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodynewcmp'] = JRequest::getVar("bodynewcmp", "", "post", "string", JREQUEST_ALLOWHTML);	
		$data['bodycmpex'] = JRequest::getVar("bodycmpex", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['bodynewuser'] = JRequest::getVar("bodynewuser", "", "post", "string", JREQUEST_ALLOWHTML);
		$data['overviewcontent'] = JRequest::getVar("overviewcontent", "", "post", "string", JREQUEST_ALLOWHTML);	
		$data['sbcmpexpadm'] = JRequest::getVar("sbcmpexpadm", "", "post", "string", JREQUEST_ALLOWHTML);	
		$data['bodycmpexpadm'] = JRequest::getVar("bodycmpexpadm", "", "post", "string", JREQUEST_ALLOWHTML);		
		
        $data['txtafterreg'] = fk_slashes($data['txtafterreg']);
        $data['bodyafterreg'] = fk_slashes($data['bodyafterreg']);
        $data['bodyafterregaa'] = fk_slashes($data['bodyafterregaa']);				
        $data['bodyactivation'] = fk_slashes($data['bodyactivation']);
        $data['bodyrep'] = fk_slashes($data['bodyrep']);
        $data['bodycmpappv'] = fk_slashes($data['bodycmpappv']);
        $data['bodycmpdis'] = fk_slashes($data['bodycmpdis']);
        $data['bodyadappv'] = fk_slashes($data['bodyadappv']);
        $data['bodyaddisap'] = fk_slashes($data['bodyaddisap']);
        $data['bodyadvdis'] = fk_slashes($data['bodyadvdis']);
        $data['bodynewad'] = fk_slashes($data['bodynewad']);
        $data['bodynewcmp'] = fk_slashes($data['bodynewcmp']);
        $data['bodycmpex'] = fk_slashes($data['bodycmpex']);
        $data['bodynewuser'] = fk_slashes($data['bodynewuser']);
    	$data['overviewcontent'] = fk_slashes($data['overviewcontent']);
        $data['sbcmpexpadm'] = fk_slashes($data['sbcmpexpadm']);
    	$data['bodycmpexpadm'] = fk_slashes($data['bodycmpexpadm']);
		
		if (!$item->bind($data)){
			return JError::raiseError( 500, $database->getErrorMsg() );
			return false;
		} 
		if (!$item->check()) {
			return JError::raiseError( 500, $database->getErrorMsg() );
			return false;
		}
		if (!$item->store()) {
			return JError::raiseError( 500, $database->getErrorMsg() );
			return false;
		}
		$respathfe = JPATH_ROOT.DS."language".DS."en-GB".DS."en-GB.com_adagency.ini";
		$respathbe = JPATH_ROOT.DS."administrator".DS."language".DS."en-GB".DS."en-GB.com_adagency.ini";

		/*Salvam LANGUAGE*/
		$textfe = fk_slashes($_POST["filecontentFE"]);
		$f = fopen ($respathfe, "w");
		fwrite ($f, $textfe);
		fclose ($f);
		$textbe = fk_slashes($_POST["filecontentBE"]);
		$g = fopen ($respathbe, "w");
		fwrite ($g, $textbe);
		fclose ($g);
		
		/*Salvam PLUGIN*/
		$plugin_handler = adagencyAdminModeladagencyConfig::makePluginList();
	    if (count($plugin_handler) > 0 )
	    foreach ($plugin_handler as $name => $plugin) {	    
	        $name = $plugin->name;
	        $value = JRequest::getVar($name."_account", array(0), 'array');
	        $value = implode (" ", $value);
	        $default = JRequest::getVar("default", null, 'post');
	        $sandbox    = JRequest::getVar($name."_sandbox", 0, 'post');
	        $reqhttps = JRequest::getVar($name."_reqhttps", 0, 'post');
	        $default = substr( $default, 0, strlen($default) - 4 ) ;
	        $value = $database->getEscaped($value);
	        if ($plugin->type == 'encoding' && file_exists($value)) {
	            $query = "update #__ad_agency_plugins set value='{$value}', sandbox='{$sandbox}' where name='{$name}';";
	        }  else if ($plugin->type !='encoding'){
	            $query = "update #__ad_agency_plugins set value='{$value}', sandbox='{$sandbox}', reqhttps='{$reqhttps}' where name='{$name}';";  
	           } else {
	            $query = '';
	        }
	        $database->setQuery($query);
	        $database->query();
	        $query = "update #__ad_agency_plugins set def='' where def='default';"; 
	        $database->setQuery($query);
	        $database->query();
	        $query = "update #__ad_agency_plugins set def='default' where name='".$default."';";    
	        $database->setQuery($query);
	        $database->query();
	    }
		
		if(isset($data['aa'])){
			foreach($data['aa'] as $key=>$value){
				$query="ALTER TABLE `#__ad_agency_".$key."` CHANGE `approved` `approved` ENUM( 'Y', 'N', 'P' ) CHARACTER SET latin1 COLLATE latin1_swedish_ci NULL DEFAULT '".$value."'";
				$database->setQuery($query);
				$database->query();
			}
		}
		
		return true;
	}	
	
	function makePluginList () {
		$database = JFactory::getDBO();	
		$plugin_path = JPATH_ROOT.'/administrator/components/com_adagency/plugins/';
		if ( is_dir ($plugin_path) ) {
			$plugin_dir = opendir($plugin_path);
			while ( ($plugin_file = readdir ($plugin_dir) ) ) {
				if (substr ($plugin_file, -3) == 'php' ) {
					//Select plugin data for current filename from database.
					$query = "select * from #__ad_agency_plugins where filename='".$plugin_file."'";
					$database->setQuery($query);
					$res = $database->loadObjectList();
					//If no entry for this file - remove it.
					if (!isset($res[0]) ) {
						@unlink (JPATH_ROOT."/administrator/components/com_adagency/plugins".$plugin_file);				
					} else {
						$plugins[$res[0]->name] = $res[0];
					}
				} //if substr
			} //while readdir
			closedir($plugin_dir);
		}// if plugin_path
		return $plugins;
	}

};
?>