<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class paypal {

    function selfile () {
        return  "paypal_payment.php";   
    }
    
    function writeto($file, $msg) {        
        $handle = @fopen( JPATH_BASE . DS . $file, "a");        
        @fwrite($handle, date('Y-m-d H:i:s') . ': ' . $msg."\n");
        @fclose($handle);    
    }    

    function type () {
        return "payment";
    }

    function getBEData ($plugin_conf) {
        return $paypalform;
    }
    
    function insert_currency() {       
        $currencies = array (
        	'USD' => 'U.S. Dollar',
        	'AUD' => 'Australian Dollar',
        	'CAD' => 'Canadian Dollar',
        	'CHF' => 'Swiss Franc',
        	'CZK' => 'Czech Koruna',
        	'DKK' => 'Danish Krone',
        	'EUR' => 'Euro',
        	'GBP' => 'Pound Sterling',
        	'HKD' => 'Hong Kong Dollar',
        	'HUF' => 'Hungarian Forint',
        	'JPY' => 'Japanese Yen',
        	'NOK' => 'Norwegian Krone',
        	'NZD' => 'New Zealand Dollar',
        	'PLN' => 'Polish Zloty',
        	'SEK' => 'Swedish Krona',
        	'SGD' => 'Singapore Dollar'
        );

        return $currencies;        
        //echo $database->getQuery();
    }    
    
    function deleteCurrency() {
       $database = JFactory::getDBO();
            
        $sql = "DELETE FROM #__adagency_currencies WHERE plugname='" . get_class($this) . "'";
        $database->setQuery($sql);
        $database->query();
        //echo $database->getQuery(); die;
        //echo $database->getQuery(); die;

    }

	function sandbox_support(){
		return 1;	
	}
	
    function getFEData ( $items, $tax, $redirect , $profile, $plugin_conf, $configs) {
    
		$page_itemid = JRequest::getInt('Itemid','0');
		if($page_itemid != '0'){
			$Itemid = "&Itemid=".$page_itemid;
		} else {
			$Itemid = NULL;
		}
	
        $db = JFactory::getDBO();
		$mosConfig_live_site = JURI::base(); 
   		$cust_info = $profile;
		$configs->currency = $tax['currency'];
	    $tax1 = $tax;
        
        //check to see if this client has purchased this product
        
        $sid = $profile->_sid;
        $uid = $profile->_user_id;      
        
		@session_start();
		$_SESSION['order_accepted'] = 0;
		//paypal have no "failed url, but only url for cancel payment

		$failed_url = $mosConfig_live_site.'index.php?option=com_adagency&controller=adagencyCampaigns&task=failPayment&plugin=paypal&custom='.$uid.';'.$sid.$Itemid;

		if ($plugin_conf->sandbox == 1) $paypal_url = '<form action="https://www.sandbox.paypal.com/cgi-bin/webscr" method="post" name="paymentForm">';
			else $paypal_url = '<form action="https://www.paypal.com/cgi-bin/webscr" method="post" name="paymentForm">';
        $content = $paypal_url.'
        <!-- <input type="hidden" name="cmd" value="_xclick"> -->
			<input type="hidden" name="cmd" value="_cart">
			<input type="hidden" name="upload" value="1">  
            <input type="hidden" name="business" value="'.$plugin_conf->config->data['paypal_email'].'">
		<!--
            <input type="hidden" name="item_name" value="iJoomla products">
            <input type="hidden" name="item_number" value="1">
		-->';
		$i = 0;
		$total1 = 0;

		foreach ( $items as $i => $item) {
			if ($i < 0) continue;
			++$i;
            $price = $item->amount/$item->quantity;
          	
			$content .= '<input type="hidden" name="item_name_'.$i.'" value="'.str_replace('"', "'", $item->name).'">';                       
			$content .= '<input type="hidden" name="amount_'.$i.'" value="'.sprintf("%.2f",$price).'">';
			$content .= '<input type="hidden" name="quantity_'.$i.'" value="'.$item->quantity.'">';
        }
     
        $tax = $tax['value'];//$total - $total1;

        /*if (((float )$tax1['value']) > 0) $content .= '<input type="hidden" name="tax_cart" value="'.sprintf("%.2f",round($tax1['value'], 2)).'" >';*/
		
		$content .= '
            <input type="hidden" name="no_note" value="1">
            <input type="hidden" name="currency_code" value="'.$configs->currency.'">
            <input type="hidden" name="bn" value="PP-BuyNowBF">
            <input type="hidden" name="notify_url" value="'.$mosConfig_live_site.'index.php?option=com_adagency&controller=adagencyCampaigns&task=notifyPayment&plugin=paypal&no_html=1&custom='.$uid.';'.$sid.'">
            <input type="hidden" name="return" value="'.$mosConfig_live_site.'index.php?option=com_adagency&controller=adagencyCampaigns&task=returnPayment&plugin=paypal&custom='.$uid.';'.$sid.$Itemid.'">
            <input type="hidden" name="cancel_return" value="'.$failed_url.'">
            <input type="hidden" name="rm" value="2" >
			<!--<input type="hidden" name="return_method" value="2" >-->
            <input type="hidden" name="custom" value="'.$uid.';'.$sid.';">
            <img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.png" width="1" height="1">
        ';

        if ( $redirect ) {
            $content .= '<input type="image" src="https://www.paypal.com/en_US/i/btn/x-click-but6.png" border="0" name="submit" alt="'.(JText::_('DSPAYMENT_WITH_PAYPAL')).'">';
        } else {
            $content .= '<!--<input type="submit" name="submit" value="Pay by PayPal">-->';
        }
        $content .= '</form>';
        if ( $redirect ) {
            $content .='<script>document.paymentForm.submit();</script>';
        }

		$_SESSION["myid"] = $uid; 
        return $content;    
    }
    
    function getIP() {
		if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		else if (isset($_SERVER['REMOTE_ADDR'])) $ip = $_SERVER['REMOTE_ADDR'];
		else $ip = "UNKNOWN";
		return $ip;
	}  
    
    function whoIs() {
    	// Get the Internet host name corresponding to a given IP address 
    	return gethostbyaddr($this->getIp());
    }
    
    function checkIdentity($who_is){
    	// Check the server host name to see if it matches
    	$pattern = "/$notify.paypal.com/";
    	if(preg_match($pattern, $who_is)) {
        	return true;
        } else {
        	return false;
        }
    }
    
    function checkAndUpdate() {
        $db = & JFactory::getDBO();
        $post = JRequest::get('post');
        $get = JRequest::get('get');

	    // Check if server is indeed PayPal or not
    	$is_paypal = $this->checkIdentity($this->whoIs());        
        if(!$is_paypal) {
        	return false;
        }
        // Check the payment status
        if(strtolower($post['payment_status']) != 'completed') {
			return false;
        }
        
        $cost = $db->getEscaped($post['mc_gross']);
        $currency = $db->getEscaped($post['mc_currency']);
        $data = split(";", $get['custom']);
        $order_id = (int)$db->getEscaped($data[1]);
        $user_id = (int)$db->getEscaped($data[0]);
        
        $sql = "SELECT aid FROM #__ad_agency_advertis WHERE user_id = $user_id ";
        $db->setQuery($sql);
        $advertiser_id = $db->loadResult();
               
        $sql = "
					SELECT card_number FROM #__ad_agency_order 
					WHERE oid = $order_id 
					AND aid = $advertiser_id 
					AND cost = $cost
					AND currency = '$currency'
					AND order_date BETWEEN curdate()-interval 1 day AND curdate() 
					AND payment_type = 'paypal_payment' 
					AND status = 'not_paid' 
                   ";
		$sql_pack[] = $sql;
		$db->setQuery($sql);
		$details = $db->loadResult();
        
        // If there is an order with those exact details
        if($details != NULL) {
        	// Update the order status, set it to 'paid'
        	$sql = "UPDATE #__ad_agency_order SET status = 'paid' WHERE oid = $order_id ";
            $sql_pack[] = $sql;
            $db->setQuery($sql);
            $db->query();
            
            $details2 = explode(";", $details);
            $campaign_id = (int)$details2[0];
            
            if($campaign_id > 0) {
            	// Get the auto-approve settings of the advertiser
                $sql = "SELECT apr_cmp FROM #__ad_agency_advertis WHERE aid = $advertiser_id ";
                $sql_pack[] = $sql;
            	$db->setQuery($sql);
                $auto_approve = $db->loadResult();
               
				// If local advertiser setting is set to "global"
                // or is not set take the global settings
           		if($auto_approve == NULL || $auto_approve == 'G') {
					$sql = "SHOW columns FROM #__ad_agency_campaign WHERE field='approved' ";
					$sql_pack[] = $sql;
					$db->setQuery($sql);
					$result = $database->loadRow();
					$auto_approve = $result[4];              
                }

				// Update the campaign if auto-approve set
	            if($auto_approve == 'Y') {
	                $sql = "UPDATE `#__ad_agency_campaign` SET `approved` = 'Y' WHERE `id` = '".$campaign_id."' ";
	                $sql_pack[] = $sql;
	                $db->setQuery($sql);
	                $db->query();
	            }
            }
            
            return true;
		}

        return false;
    }

    function notify($plugin_conf, $cart, $configs, $plugin_handler) {
    	$this->checkAndUpdate();
		die();		
	}

    function return1 ($plugin_conf, $cart, $configs, $plugin_handler) {    
		$get = JRequest::get('get');		
        $data = split(";", $get['custom']);
        $sid = $data[1];
		if (!$sid) {
        	echo JText::_('ADAG_PAYPAL_NO_SID');
            die();
        } else {
			$plugin_handler->goToSuccessURL($sid);
        }
	 	return;
    }

    function return2 ($plugin_conf, $cart, $configs, $plugin_handler) {
        $data = split(";", $_GET['custom']);
        $now = time();
        $sid = $data[1];
		if (!$sid) {
        	echo JText::_('ADAG_PAYPAL_NO_SID');
            die();        	
		} else {
            /* When returning (cancel go back) we delete the order & campaign details */
			$db = &JFactory::getDBO();
            $user =& JFactory::getUser();
            
            $sql = "SELECT card_number FROM #__ad_agency_order WHERE oid = $sid AND status = 'not_paid' ";
            $db->setQuery($sql);
            $details = $db->loadResult();
            if($details != NULL) {
                $details2 = split(";", $details);
                $campaign_id = $db->getEscaped($details2[0]);
                
                // Get advertiser details
                $sql = "SELECT aid FROM #__ad_agency_advertis WHERE user_id = $user->id ";
                $db->setQuery($sql);
                $advertiser_id = $db->loadResult();
                
                // Delete the order
                $sql = "DELETE FROM #__ad_agency_order WHERE oid = $sid AND aid = $advertiser_id ";
                $db->setQuery($sql);
                $db->query();
                
                // Delete the banners associated with the campaign
                $sql = "DELETE FROM #__ad_agency_campaign_banner WHERE campaign_id = $campaign_id AND aid = $advertiser_id ";
                $db->setQuery($sql);
                $db->query();
                
                // Delete the campaign
                $sql = "DELETE FROM #__ad_agency_campaign WHERE id = $campaign_id AND approved = 'P' AND aid = $advertiser_id ";
                $db->setQuery($sql);
                $db->query();
            }
			
            $plugin_handler->goToFailedURL($sid);
        }      
        return;
    }
   
    function get_info () {
        $info = _PLUGIN_PAYPAL_PAYMENT;
        return $info;
    }

	function get_account () {
		global $database;
		$sql = "select value from #__adagency_plugins where name='".get_class($this)."'";	
		$database->setQuery($sql);
		$account = $database->loadResult();
		return $account;
	}

    function old_notify_function($plugin_conf, $cart, $configs, $plugin_handler) {
		        
        $req = 'cmd=_notify-validate';

        foreach ( $_POST as $key => $value ) {
            $value = urlencode(stripslashes( $value ) );
            $req .= "&$key=$value";
        }
        // post back to PayPal system to validate
		if ($plugin_conf->sandbox == 0) {
			$url = "www.paypal.com:443";

        	$fp = fsockopen ("ssl://www.paypal.com", 443, $errno, $errstr, 30);	
        	
        } else {
			$url = "www.sandbox.paypal.com:443";
			$fp = fsockopen ("ssl://www.sandbox.paypal.com", 443, $errno, $errstr, 30);        	
        	
        }
        
        $header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
        $header .= "Host: ".$url."\r\n";
        $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
        $header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
   
		$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'Header: '.$header);
		$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'REQ: '.$req);
		$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'REQUEST: '.$_REQUEST);

		if (!$fp) {
			$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'Failed is REQUEST (can\'t connect to paypal for ipn): '.print_r($_REQUEST, true));
			//can't connect to paypal for ipn 
		} else { 
			fputs ($fp, $header );
			fputs ($fp, $req);

			while (!feof($fp)) {
				$res = fgets ($fp, 1024);
				//fputs($file,$res);
				$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'Get from Paypal (res): '.str_replace("\r",'',str_replace("\n",'',$res)));
				if (strcmp ($res, "VERIFIED") == 0) {
		        	$data = split(";", $_REQUEST['custom']);
			        //data: userid,sid
			        //save data
			        $now = time();
			        $sid = $data[1];
			        $my->id = $data[0];
					$customer = $plugin_handler->loadCustomer($sid);
					if ($customer->_user->id != $data[0]) return;
			        if (!$sid) {
			        	$sid = $_REQUEST['sd_sid']; 
			        }
					$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'REQUEST: '.print_r($_REQUEST, true));                 
			        $items = $cart->getCartItems( $customer, $configs );			 	 
			        $tax = $cart->calc_price($items, $customer, $configs);			        
			        $non_taxed = $tax['total'];//$total;
			        $total = round($tax['taxed'], 2);
			        $taxa = $tax['value'];
			        $shipping = $tax['shipping'];
			        $currency = $tax['currency'];
			        $licenses = $tax['licenses'];
					$paypal_gross = (float )$_REQUEST["mc_gross"];
					$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'Customer info: '.print_r($customer, true));
					$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'Items info: '.print_r($items, true)); 
					$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'Items info: '.print_r($tax, true));                
					if ($total != $paypal_gross) {
							$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'Wrong gross: total='.$total.'; mc_gross(paypal)='.$paypal_gross);                
							return false;
					}
					$total = $tax['taxed'];
			         //   $total = round( $total + $vat_tax + $state_tax, 2 );			
			        $orderid = $plugin_handler->addOrder($items, $customer, $now, 'paypal');
					$plugin_handler->addLicenses($items, $orderid, $now, $customer);
			        $plugin_handler->dispatchMail($orderid,$total,$licenses, $now, $items, $customer);                    
			  
				} else if (strcmp ($res, "INVALID") == 0) {
					$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'INVALID(payment): '.print_r($_REQUEST, true));   
				} else {
					//$this->writeto('administrator/components/com_adagency/plugins/paypal.log', 'Something wrong(payment): '.print_r($_REQUEST, true));   
                }
			}
		}    
    }    
    
};