<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");

	$advertiser = $this->advertiser;
	$configs = $this->configs;
	$lists = $this->lists;
	$user = $this->user;
	if ($advertiser->aid==0) {
		if(isset($_SESSION['ad_company'])) $advertiser->company = $_SESSION['ad_company'];
		if(isset($_SESSION['ad_description'])) $advertiser->description = $_SESSION['ad_description'];
		if(isset($_SESSION['ad_approved'])) $advertiser->approved = $_SESSION['ad_approved'];
		if(isset($_SESSION['ad_enabled'])) $user->block = $_SESSION['ad_enabled'];
		if(isset($_SESSION['ad_username'])) $user->username = $_SESSION['ad_username'];
		if(isset($_SESSION['ad_email'])) $user->email = $_SESSION['ad_email'];
		if(isset($_SESSION['ad_name'])) $user->name = $_SESSION['ad_name'];
		if(isset($_SESSION['ad_website'])) $advertiser->website = $_SESSION['ad_website'];
		if(isset($_SESSION['ad_address'])) $advertiser->address = $_SESSION['ad_address'];
		if(isset($_SESSION['ad_city'])) $advertiser->city = $_SESSION['ad_city'];
		if(isset($_SESSION['ad_zip'])) $advertiser->zip = $_SESSION['ad_zip'];
		if(isset($_SESSION['ad_telephone'])) $advertiser->telephone = $_SESSION['ad_telephone'];
	}
	$get_data = JRequest::get('get');
    $document = &JFactory::getDocument();
    $document->addStyleSheet(JURI::root()."components/com_adagency/includes/css/adag_tip.css");
?>

<?php include(JPATH_BASE."/components/com_adagency/includes/js/advertisers.php"); ?>
 <form action="index.php" method="post" name="adminForm" id="adminForm">
	<fieldset class="adminform">
	<legend><?php echo JText::_('VIEWADVERTISERINFO');?></legend>
                <table class="admintable">

    <table class="adminform">
		<?php /* - BASIC INFORMATION [begin]- */ ?>
		<tr>
			<th colspan="2">
			<?php echo JText::_('ADAG_BASIC_INFO'); ?>
			</th>
		</tr>
		<tr>
		<td width="10%">
		<?php echo JText::_('VIEWADVERTISERCONTACT'); ?>:<font color="#ff0000">*</font>
		</td>
		<td>
			<input class="inputbox" type="text" name="name" size="40" maxlength="50" value="<?php echo $user->name; ?>" />
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('VIEWADVERTISERCONTACT_TIP'); ?></span>
            </span>
		</td>
		</tr>

		<tr>
			<td width="10%">
			<?php echo JText::_('VIEWADVERTISEREMAIL');?>:<font color="#ff0000">*</font>
			</td>
			<td>
				<input class="inputbox" type="text" name="email" size="40" maxlength="100" <?php #if ($advertiser->aid!=0) echo ' readonly disabled '; ?> value="<?php echo $user->email; ?>" />
                <span class="adag_tip">
                    <img src="components/com_adagency/images/tooltip.png" border="0" />
                    <span><?php echo JText::_('VIEWADVERTISEREMAIL_TIP'); ?></span>
                </span>
			</td>
		</tr>

		<?php if(isset($configs->show)&&(in_array('phone',$configs->show))) { ?>
		<tr>
			<td width="10%">
                <?php echo JText::_('VIEWADVERTISERPHONE'); ?>:
                <?php if(isset($configs->mandatory)&&(in_array('phone',$configs->mandatory))) { ?>
                    <font color="#ff0000">*</font>
                <?php } ?>
			</td>
			<td>
				<input class="inputbox" type="text" name="telephone" size="40" maxlength="20" value="<?php echo $advertiser->telephone; ?>" />
                <span class="adag_tip">
                    <img src="components/com_adagency/images/tooltip.png" border="0" />
                    <span><?php echo JText::_('VIEWADVERTISERPHONE_TIP'); ?></span>
                </span>
			</td>
		</tr>
        <?php } ?>

		<?php if(isset($configs->show)&&(in_array('url',$configs->show))) { ?>
		<tr>
			<td width="10%">
                <?php echo JText::_('VIEWADVERTISERURL'); ?>:
                <?php if(isset($configs->mandatory)&&(in_array('url',$configs->mandatory))) { ?>
                    <font color="#ff0000">*</font>
                <?php } ?>
			</td>
			<td>
				<input class="inputbox" type="text" name="website" size="40" maxlength="255" value="<?php echo $advertiser->website?$advertiser->website:'http://'; ?>" />
                <span class="adag_tip">
                    <img src="components/com_adagency/images/tooltip.png" border="0" />
                    <span><?php echo JText::_('VIEWADVERTISERURL_TIP'); ?></span>
                </span>
			</td>
		</tr>
        <?php } ?>

		<tr>
			<td width="10%">
				<?php echo JText::_('ADAG_TFORMAT'); ?>:<font color="#ff0000">*</font>
			</td>
			<td>
				<select name="fax">
					<option value="10" <?php if(isset($advertiser->fax)&&($advertiser->fax==10)) { echo 'selected="selected"';}?>>mm/dd/yyyy</option>
					<option value="9" <?php if(isset($advertiser->fax)&&($advertiser->fax==9)) { echo 'selected="selected"';}?>>mm-dd-yyyy</option>
					<option value="7" <?php if(isset($advertiser->fax)&&($advertiser->fax==7)) { echo 'selected="selected"';}?>>dd-mm-yyyy</option>
					<option value="8" <?php if(isset($advertiser->fax)&&($advertiser->fax==8)) { echo 'selected="selected"';}?>>dd/mm/yyyy</option>
					<option value="11" <?php if(isset($advertiser->fax)&&($advertiser->fax==11)) { echo 'selected="selected"';}?>>yyyy-mm-dd</option>
					<option value="12" <?php if(isset($advertiser->fax)&&($advertiser->fax==12)) { echo 'selected="selected"';}?>>yyyy/mm/dd</option>
					<option value="1" <?php if(isset($advertiser->fax)&&($advertiser->fax==1)) { echo 'selected="selected"';}?>>dd-mm-yyyy hh:mm:ss</option>
					<option value="2" <?php if(isset($advertiser->fax)&&($advertiser->fax==2)) { echo 'selected="selected"';}?>>dd/mm/yyyy hh:mm:ss</option>
					<option value="3" <?php if(isset($advertiser->fax)&&($advertiser->fax==3)) { echo 'selected="selected"';}?>>mm-dd-yyyy hh:mm:ss</option>
					<option value="4" <?php if(isset($advertiser->fax)&&($advertiser->fax==4)) { echo 'selected="selected"';}?>>mm/dd/yyyy hh:mm:ss</option>
					<option value="5" <?php if(isset($advertiser->fax)&&($advertiser->fax==5)) { echo 'selected="selected"';}?>>yyyy-mm-dd hh:mm:ss</option>
					<option value="6" <?php if(isset($advertiser->fax)&&($advertiser->fax==6)) { echo 'selected="selected"';}?>>yyyy/mm/dd hh:mm:ss</option>

				</select>
                <span class="adag_tip">
                    <img src="components/com_adagency/images/tooltip.png" border="0" />
                    <span><?php echo JText::_('ADAG_TFORMAT_TIP'); ?></span>
                </span>
			</td>
		</tr>

		<?php /* - BASIC INFORMATION [end]- */ ?>

		<?php /* - LOGIN INFORMATION [begin]- */ ?>

		<tr>
			<th colspan="2">
			<?php echo JText::_('ADAD_LOGIN_INFO'); ?>
			</th>
		</tr>

		<tr>
			<td width="10%">
			<?php echo JText::_('VIEWADVERTISERLOGIN');?>:<font color="#ff0000">*</font>
			</td>
			<td>
			<input class="inputbox" type="text" name="username" size="40" maxlength="25" <?php if($advertiser->aid>0) { echo 'readonly="" style="color:#ff0000; font-weight: bold; background-color: transparent; border: 0px; "'; } ?> value="<?php echo $user->username; ?>" />
          	<?php if(!isset($_GET['cid'][0])){ ?>
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('VIEWADVERTISERLOGIN_TIP'); ?></span>
            </span>
            <?php } ?>
			</td>
		</tr>

		<?php if($advertiser->aid<1) {?>
		<tr>
			<td width="10%">
			 <?php echo JText::_('VIEWADVERTISERPASS'); ?>:<font color="#ff0000">*</font>
			</td>
			<td>
			<input class="inputbox" type="password" name="password" size="40" maxlength="100" value="" />
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('VIEWADVERTISERPASS_TIP'); ?></span>
            </span>
			</td>
		</tr>

		<tr>
			<td width="10%">
			 <?php echo JText::_('ADAG_CNF_PSW'); ?>:<font color="#ff0000">*</font>
			</td>
			<td>
			<input class="inputbox" type="password" name="password2" size="40" maxlength="100" value="" />
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('ADAG_CNF_PSW_TIP'); ?></span>
            </span>
			</td>
		</tr>
		<?php } ?>
		<?php /* - LOGIN INFORMATION [end]- */ ?>

		<?php /* - ADMIN OPTIONS [begin] - */ ?>
		<tr>
			<th colspan="2">
			<?php echo JText::_('ADAG_ADMOPT'); ?>
			</th>
		</tr>
		<tr>
			<td>
			<?php echo JText::_('AD_STATUS'); ?>:
			</td>
			<td>
			 <?php echo $lists['approved'] ?>
             <span class="adag_tip">
                 <img src="components/com_adagency/images/tooltip.png" border="0" />
                 <span><?php echo JText::_('AD_STATUS_TIP'); ?></span>
             </span>
			</td>
		</tr>
		<tr>
			<td>
			<?php echo JText::_('Enabled'); ?>:
			</td>
			<td>
			 <?php echo $lists['enabled'] ?>
             <span class="adag_tip">
                 <img src="components/com_adagency/images/tooltip.png" border="0" />
                 <span><?php echo JText::_('Enabled_TIP'); ?></span>
             </span>
			</td>
		</tr>
		<?php /* - ADMIN OPTIONS [end] - */?>

		<?php /* - COMPANY [begin] - */?>
		<?php if(isset($configs->show)&&(in_array('company',$configs->show))) { ?>
		<tr>
			<th colspan="2">
			<?php echo JText::_('ADAG_COMP'); ?>
			</th>
		</tr>
		<tr>
			<td width="20%">
			<?php echo JText::_('VIEWADVERTISERCOMPNAME'); ?>:<?php if(isset($configs->mandatory)&&(in_array('company',$configs->mandatory))) { ?><font color="#ff0000">*</font><?php } ?>
			</td>
			<td>
			<input class="inputbox" type="text" name="company" size="40" maxlength="100" valign="top" value="<?php echo $advertiser->company; ?>" />
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('VIEWADVERTISERCOMPNAME_TIP'); ?></span>
            </span>
			</td>
		</tr>
		<tr>
			<td width="20%">
			<?php echo JText::_('VIEWADVERTISERDESC');?><?php if(isset($configs->mandatory)&&(in_array('company',$configs->mandatory))) { ?>:<font color="#ff0000">*</font><?php } ?>
			</td>
			<td>
		<TEXTAREA NAME="description" ROWS="6" COLS="41"><?php echo $advertiser->description;?></TEXTAREA>
        <span class="adag_tip" style="float:right;margin-right:58%;">
            <img src="components/com_adagency/images/tooltip.png" border="0" />
            <span><?php echo JText::_('VIEWADVERTISERDESC_TIP'); ?></span>
        </span>
			<br>
			</td>
		</tr>
		<?php } ?>
		<?php /* - COMPANY [end] - */?>

		<?php /* - ADDRESS [begin] - */?>
		<?php if(isset($configs->show)&&(in_array('address',$configs->show))) { ?>
		<tr>
			<th colspan="2">
			 <?php echo JText::_('VIEWADVERTISERADDRESS') ?>
			</th>
		</tr>
<?php include(JPATH_BASE."/components/com_adagency/includes/js/advertisers_country.php"); ?>

		<tr>
		  <td><?php echo JText::_("VIEWADVERTISERCOUNTRY");?>:<?php if(isset($configs->mandatory)&&(in_array('address',$configs->mandatory))) { ?><font color="#ff0000">*</font><?php } ?></td>
		  <td><?php echo $this->lists['country_option']; ?>
              <span class="adag_tip">
                  <img src="components/com_adagency/images/tooltip.png" border="0" />
                  <span><?php echo JText::_('VIEWADVERTISERCOUNTRY_TIP'); ?></span>
              </span>
          </td>
		</tr>
		<tr>
		  <td><?php echo JText::_("VIEWADVERTISERPROV");?>:<?php if(isset($configs->mandatory)&&(in_array('address',$configs->mandatory))) { ?><font color="#ff0000">*</font><?php } ?></td>
		  <td><?php
		  	echo str_replace('id="province"','id="province" style="float:left;"',$this->lists['customerlocation']);
		  ?>
          <span class="adag_tip" style="margin-left: 5px;">
              <img src="components/com_adagency/images/tooltip.png" border="0" />
              <span><?php echo JText::_('VIEWADVERTISERPROV_TIP'); ?></span>
          </span>
		  </td>
		</tr>
		<tr>
			<td>
		     <?php echo JText::_('ADAG_CITY'); ?><?php if(isset($configs->mandatory)&&(in_array('address',$configs->mandatory))) { ?>:<font color="#ff0000">*</font><?php } ?>
			</td>
			<td>
			<input class="inputbox" type="text" name="city" size="40" maxlength="100" value="<?php echo $advertiser->city; ?>" />
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('ADAG_CITY_TIP'); ?></span>
            </span>
			</td>
		</tr>
		<tr>
			<td width="10%">
    			<?php echo JText::_('ADAG_STREET'); ?>:<?php if(isset($configs->mandatory)&&(in_array('address',$configs->mandatory))) { ?><font color="#ff0000">*</font><?php } ?>
			</td>
			<td>
			<input class="inputbox" type="text" name="address" size="40" maxlength="100" value="<?php echo $advertiser->address; ?>" />
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('ADAG_STREET_TIP'); ?></span>
            </span>
			</td>
		</tr>
		<tr>
			<td width="10%">
	 <?php echo JText::_('VIEWADVERTISERZIP'); ?>:<?php if(isset($configs->mandatory)&&(in_array('address',$configs->mandatory))) { ?><font color="#ff0000">*</font><?php } ?>
			</td>
			<td>
			<input class="inputbox" type="text" name="zip" size="40" maxlength="12" value="<?php echo $advertiser->zip; ?>" />
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('VIEWADVERTISERZIP_TIP'); ?></span>
            </span>
			</td>
		</tr>
		<?php } ?>
		<?php /* - ADDRESS [end] - */?>

		<?php /* - EMAIL REPORTS [begin]- */ ?>
		<?php if(isset($configs->show)&&(in_array('email',$configs->show))) { ?>
		<tr>
			<th colspan="2">
			 <?php echo JText::_('VIEWADVERTISEREMAILOPT') ?>
			</th>
		</tr>
		<tr>
			<td width="10%">&nbsp;

			</td>
			<td>
				<table align="left" border="0" cellspacing="0" style="width: 360px;">
				<tr>
					<td width="20">
						<INPUT  TYPE="checkbox" <?php if ($advertiser->email_daily_report=='Y') echo 'checked' ?> NAME="email_daily_report" value="Y" >
					</td>
					<td width="120">
						<?php echo JText::_('VIEWADVERTISERDAY'); ?>
					</td>
					<td width="20">
						<INPUT  TYPE="checkbox" <?php if ($advertiser->email_weekly_report=='Y') echo 'checked' ?> NAME="email_weekly_report" value="Y" >
					</td>
					<td width="180">
						<?php echo JText::_('VIEWADVERTISERWEEK'); ?>
					</td>
				</tr>
				<tr>
					<td>
						<INPUT  TYPE="checkbox" <?php if ($advertiser->email_month_report=='Y') echo 'checked' ?> NAME="email_month_report" value="Y" >
					</td>
					<td>
						<?php echo JText::_('VIEWADVERTISERMONTH'); ?>
					</td>
					<td>
						<INPUT  TYPE="checkbox" <?php if ($advertiser->email_campaign_expiration=='Y') echo 'checked' ?> NAME="email_campaign_expiration" value="Y">
					</td>
					<td >
      				<?php echo JText::_('VIEWADVERTISEREXP'); ?>
                    <span class="adag_tip" style="float:right;margin-top:-30px;">
                        <img src="components/com_adagency/images/tooltip.png" border="0" />
                        <span><?php echo JText::_('VIEWADVERTISEREMAILOPT_TIP'); ?></span>
                    </span>
					</td>
				</tr>
				</table>
			</td>
		</tr>
		<?php } ?>
		<?php /* - EMAIL REPORTS [end]- */?>

		<?php // Approvals [begin]?>
		<tr>
			<th colspan="2">
			 <?php echo JText::_('ADAG_APPROVALS') ?>
			</th>
		</tr>
		<tr>
			<td><?php echo JText::_('ADAG_AA_ADS');?></td>
			<td><select name="apr_ads">
				<option value="G" <?php if($advertiser->apr_ads=='G') {echo 'selected="selected"';}?>><?php echo JText::_('ADAG_USE_GLB'); ?></option>
				<option value="Y" <?php if($advertiser->apr_ads=='Y') {echo 'selected="selected"';}?>><?php echo JText::_('JAS_YES'); ?></option>
				<option value="N" <?php if($advertiser->apr_ads=='N') {echo 'selected="selected"';}?>><?php echo JText::_('JAS_NO'); ?></option>
			</select>
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('ADAG_AA_ADS_TIP2'); ?></span>
            </span>
			<?php echo JText::_('ADAG_AA_INFO');?></td>
		</tr>
		<tr>
			<td><?php echo JText::_('ADAG_AA_CMP');?></td>
			<td><select name="apr_cmp">
				<option value="G" <?php if($advertiser->apr_cmp=='G') {echo 'selected="selected"';}?>><?php echo JText::_('ADAG_USE_GLB'); ?></option>
				<option value="Y" <?php if($advertiser->apr_cmp=='Y') {echo 'selected="selected"';}?>><?php echo JText::_('JAS_YES'); ?></option>
				<option value="N" <?php if($advertiser->apr_cmp=='N') {echo 'selected="selected"';}?>><?php echo JText::_('JAS_NO'); ?></option>
			</select>
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('ADAG_AA_CMP_TIP2'); ?></span>
            </span>
			<?php echo JText::_('ADAG_AA_INFO');?></td>
		</tr>
		<?php // Approvals [end]?>


	</table>

	<input type="hidden" name="images" value="" />
	<input type="hidden" id="sendmail" name="sendmail" value="1" />
	<input type="hidden" id="initvalcamp" value="" />
	<input type="hidden" name="option" value="com_adagency" />
	<input type="hidden" name="aid" value="<?php echo $advertiser->aid; ?>" />
	<input type="hidden" name="user_id" value="<?php echo $advertiser->user_id; ?>" />
	<input type="hidden" name="lastreport" value="<?php if (isset($advertiser->lastreport)) echo $advertiser->lastreport; else echo time(); ?>" />
	<input type="hidden" name="weekreport" value="<?php if (isset($advertiser->weekreport)) echo $advertiser->weekreport; else echo time(); ?>" />
	<input type="hidden" name="monthreport" value="<?php if (isset($advertiser->monthreport)) echo $advertiser->monthreport; else echo time(); ?>" />
    <input type="hidden" name="task" value="" />
	<input type="hidden" name="controller" value="adagencyAdvertisers" />
	<?php
		// the graybox code
		if(isset($get_data['tmpl'])&&($get_data['tmpl'] == 'component')) {
			echo "<input type='hidden' name='tmpl' value='component' />";
			echo "<input type='button' value='".JText::_('ADAG_SAVE')."' class='inputbox' onclick='submitbutton(\"save_graybox\");' />";
		}
	?>
    </fieldset>
</form>
