<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
$camp_row = $this->camp;
$stats = $this->stats;
$package_row = $this->package_row;
$advertiser = $this->advt;
if(isset($advertiser->approved)&&($advertiser->approved != 'Y')){
    $advertiser_appr = "<div style='clear:both'></div><div id='ajax_adv' style='margin: 4px 0;padding: 3px; border:1px solid #FF0000; background-color: #FFFFCC; width: 515px;'>".JText::_('ADAG_NOT_APPROVED_CAMP')."<br /<br />- <span id='approve_and_email' style='text-decoration:underline; cursor:pointer;'>".JText::_('ADAG_NOT_APPR_1')."</span><br />- <span id='approve_no_email' style='text-decoration:underline; cursor:pointer;'>".JText::_('ADAG_NOT_APPR_2')."</span><br /><br /><span class='close_it' style='font-weight:bold; text-decoration: underline; cursor: pointer;' >".JText::_('ADAG_CLOSE')."</span><input type='hidden' id='advertiser_aid' value='".$advertiser->aid."' /></div>";
} else {
    $advertiser_appr = NULL;
}
$ban_row = $this->ban_row;
$cbrw = NULL;
if(isset($ban_row)&&(is_array($ban_row))){
    foreach($ban_row as $el){
        $cbrw[] = $el->id;
    }
    $cbrw = @implode(",",$cbrw);
}
$configs = $this->configs;

if ( isset($camp_row->params['adslim']) ) {
    $adslim = (int)$camp_row->params['adslim'];
} elseif ( (!isset($camp_row->id) || ($camp_row->id <= 0)) && isset($configs->params['adslim']) ) {
    $adslim = $configs->params['adslim'];
} else {
    $adslim = 999;
}

$lists = $this->lists;
$task = $this->task;
// JHTML::_('behavior.modal');
// JHTML::_('behavior.mootools');
$document = &JFactory::getDocument();
$document->addScript( JURI::root()."components/com_adagency/includes/js/jquery.js" );
$document->addScript( JURI::root()."components/com_adagency/includes/js/jquery.adagency.js" );
$document->addScript(JURI::root()."components/com_adagency/includes/js/jquery.DOMWindow.js");
$document->addScript(JURI::root()."components/com_adagency/includes/js/graybox.js");
$document->addStyleSheet('components/com_adagency/css/joomla16.css');
$document->addStyleSheet(JURI::root()."components/com_adagency/includes/css/adag_tip.css");

require_once(JPATH_BASE.DS."components".DS."com_adagency".DS."helpers".DS."helper.php");

?>
<?php include(JPATH_BASE."/components/com_adagency/includes/js/campaigns.php"); ?>

 <form action="index.php" method="post" name="adminForm" id="adminForm">
	<fieldset class="adminform">
	<legend><?php if ($camp_row->id<1) echo JText::_('AD_CMP_NEWCMP'); else echo JText::_('AD_CMP_EDITCMP');?></legend>
<table class="adminform">
		<th colspan="2">
		<?php echo JText::_('AD_CMP_MAININFO'); ?>
		</th>
		<tr>
			<td width="15%" valign="top">
			<?php echo JText::_('NEWADADVERTISER'); ?>:<font color="#ff0000">*</font>
            </td>
			<td>
				<div id="to_be_replaced" style="float:left "><?php echo $lists['advertiser_id']; ?></div>
                <span class="adag_tip" style="float: left; margin-left: 5px;">
                    <img src="components/com_adagency/images/tooltip.png" border="0" />
                    <span><?php echo JText::_('NEWADADVERTISER_TIP'); ?></span>
                </span><div style="float:left; padding-left:10px; "><a rel="{handler: 'iframe', size: {x: 700, y: 450}}" href="index.php?option=com_adagency&controller=adagencyAdvertisers&task=addadv&tmpl=component" class="modal2"><?php echo JText::_('AD_CMP_ADD_ADVERTISER'); ?></a></div>
            <?php echo $advertiser_appr; ?>
			</td>
		</tr>
		<tr>
			<td>
			<?php echo JText::_('AD_CMP_CMPNAME');?>:<font color="#ff0000">*</font>
			</td>
			<td>
			<input class="inputbox" type="text" name="name" size="40" maxlength="255" value="<?php echo $camp_row->name; ?>" />
            <span class="adag_tip">
                <img src="components/com_adagency/images/tooltip.png" border="0" />
                <span><?php echo JText::_('AD_CMP_CMPNAME_TIP'); ?></span>
            </span>
			<br>
			</td>
		</tr>

		<?php if (!$camp_row->id) { ?>
			<tr>
				<td width="10%"><?php echo JText::_('AD_CMP_CMPPACK'); ?>:<font color="#ff0000">*</font></td>
				<td>
					<div  id="to_be_replaced_p" style="float:left "><?php echo $lists["package"]; ?></div>
                    <span class="adag_tip" style="float: left; margin-left: 5px;">
                        <img src="components/com_adagency/images/tooltip.png" border="0" />
                        <span><?php echo JText::_('AD_CMP_CMPPACK_TIP'); ?></span>
                    </span>
					<div style="float:left; padding-left:10px; "><a rel="{handler: 'iframe', size: {x: 700, y: 450}}" href="index.php?option=com_adagency&controller=adagencyPackages&task=addpack&tmpl=component&advert_id=<?php echo $this->advertiser_id;?>" class="modal2"><?php echo JText::_('AD_CMP_ADD_PACKAGE'); ?></a>&nbsp;
                    </div>
				</td>
			</tr>

			<tr>
				<td>&nbsp;

				</td>

				<td>
<div style="border: 1px solid #FF0000; width:40%; color:#FF0000; padding: 3px 3px 3px 9px;"><?php echo JText::_('AD_NOTICE_CAMP');?></div>
				</td>

			</tr>

			<tr>
				<td><?php echo JText::_("AD_CAMP_START_DATE");?>:<font color="#ff0000">*</font>
				</td>
				<td>
					<?php
					if(($configs->params['timeformat']==1)||($configs->params['timeformat']==7)) {$ymd="%d-%m-%Y";}
					elseif(($configs->params['timeformat']==2)||($configs->params['timeformat']==8)) {$ymd="%d/%m/%Y";}
					elseif(($configs->params['timeformat']==3)||($configs->params['timeformat']==9)) {$ymd="%m-%d-%Y";}
					elseif(($configs->params['timeformat']==4)||($configs->params['timeformat']==10)) {$ymd="%m/%d/%Y";}
					elseif(($configs->params['timeformat']==5)||($configs->params['timeformat']==11)) {$ymd="%Y-%m-%d";}
					elseif(($configs->params['timeformat']==6)||($configs->params['timeformat']==12)) {$ymd="%Y/%m/%d";}
					else {$ymd="%d-%m-%Y";}
					if($configs->params['timeformat']>=7) {$hms = NULL;} else {$hms = ' %H:%M:%S';}
					echo JHTML::_('calendar', adagencyAdminHelper::formatime($camp_row->start_date, $configs->params['timeformat']), 'start_date', 'start_date', ''.$ymd.$hms, array('class'=>'inputbox', 'size'=>'25',  'maxlength'=>'19'));
					echo "<input type='hidden' name='tfa' value='".$configs->params['timeformat']."' />";
					?>
                    <span class="adag_tip">
                        <img src="components/com_adagency/images/tooltip.png" border="0" />
                        <span><?php echo JText::_('AD_CAMP_START_DATE_TIP'); ?></span>
                    </span>
				</td>
			</tr>


		<?php }	?>

		<tr>
			<td></td>
			<td>
			<input type="hidden" name="default" <?php if ($camp_row->default=='Y') echo 'checked'; ?> value ="Y"> <?php //echo "note.."; ?>
			</td>
		</tr>
		<tr>
			<td>
			<?php echo JText::_("AD_CAMP_APPROVED"); ?>:
			</td>
			<td>
			 <?php echo $lists['approved'] ?>
             <span class="adag_tip">
                 <img src="components/com_adagency/images/tooltip.png" border="0" />
                 <span><?php echo JText::_('AD_CAMP_APPROVED_TIP'); ?></span>
             </span>
			</td>
		</tr>
		<tr>
			<td><?php echo JText::_('AD_CMP_INCLUDED_ADS'); ?>:<font color="#ff0000">*</font>&nbsp;
                <span class="adag_tip">
                    <img src="components/com_adagency/images/tooltip.png" border="0" />
                    <span><?php echo JText::_('AD_CMP_INCLUDED_ADS_TIP'); ?></span>
                </span>
			</td>
			<td>
            <?php
                if ( isset($adslim) && ($adslim != 999) ) {
                    echo "<p><span class='adslim'>" . JText::_('ADAG_CMP_ADS_LIM') . ": " . $adslim . "</span></p>";
                }
            ?>
			<TABLE class="adminform" id="banner_table">
			<TBODY>
			<TR >
				<TH style="text-align:center;"><?php echo JText::_("AD_BANNER_ID"); ?></TH>
				<TH><?php echo JText::_("AD_BANNER_NAME"); ?></TH>
                <TH><?php echo JText::_("NEWADZONE"); ?> </TH>
				<TH><?php echo JText::_("VIEWADPREVIEW");?></TH>
				<TH style="text-align:center;"><?php echo JText::_("VIEWADSTATUS"); ?></TH>
				<TH><?php echo JText::_("ADAG_INCLUDE");?></TH>
				<?php if ($task=="edit" || $task=='editA') { /* ?>
				<TH><?php echo JText::_("ADAG_DELETE");?></TH>
				<?php */  } ?>
				<TH style="text-align:left;"><?php echo JText::_("AD_BANNER_RW"); ?></TH>
			</TR>
			<?php
				$k=0;
				for ($i=0, $n=count( $ban_row ); $i < $n; $i++) {
					$row = &$ban_row[$i];
			?>
					<TR class="<?php echo "row$k"; ?>">
						<TD style="text-align:center;"><?php echo $row->id; ?></TD>
						<TD><?php echo $row->title; ?> <!--(<?php if ($row->width==0 or $row->height==0) { echo  "Size"." Unknown"; } else {echo "$row->width x $row->height"; }?>)--></TD>
                        <TD><?php if(isset($row->zones)) { echo $row->zones; } else { echo "-"; }?></TD>
						<TD><a href="<?php echo str_replace("administrator/","",JURI::base())."index.php?option=com_adagency&controller=adagencyAds&task=preview&tmpl=component&no_html=1&adid=".$row->id;?>" class="modal2"><?php echo strtolower(JText::_("VIEWADPREVIEW"));?></a></TD>
                        <TD style="text-align:center;">
                            <?php if ($row->approved == 'Y') { ?>
                                <img border="0" alt="Approve" src="templates/bluestork/images/admin/tick.png">
                            <?php } elseif ($row->approved == 'N') { ?>
                                <img border="0" alt="Unapprove" src="templates/bluestork/images/admin/publish_x.png">
                            <?php } elseif ($row->approved == 'P') { ?>
                                <img border="0" alt="Pending" src="components/com_adagency/images/pending.gif">
                            <?php } ?>
                        </TD>

						<TD class="add_column">
                                <INPUT TYPE="checkbox" NAME="banner[<?php echo $row->id;?>][add]" VALUE="1" <?php if ($row->relative_weighting != NULL) { echo 'checked="checked"'; } ?>
                        </TD>

						<?php if ($task=="edit" || $task=='editA') { /* ?>
						<TD><?php if ($row->relative_weighting>0) {?><INPUT TYPE="checkbox" NAME="banner[<?php echo $row->id;?>][del]" VALUE="1"><?php } ?></TD>
						<?php */ }  ?>

						<TD style="text-align:left;"><INPUT TYPE="text" NAME="banner[<?php echo $row->id;?>][rw]"  size="5" maxlength="6" value="<?php echo $row->relative_weighting>0?$row->relative_weighting: '100';?>"></TD>
					</TR>
					<?php
					$k = 1 - $k;
				//}
			}?>
			</TBODY>
			</TABLE>

			</td>
		</tr>
		<tr>
			<td>
			</td>
			<td>
			<input class="inputbox" type="hidden" name="notes" size="40" maxlength="255" value="<?php //echo $camp_row->notes; ?>" />
			</td>
		</tr>
	</table>
		<?php if ($camp_row->id > 0) { ?>
	<table class="adminform" cellpadding="0" cellspacing="0">
		<tr>
			<th colspan="2">
				<?php echo JText::_('ADAG_CPM_STUS');?>
			</th>
		</tr>

		<tr>
			<td><?php echo JText::_('ADAG_CPM_PACKNAME');?>: </td>
			<td><a href="index.php?option=com_adagency&controller=adagencyPackages&task=edit&cid[]=<?php echo $package_row->tid; ?>"><?php echo $package_row->description; ?></a></td>
		</tr>

		<tr>
			<td><?php echo JText::_('VIEWDSADMINZONES');?>: </td>
			<td>
	            <?php
					if(is_array($package_row->allzones)) {
						$nr2 = 0;
						foreach($package_row->allzones as $zone){
							if($nr2 > 0) { echo ", "; }
							echo '<a href="index.php?option=com_adagency&controller=adagencyZones&task=edit&cid[]='.$zone->zoneid.'">'.$zone->z_title.'</a>';
							$nr2++;
						}
					}
				?>
            </td>
		</tr>

		<tr>
			<td><?php echo JText::_('ADAG_CPM_PACKTYPE');?>: </td>
			<td><?php if ($camp_row->type=="cpm") { echo JText::_('ADAG_CPM'); } elseif ($camp_row->type=="pc") { echo JText::_('ADAG_PC'); } elseif ($camp_row->type=="fr") { echo JText::_('ADAG_FR'); } ?></td>
		</tr>
		<tr>
			<td><?php echo JText::_('ADAG_CPM_PACKDETLS');?>: </td>
			<td><?php echo $package_row->details; ?></td>
		</tr>
		<tr>
			<td><?php echo JText::_('ADAG_CPM_STARTDATE'); ?>:</td>
			<td><?php echo adagencyAdminHelper::formatime($camp_row->start_date, $configs->params['timeformat']); ?></td>
		</tr>


		<?php if ($camp_row->type == "cpm") {
			if ($camp_row->quantity > 0) {
			$package_row->quantity = intval($package_row->quantity) - intval($camp_row->quantity);
			?>
				<tr>
					<td colspan="2"><span style="font-size: 24px; font-weight: bold; color: #000000;"><span style="color: #FF0000;"><?php echo $package_row->quantity; ?></span>&nbsp;<?php echo JText::_('AD_CAMP_IMP');?>,&nbsp;<span style="color: #FF0000;"><?php echo $camp_row->quantity; ?></span>&nbsp;<?php echo JText::_('AD_CAMP_IMP_LEFT');?></span></td>
				</tr>
		<?php }
			else { ?>
			<tr>
				<td colspan="2">
				<span style="font-size: 24px; font-weight: bold; color: #FF0000;"><?php echo JText::_('AD_CAMP_EXPIRED');?></span>
				</td>
			</tr>
			<?php }
		}
		if ($camp_row->type == "pc") {
			if ($camp_row->quantity > 0) {

				$package_row->quantity = intval($package_row->quantity) - intval($camp_row->quantity);
				?>
					<tr>
						<td colspan="2"><span style="font-size: 24px; font-weight: bold; color: #000000;"><span style="color: #FF0000;"><?php echo $package_row->quantity; ?></span>&nbsp;<?php echo JText::_('AD_CAMP_CLK');?>,&nbsp;<span style="color: #FF0000;"><?php echo $camp_row->quantity; ?></span>&nbsp;<?php echo JText::_('AD_CAMP_CLK_LEFT');?></span></td>
					</tr>
		<?php } else { ?>
				<tr>
					<td colspan="2">
					<span style="font-size: 24px; font-weight: bold; color: #FF0000;"><?php echo JText::_('AD_CAMP_EXPIRED');?></span>
					</td>
				</tr>

			<?php }
		}
		if ($camp_row->type == "fr") {
		if ($camp_row->expired) {
		?>
			<tr>
				<td colspan="2">
				<span style="font-size: 24px; font-weight: bold; color: #FF0000;"><?php echo JText::_('AD_CAMP_EXPIRED');?></span>
				</td>
			</tr>
			<?php } else { ?>
			<tr>
				<td colspan="2">
				<span style="font-size: 24px; font-weight: bold; color: #000000;"><span style="color: #FF0000;"><?php echo $camp_row->time_left['days']; ?></span>&nbsp;<?php echo JText::_('AD_CAMP_DAYS');?>&nbsp;<span style="color: #FF0000;"><?php echo $camp_row->time_left['hours']; ?></span>&nbsp;<?php echo JText::_('AD_CAMP_HOURS');?>&nbsp;<span style="color: #FF0000;"><?php echo $camp_row->time_left['mins']; ?></span>&nbsp;<?php echo JText::_('AD_CAMP_MINS');?>&nbsp;<?php echo JText::_('AD_CAMP_IMP_LEFT');?></span>
				</td>
			</tr>
		<?php }
			} ?>
			</table>
			<table class="adminform" cellpadding="0" cellspacing="0">
			<tr>
				<th colspan="2">
					<?php echo JText::_('AD_CAMP_STATS'); ?>
				</th>
			</tr>
			<tr>
				<td><?php echo JText::_('AD_CAMP_DURATION');?>: </td>
				<td><?php echo $stats['days'] . "&nbsp;".JText::_("ADAG_DAYS")."&nbsp;" . $stats['hours'] . "&nbsp;".JText::_('AD_CAMP_HOURS')."&nbsp;" . $stats['mins'] . "&nbsp;".JText::_('AD_CAMP_MINS'); ?></td>
			</tr>
			<tr>
				<td><?php echo JText::_('AD_CAMP_CLICKS');?>: </td>
				<td><?php if ($stats['click']) { echo $stats['click']; } else echo '0';?></td>
			</tr>
			<tr>
				<td><?php echo JText::_('AD_CAMP_IMPS');?>: </td>
				<td><?php if ($stats['impressions']) { echo $stats['impressions']; } else echo '0'; ?></td>
			</tr>
			<tr>
				<td><?php echo JText::_('AD_CLICK_RATE');?>: </td>
				<td><?php if ($stats['click_rate']) { echo $stats['click_rate']; } else echo '0.00';  ?>%</td>
			</tr>

		<?php } ?>

		</table>
		<input type="hidden" name="id" value="<?php echo $camp_row->id; ?>" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="option" value="com_adagency" />
		<input type="hidden" name="controller" value="adagencyCampaigns" />
		<?php if ($camp_row->id>0) { ?>
        <input type="hidden" name="cbrw" value="<?php echo $cbrw; ?>" />
		<input type="hidden" name="otid" value="<?php echo $camp_row->otid; ?>" />
		<input type="hidden" name="aid" value="<?php echo $camp_row->aid; ?>" />
		<input type="hidden" name="type" value="<?php echo $camp_row->type; ?>" />
		<input type="hidden" name="quantity" value="<?php echo $camp_row->quantity; ?>" />
		<input type="hidden" name="validity" value="<?php echo $camp_row->validity; ?>" />
		<input type="hidden" name="start_date" value="<?php echo $camp_row->start_date; ?>" />
		<input type="hidden" name="cost" value="<?php echo $camp_row->cost; ?>" />
		<input type="hidden" id="sendmail" name="sendmail" value="1" />
		<input type="hidden" id="initvalcamp" value="" />
		<?php } else { ?>
		<input type="hidden" id="initvalcamp" value="" />
		<input type="hidden" name="now_datetime" value="<?php echo date("Y-m-d"); ?>" />
		<?php } ?>
		</fieldset>
		</form>
