<?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
$document = &JFactory::getDocument();
$document->addScript(JURI::root() . 'components/com_adagency/includes/js/jquery.js');
$document->addScript(JURI::root() . 'components/com_adagency/includes/js/jquery.adagency.js');
$k = 0;
$n = count ($this->packages);
$configs = $this->configs;
$ordersnr = $this->ordersnr;
$lists=$this->lists;
if(!isset($_SESSION['package_status'])) {$_SESSION['package_status']=NULL;}
?>
<?php if (!$this->nz) { ?>
    <SCRIPT>
    function saveorder(n, task) {
        Joomla.submitform("saveorder");
    }
    </SCRIPT>
    <form action="index.php?option=com_adagency&controller=adagencyPackages" method="post" name="topform1">
        <table width="100%" cellpadding="5" cellspacing="5" bgcolor="#FFFFFF">
            <tr>
                <td align="right" width="50%">
                    <input type="text" name="search_package" value="<?php if(isset($_SESSION['search_package'])) echo $_SESSION['search_package'];?>" />
                    <input type="submit" name="submit_search" value="<?php echo JText::_('VIEWAD_SEARCHTXT');?>" />
                </td>
                <td align="right">
                    <?php echo JText::_('VIEWAD_SEARCH_TYPE');?>
                    <?php echo $lists['type_package'];	?>
                </td>
                <td align="right">
                    <?php echo JText::_('VIEWAD_SEARCH_ZONE');?>
                    <?php echo $lists['package_zone'];	?>
                </td>
                <td align="right">
                    <?php echo JText::_('VIEWADSTATUS');?>
                    <select name="package_status" onChange="document.topform1.submit()">
                        <option value="-1" <?php if (!isset($_SESSION['order_status']) || $_SESSION['package_status'] == '-1') echo ' selected="selected" ';?>><?php echo JText::_('VIEWAD_SEARCH_SELECT'); ?></option>
                        <option value="1" <?php if (isset($_SESSION['package_status']) && $_SESSION['package_status'] == '1') echo ' selected="selected" ';?>><?php echo JText::_('VIEWPACKAGEPUBLISHED');?></option>
                        <option value="0" <?php if (isset($_SESSION['package_status']) && $_SESSION['package_status'] == '0') echo ' selected="selected" ';?>><?php echo JText::_('VIEWPACKAGEUNPUBLISHED');?></option>
                    </select>
                </td>
            </tr>
        </table>
    </form>
<?php
    } else {
?>
<script type="text/javascript">
    ADAG(function () {
        ADAG('#adag-next').click(function () {
            count_checked = ADAG('#editcell tbody tr').find('td:first').not(':last').find(':checked').length;
            if (!count_checked) {
                alert('<?php echo JText::_('ADAG_NZ_AT_LEAST'); ?>');
            } else {
                submitbutton('zonePacks');
            }
        });
    });
</script>
<div style="margin: 4px 0pt; padding: 3px; border: 1px solid rgb(255, 0, 0); background-color: rgb(255, 255, 204); width: 715px;">
    <div class="adag_bold"><?php echo JText::_('ADAG_NZ_ADDED'); ?></div>
    <div class="adag_normal"><?php echo JText::_('ADAG_NZ_MSG1'); ?></div>
    <div class="adag_note"><?php echo JText::_('ADAG_NZ_NOTE'); ?></div>
</div>
<?php
    }
?>

<form action="index.php" name="adminForm" method="post">
<div id="editcell" >
<table class="adminlist">
<thead>

	<tr>
		<th width="5">
			<input type="checkbox" onclick="checkAll(<?php echo $n; ?>)" name="toggle" value="" />
		</th>
		<th width="5">
			<?php echo JText::_('ADAG_UNIV_ID');?>
		</th>
	        <th>
			<?php echo JText::_('VIEWPACKAGEDESC');?>
		</th>
		<th>
			<?php echo JText::_('VIEWPACKAGETYPE');?>
		</th>
		<th>
			<?php echo JText::_('VIEWDSADMINZONES');?>
		</th>

		<th>
			<?php echo JText::_('VIEWPACKAGEPUBLISHED');?>
		</th>
		<th width="65">
			<?php echo JText::_('ORDER');?><a class="saveorder" title="Save Order" href="javascript:saveorder(<?php echo $n;?>, 'saveorder')">
</a>
		</th>
		<th>
			<?php echo JText::_('VIEWPACKAGETERMS');?>
		</th>
		<th>
			<?php echo JText::_('VIEWPACKAGEPERIOD');?>
		</th>
		<th>
			<?php echo JText::_('VIEWPACKAGEPRICE');?>
		</th>
		<th>
			<?php echo JText::_('VIEWPACKAGEORDERS');?>
		</th>

	</tr>
</thead>

<tbody>
<?php
    if (!$this->nz) {
        echo "<a href='http://www.ijoomla.com/redirect/adserver/videos/packages.htm' target='_blank'>".JText::_('AD_VIDEO')."</a>";
        echo "&nbsp;&nbsp;<a href='http://www.ijoomla.com/redirect/adserver/videos/packages.htm' target='_blank'><img src='".JURI::base()."components/com_adagency/images/icon_video.gif' alt='watch video' /></a><p />";
    }
?>
<?php
	for ($i = 0; $i < $n; $i++):
		$order =& $this->packages[$i];
		$id = $order->tid;
		$checked = JHTML::_('grid.id', $i, $id);
		$link = JRoute::_("index.php?option=com_adagency&controller=adagencyPackages&task=edit&cid[]=".$id);
		$published = JHTML::_('grid.published', $order, $i );
?>
	<tr class="row<?php echo $k;?>">
	     	<td><?php echo $checked;?></td>
			<td width="5" align="center"><?php echo $id;?></td>
	     	<td><a href="<?php echo $link;?>" ><?php echo $order->description;?></a></td>
	     	<td><?php echo JText::_('ADAG_'.strtoupper($order->type));?></td>
	     	<td><?php
					if(isset($order->location)&&(is_array($order->location))) {
						$cnt = 0;
						foreach($order->location as $element){
							if($cnt >0) { echo ", "; }
							echo "<a href='index.php?option=com_adagency&controller=adagencyZones&task=edit&cid[]=".$element->zone_id."'>".$element->title."</a>";
							$cnt++;
						}
					}
				?>
			</td>
	     	<td><?php echo $published;?></td>
			<td align="center"><input type="text" maxlength="4" size="5" name="pack[<?php echo $id;?>]" value="<?php echo $order->ordering;?>"/></td>
	     	<td><?php if ($order->type!="fr") { echo $order->quantity."&nbsp;"; if ($order->type=="cpm") { echo "Impressions"; } else { echo "Clicks"; } } else { echo "-"; } ?></td>
	     	<td><?php if ($order->type=="fr") { if ($order->validity!="") {
					$validity = explode("|", $order->validity, 2);
					$validity[1] = ($validity[1]=="day") ? "Day(s)" : (($validity[1]=="week") ? "Week(s)" : (($validity[1]=="month") ? "Month(s)" : (($validity[1]=="year") ? "Year(s)" : ""))) ;
					echo $validity[0]." ".$validity[1]; } } else { echo "-"; } ?></td>
	     	<td><?php echo $order->cost."&nbsp;".$configs->currencydef;?></td>
			<td><a href="index.php?option=com_adagency&controller=adagencyPackages&task=edit&cid[]="><?php echo $ordersnr[$order->tid];?></a></td>
	</tr>


<?php
		$k = 1 - $k;
	endfor;
?>
	<tr>
        <td colspan="11">
            <?php if (!$this->nz) { ?>
                <input type="hidden" /><?php echo $this->pagination->getListFooter(); ?>
            <?php
                } else {
            ?>
            <input type="hidden" name="nz" value="<?php echo $this->nz; ?>" />
            <div id="adag-next"><?php echo JText::_('ADAG_NEXT'); ?> >> </div>
            <?php
                }
            ?>

        </td>
    </tr>


</tbody>


</table>

</div>

<input type="hidden" name="option" value="com_adagency" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="controller" value="adagencyPackages" />
</form>
