 <?php
/**
 * @copyright   (C) 2010 iJoomla, Inc. - All rights reserved.
 * @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html)
 * @author  iJoomla.com <webmaster@ijoomla.com>
 * @url   http://www.ijoomla.com/licensing/
 * the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  *are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
 * More info at http://www.ijoomla.com/licensing/
*/
defined ('_JEXEC') or die ("Go away.");
jimport ("joomla.application.component.view");

class adagencyAdminViewadagencyPlugins extends JView {

	function display ($tpl =  null ) {
		JToolBarHelper::title(JText::_('AD_PLUGINS_MANAGERS'), 'generic.png');
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		$plugins =& $this->get('listPlugins');
		$this->assignRef('plugins', $plugins);
		parent::display($tpl);
	}

	function editForm($tpl = null) {
		$db =& JFactory::getDBO();
		$plugin =& $this->get('plugin');
		$plugin_data =& $this->_models['adagencyplugin']->BEPluginHandler();
		$isNew = ($plugin->id < 1);
		$text = $isNew?JText::_('New'):JText::_('Edit');
		JToolBarHelper::title(JText::_('Plugin').":<small>[".$text."]</small>");
		JToolBarHelper::save();
		if ($isNew) {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel ('cancel', 'Close');
		}
		$this->assign("plugin", $plugin);
		$configs =& $this->_models['adagencyconfig']->getConfigs();
		$lists = null;
		$this->assign("configs", $configs);
		$this->assign("lists", $lists);
		$this->assign("plugin_data", $plugin_data);
		parent::display($tpl);
	}
}
?>