<?php
/**
 * sh404SEF support for iJoomla adagency component.
 * Copyright Yannick Gaultier (shumisha) - 2007
 * shumisha@gmail.com
 * @version     $Id: com_adagency.php 866 2009-01-17 14:05:21Z silianacom-svn $
 * {shSourceVersionTag: Version x - 2007-09-20}
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

// ------------------  standard plugin initialize function - don't change ---------------------------
global $sh_LANG;
$sefConfig = & shRouter::shGetConfig();  
$shLangName = '';
$shLangIso = '';
$title = array();
$shItemidString = '';
$dosef = shInitializePlugin( $lang, $shLangName, $shLangIso, $option);
if ($dosef == false) return;
// ------------------  standard plugin initialize function - don't change ---------------------------

// ------------------  load language file - adjust as needed ----------------------------------------
//$shLangIso = shLoadPluginLanguage( 'com_adagency', $shLangIso, '_SH404SEF_IJOOMLA_MAG_SHOW_EDITION');
// ------------------  load language file - adjust as needed ----------------------------------------


if (!empty($option))
  shRemoveFromGETVarsList('option');
if (!empty($lang))
  shRemoveFromGETVarsList('lang');
if (!empty($Itemid))
  shRemoveFromGETVarsList('Itemid');
  
if(!function_exists(adAgencyViewToController)) {
    function adAgencyViewToController($param) {
        if($param == 'adagencycpanel') { return 'adagencyCPanel'; } 
        else { 
            if(strpos(" " . $param, 'adagency')>0) {
                $param = str_replace('adagency', '', $param);
                $param = 'adagency' . ucfirst($param);
            }
            return $param; 
        }
    }
}

// start IJoomla specific stuff
$controller = isset($controller) ? @$controller : null;   
if (!empty($controller)) {
    shRemoveFromGETVarsList('controller');
} elseif (!empty($view)) {
    $controller = adAgencyViewToController($view);
    shRemoveFromGETVarsList('view');
}

$task 		= isset($task) ? @$task : null;
$type 		= isset($type) ? @$type : null;
$cid 		= isset($cid[0]) ? @$cid[0] : null;
$aid 		= isset($aid[0]) ? @$aid[0] : null;
$bid 		= isset($bid[0]) ? @$bid[0] : null;
$tmpl		= isset($tmpl) ? @$tmpl : null;
$no_html	= isset($no_html) ? @$no_html : null;
$Itemid = isset($Itemid) ? @$Itemid : null;
// shumisha : insert magazine name from menu
$shAdagency = shGetComponentPrefix($option);
$shAdagency = empty($shAdagency) ?  getMenuTitle($option, (isset($task) ? @$task : null), $Itemid, '', $shLangName ) : $shAdagency;
$shAdagency = (empty($shAdagency) || $shAdagency == '/') ? 'adAgency' : $shAdagency; // V 1.2.4.t  
switch ($controller)
{
	case 'adagencyAdvertisers':
		$title[]='adagencyAdvertisers';
        if($task == null && isset($layout)) {
            if ($layout == 'editform') {
                $task = 'edit';
            } elseif ($layout == 'overview')  {
                $task = 'overview';
            }
            shRemoveFromGETVarsList('layout');
        }
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if($cid!=null){
			$title[]=$cid;
			shRemoveFromGETVarsList('cid');
		}
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');
		break;
	case 'adagencyCPanel':
		$title[]='adagencyCPanel';
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');
		break;
	case 'adagencyAds':
		$title[]='adagencyAds';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if($type!=null){
			$title[]=$type;
			shRemoveFromGETVarsList('type');
		}
		if(intval($cid)>0){
			$query="select name from #__ad_agency_campaign where id=".intval($cid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$cid."-".$result->name;
			shRemoveFromGETVarsList('cid');
		}
		else shRemoveFromGETVarsList('cid');
		if(intval($aid)>0){
			$query="select name from #__users u left join #__ad_agency_advertis ad on u.id=ad.user_id where ad.aid=".intval($aid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$aid."-".$result->name;
			shRemoveFromGETVarsList('aid');
		}
		else shRemoveFromGETVarsList('aid');
		if(intval($bid)>0){
			$query="select title from #__ad_agency_banners where id=".intval($bid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$bid."-".$result->title;
			shRemoveFromGETVarsList('bid');
		}
		else shRemoveFromGETVarsList('bid');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');
		break;
	case 'adagencyCampaigns':
		$title[]='adagencyCampaigns';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if(intval($cid)>0){
			$query="select name from #__ad_agency_campaign where id=".intval($cid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$cid."-".$result->name;
			shRemoveFromGETVarsList('cid');
		}else shRemoveFromGETVarsList('cid');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');		
		break;
	case 'adagencyReports':
		$title[]='adagencyReports';
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');		
		break;
	case 'adagencyPackages':
		$title[]='adagencyPackages';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		$title[]=$tmpl;
		shRemoveFromGETVarsList('tmpl');
		$title[]=$no_html;
		shRemoveFromGETVarsList('no_html');
		$title[]=$cid;
		shRemoveFromGETVarsList('cid');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');
		break;
	case 'adagencyOrders':
		$title[]='adagencyOrders';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');
		break;
	case 'adagencyTextlink':
		$title[]='adagencyTextlink';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if(intval($cid)>0){
			$query="select title from #__ad_agency_banners where id=".intval($cid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$cid."-".$result->title;
			shRemoveFromGETVarsList('cid');
		}else shRemoveFromGETVarsList('cid[0]');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');
		break;
	case 'adagencyStandard':
		$title[]='adagencyStandard';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if(intval($cid)>0){
			$query="select title from #__ad_agency_banners where id=".intval($cid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$cid."-".$result->title;
			shRemoveFromGETVarsList('cid');
		}else shRemoveFromGETVarsList('cid[0]');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');		
		break;
	case 'adagencyFlash':
		$title[]='adagencyFlash';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if(intval($cid)>0){
			$query="select title from #__ad_agency_banners where id=".intval($cid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$cid."-".$result->title;
			shRemoveFromGETVarsList('cid');
		}else shRemoveFromGETVarsList('cid[0]');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');		
		break;
	case 'adagencyAdcode':
		$title[]='adagencyAdcode';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if(intval($cid)>0){
			$query="select title from #__ad_agency_banners where id=".intval($cid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$cid."-".$result->title;
			shRemoveFromGETVarsList('cid');
		}else shRemoveFromGETVarsList('cid[0]');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');		
		break;
	case 'adagencyFloating':
		$title[]='adagencyFloating';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if(intval($cid)>0){
			$query="select title from #__ad_agency_banners where id=".intval($cid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$cid."-".$result->title;
			shRemoveFromGETVarsList('cid');
		}else shRemoveFromGETVarsList('cid[0]');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');				
		break;
	case 'adagencyPopup':
		$title[]='adagencyPopup';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if(intval($cid)>0){
			$query="select title from #__ad_agency_banners where id=".intval($cid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$cid."-".$result->title;
			shRemoveFromGETVarsList('cid');
		}else shRemoveFromGETVarsList('cid[0]');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');		
		break;
	case 'adagencyTransition':
		$title[]='adagencyTransition';
		$title[]=$task;
		shRemoveFromGETVarsList('task');
		if(intval($cid)>0){
			$query="select title from #__ad_agency_banners where id=".intval($cid);
			$database->setQuery($query);
			$database->query();
			$result=$database->loadObject();
			$title[]=$cid."-".$result->title;
			shRemoveFromGETVarsList('cid');
		}else shRemoveFromGETVarsList('cid[0]');
		if($Itemid != null) {
			$title[]="menu-id-".$Itemid;
		}
		shRemoveFromGETVarsList('Itemid');
		break;
    default:
      $title[] = "adagency";
    break;
}

// ------------------  standard plugin finalize function - don't change ---------------------------  
if ($dosef){
   $string = shFinalizePlugin( $string, $title, $shAppendString, $shItemidString, 
      (isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null), 
      (isset($shLangName) ? @$shLangName : null));
}      
// ------------------  standard plugin finalize function - don't change ---------------------------
	
?>
